//
// explos.h
//

void insert_explosion ( int x, int y, byte type )
{
  ExplAnzahl++;
  if ( ExplAnzahl > 199 ) ExplAnzahl--;
  
  EL[ExplAnzahl].x              = x;
  EL[ExplAnzahl].y              = y;
  EL[ExplAnzahl].type           = type;
  EL[ExplAnzahl].index          = 0;
  if ( type == 1 ) EL[ExplAnzahl].destruction = 5;
  if ( type == 2 ) EL[ExplAnzahl].destruction = 15;
}

void delete_explosion ( BYTE index )
{
  int i;

  for ( i=index; i<ExplAnzahl; i++ ) EL[i] = EL[i+1];     // index korrigieren
  ExplAnzahl--;
}

void compute_explosion ( BYTE index )
{
  int i;

  if ( EL[index].index == 0 )
  {
    for (i=0; i<=MannAnzahl; i++)
    {
      if ( ((ML[i].y<EL[index].y+30)&&(ML[i].y>EL[index].y-30)) && ((ML[i].x<EL[index].x+30)&&(ML[i].x>EL[index].x-30)) )
      {
        ML[i].explose = index+1;
        ML[i].energie -= EL[index].destruction;
      }
    }
    for (i=0; i<=FeindAnzahl; i++)
    {
      if ( ((FL[i].y<EL[index].y+30)&&(FL[i].y>EL[index].y-30)) && ((FL[i].x<EL[index].x+30)&&(FL[i].x>EL[index].x-30)) )
      {
        FL[i].explose = index+1;
        FL[i].energie -= EL[index].destruction;
      }
    }
  }
  if ( EL[index].index >= 9 ) { delete_explosion(index); return; }
  if ( EL[index].type == 1 ) show_explore_1(index);
  if ( EL[index].type == 2 ) show_explore_2(index);
  EL[index].index++;
}


void show_explore_1 ( BYTE index )
{
  int i, j, k;

  k = EL[index].index*806;

  for ( i=0; i<26; i++ )
  {
    for ( j=0; j<31; j++ )
    {
      if ( ((EL[index].x+j)<Mrechts)&&((EL[index].x+j)>Mlinks)&&((EL[index].y+i)>Moben)&&((EL[index].y+i)<Munten) )
      {
       if ( ExploseData[k] != 255 ) vsetpix( EL[index].x+j, EL[index].y+i, ExploseData[k], res_x); 
      }
    k++;
    }
  }

}


void show_explore_2 ( BYTE index )
{
  int i, j, k;

  k = EL[index].index*806;

  for ( i=0; i<26; i++ )
  {
    for ( j=0; j<31; j++ )
    {
      if ( ((EL[index].x+j)<Mrechts)&&((EL[index].x+j)>Mlinks)&&((EL[index].y+i)>Moben)&&((EL[index].y+i)<Munten) )
      {
       if ( ExploseData[k] != 255 ) vsetpix( EL[index].x+j, EL[index].y+i, ExploseData[k], res_x); 
      }
    k++;
    }
  }

}

