//
// explose.h
//

void LoadExplose ( void )
{
  int i;
  short Zeichen=0;
  FILE *Datei;

  ExploseData = (byte *)malloc(10000);

  chdir("RESOURCE");

  if ( (Datei = fopen("explose.rsc", "rb")) == NULL )           
  {
    textmodus();
    printf("\n\nERROR: Kann 'explose.rsc' nicht laden!\n\n");
    exit(0);
  }
  i=0;
  while ((Zeichen = fgetc(Datei)) != EOF) ExploseData[i++] = (byte)Zeichen;
  fclose(Datei);

  chdir("..");
}


void ExploseInsert ( short x, short y, short destruct, short range, byte type )
{
  short i;

  EAnz++;
  if ( EAnz >= EMAX ) { EAnz--; return; }

  memset(&Explose[ExploseNextFree], 0, sizeof(EXPLO));

  Explose[ExploseNextFree].free         = 1;
  Explose[ExploseNextFree].type         = type;
  Explose[ExploseNextFree].x            = x;
  Explose[ExploseNextFree].y            = y;
  Explose[ExploseNextFree].range        = range;
  Explose[ExploseNextFree].destruct     = destruct;
  Explose[ExploseNextFree].index        = 0;

  switch ( type )
  {
    case 1: Explose[ExploseNextFree].frames     = 11;
            Explose[ExploseNextFree].shape_x    = 28;
            Explose[ExploseNextFree].shape_y    = 20;
            Explose[ExploseNextFree].shape_start= 0;
            break;
  }

  for(i=ExploseNextFree; i<EMAX; ++i) if ( !Explose[i].free ) { ExploseNextFree = i; return; }
}


void EDelete ( short index )
{
  EAnz--;
  Explose[index].free = 0;

  if ( index < ExploseNextFree ) ExploseNextFree = index;
}

void ExploseCompute ( short index )
{
  if ( GameDel >= GameSpeed ) Explose[index].index++;
  if ( Explose[index].index > Explose[index].frames ) { EDelete(index); return; }

  ShowExplose(index);
}

void ShowExplose ( short index )
{
  static short i, j, k;

  k = Explose[index].shape_start+(Explose[index].shape_x*Explose[index].shape_y)*Explose[index].index;

  for(i=0; i<Explose[index].shape_y; i++)
  {
    for(j=0; j<Explose[index].shape_x; j++)
    {
      if ( ExploseData[k] != 0 ) ssetpix(Explose[index].x+j, Explose[index].y+i, ExploseData[k]);
      k++;
    }
  }
}
