//
// Init.h
//
#define LOAD_X          270     
#define LOAD_Y          320


void LoadTerrain ( void )
{
  FILE *Datei;
  short Zeichen=0;
  long i=0;

  TerrainData = (byte *)malloc(400000);
  chdir("RESOURCE");

  if ( (Datei = fopen("terrain.rsc", "rb")) == NULL ) { textmodus(); printf("\n\nERROR: Kann 'terrain.rsc' nicht laden!\n\n"); exit(0); }
  while ((Zeichen = fgetc(Datei)) != EOF) TerrainData[i++] = (byte)Zeichen;
  fclose(Datei);

  fclose(Datei);
  chdir("..");
}


void LoadLeute ( void )
{
  FILE *Datei;
  short Zeichen;
  int i=0;

  LeuteData = (byte *)malloc(900000);
  chdir("RESOURCE");

  if ( (Datei = fopen("lsprites.rsc", "rb")) == NULL ) { textmodus(); printf("\n\nERROR: Kann 'lsprites.rsc' nicht laden!\n\n"); exit(0); }
  while ((Zeichen = fgetc(Datei)) != EOF) LeuteData[i++] = (byte)Zeichen;
  fclose(Datei);

  KAMPF_START = i;
  if ( (Datei = fopen("ksprites.rsc", "rb")) == NULL ) { textmodus(); printf("\n\nERROR: Kann 'ksprites.rsc' nicht laden!\n\n"); exit(0); }
  while ((Zeichen = fgetc(Datei)) != EOF) LeuteData[i++] = (byte)Zeichen;
  fclose(Datei);

  HELI_START = i;
  if ( (Datei = fopen("hsprites.rsc", "rb")) == NULL ) { textmodus(); printf("\n\nERROR: Kann 'hsprites.rsc' nicht laden!\n\n"); exit(0); }
  while ((Zeichen = fgetc(Datei)) != EOF) LeuteData[i++] = (byte)Zeichen;
  fclose(Datei);

  chdir("..");
}


void InitSpiel ( void )
{
  short i, j=0;

  LoadFont();
  MouseLoadImages(); 
  LoadTerrain(); LoadLeute(); LoadNum(); 
  LoadMap("demo.mis"); LoadExplose(); LoadRauch();
  DecodeKarte(); 
  InitKarte(); InitXYKarte();
  SetUpData();

  FadeOut();
}


void FreeData ( void )
{
  free(Terrain);                                           // Entkompr. Karte 
  free(TerrainData);                                      // Landschaftsdaten
}


int get_ini_value ( FILE *D )
{
  char ini[5];
  short i= 0;

  memset(ini, 32, 5);
  while ( fgetc(D) != '=' );
  while ( (ini[i++] = fgetc(D)) != ':');
  return atoi(ini); 
}


void LoadNum ( void )
{
  FILE *Datei;

  chdir("RESOURCE");

  if ( (Datei = fopen("mann.num", "rb")) == NULL )
  {
    textmodus();
    printf("\n\nERROR: Kann 'mann.num' nicht laden!\n\n");
    exit(0);
  }
//----------------------L_ANFANG ---------------------------------------------
   L_ANFANG = get_ini_value(Datei);
   L_LANG   = get_ini_value(Datei);
//----------------------R_ANFANG ---------------------------------------------
   R_ANFANG = get_ini_value(Datei);
   R_LANG   = get_ini_value(Datei);
//----------------------O_ANFANG ---------------------------------------------
   O_ANFANG = get_ini_value(Datei);
   O_LANG   = get_ini_value(Datei);
//----------------------U_ANFANG ---------------------------------------------
   U_ANFANG = get_ini_value(Datei);
   U_LANG   = get_ini_value(Datei);
//----------------------LO_ANFANG ---------------------------------------------
   LO_ANFANG = get_ini_value(Datei);
   LO_LANG   = get_ini_value(Datei);
//----------------------LU_ANFANG ---------------------------------------------
   LU_ANFANG = get_ini_value(Datei);
   LU_LANG   = get_ini_value(Datei);
//----------------------RO_ANFANG ---------------------------------------------
   RO_ANFANG = get_ini_value(Datei);
   RO_LANG   = get_ini_value(Datei);
//----------------------RU_ANFANG ---------------------------------------------
   RU_ANFANG = get_ini_value(Datei);
   RU_LANG   = get_ini_value(Datei);


//----------------------MANN_DIV ---------------------------------------------
   MANN_DIV = get_ini_value(Datei);

//----------------------ANGRIF_L ---------------------------------------------
  ANGRIF_L  = get_ini_value(Datei);
  ANGRIF_LL = get_ini_value(Datei);
//----------------------ANGRIF_R ---------------------------------------------
  ANGRIF_R  = get_ini_value(Datei);
  ANGRIF_RL = get_ini_value(Datei);
//----------------------ANGRIF_O ---------------------------------------------
  ANGRIF_O  = get_ini_value(Datei);
  ANGRIF_OL = get_ini_value(Datei);
//----------------------ANGRIF_U ---------------------------------------------
  ANGRIF_U  = get_ini_value(Datei);
  ANGRIF_UL = get_ini_value(Datei);
//----------------------ANGRIF_LO ---------------------------------------------
  ANGRIF_LO  = get_ini_value(Datei);
  ANGRIF_LOL = get_ini_value(Datei);
//----------------------ANGRIF_LU ---------------------------------------------
  ANGRIF_LU  = get_ini_value(Datei);
  ANGRIF_LUL = get_ini_value(Datei);
//----------------------ANGRIF_RO ---------------------------------------------
  ANGRIF_RO  = get_ini_value(Datei);
  ANGRIF_ROL = get_ini_value(Datei);
//----------------------ANGRIF_RU ---------------------------------------------
  ANGRIF_RU  = get_ini_value(Datei);
  ANGRIF_RUL = get_ini_value(Datei);
//----------------------FL_ANFANG ---------------------------------------------
  FL_ANFANG  = get_ini_value(Datei);
//----------------------FR_ANFANG ---------------------------------------------
  FR_ANFANG  = get_ini_value(Datei);
//----------------------FO_ANFANG ---------------------------------------------
  FO_ANFANG  = get_ini_value(Datei);
//----------------------FU_ANFANG ---------------------------------------------
  FU_ANFANG  = get_ini_value(Datei);

//----------------------S1_ANFANG ---------------------------------------------
  S1_ANFANG  = get_ini_value(Datei);
//----------------------S1_LANG-----------------------------------------------
  S1_LANG    = get_ini_value(Datei);
//----------------------S2_ANFANG ---------------------------------------------
  S2_ANFANG  = get_ini_value(Datei);
//----------------------S2_LANG-----------------------------------------------
  S2_LANG    = get_ini_value(Datei);


  fclose(Datei);

  chdir("..");
}

