//
// Init.h
//
void LoadTerrain ( void )
{
  FILE *Datei, *Data;
  char puffer[14], anzahl=0, h, j=0;
  short Zeichen;
  long i=0;

  TerrainData = (byte *)malloc(305000);
  chdir("RESOURCE");

  if ( (Datei = fopen("terrain.num", "rb")) == NULL ) { textmodus(); printf("\n\nERROR: Kann 'terrain.num' nicht laden!\n\n"); exit(0); }
  anzahl = get_ini_value(Datei); 

  for (h=0; h<anzahl; h++ )
  {
    memset(&puffer[1], 0, 13); while ( fgetc(Datei) != '=' );
    while ( (puffer[j++] = fgetc(Datei)) != ':');  puffer[--j] = 0x00; j = 0;

    if ( (Data = fopen(puffer, "rb")) == NULL ) { textmodus(); printf("\n\nERROR: Kann '%s' nicht laden!\n\n", puffer); exit(0); }
    while ((Zeichen = fgetc(Data)) != EOF) TerrainData[i++] = (byte)Zeichen;
    fclose(Data);
  }

  fclose(Datei);
  chdir("..");
}


void LoadLeute ( void )
{
  FILE *Datei;
  short Zeichen;
  int i=0;

  LeuteData = (byte *)malloc(410000);
  chdir("RESOURCE");

  if ( (Datei = fopen("lsprites.rsc", "rb")) == NULL ) { textmodus(); printf("\n\nERROR: Kann 'lsprites.rsc' nicht laden!\n\n"); exit(0); }

  while ((Zeichen = fgetc(Datei)) != EOF) LeuteData[i++] = (byte)Zeichen;
  fclose(Datei);

  chdir("..");
}


void InitSpiel ( void )
{
  MouseLoadImages();
  LoadTerrain(); LoadLeute();
  chdir("DATA"); ShowPalette("intfc-05.xgf"); chdir("..");
  SetOverscanColor(0);
}

int get_ini_value ( FILE *D )
{
  char ini[5];
  int i= 0;

  memset(ini, 32, 5);
  while ( fgetc(D) != '=' );
  while ( (ini[i++] = fgetc(D)) != ':');
  return atoi(ini); 
}


void FreeData ( void )
{
  free(Terrain);                                           // Entkompr. Karte 
  free(TerrainData);                                      // Landschaftsdaten
}
