//
// leute.h
//

void MInsert ( short ax, short ay, short dx, short dy, byte type )
{
  short i;


  MAnz++;
  if ( MAnz >= LMAX/2 ) { MAnz--; return; }

  Leute[NextFree].ax            = ax;
  Leute[NextFree].ay            = ay;
  Leute[NextFree].dx            = dx;
  Leute[NextFree].dy            = dy;
  Leute[NextFree].x             = ax-ScrollX;
  Leute[NextFree].y             = ay-ScrollY;
  Leute[NextFree].type          = type;
  Leute[NextFree].free          = 1;
  Leute[NextFree].feind         = 0;
  Leute[NextFree].energie       = 15;
  Leute[NextFree].shape         = type*400;

  switch ( type )
  {
    case 1: Leute[NextFree].shapeX = 20;
            Leute[NextFree].shapeY = 20;
            break;

    default: Leute[NextFree].shapeX = 20;
             Leute[NextFree].shapeY = 20;
             break;
  }

  for(i=NextFree; i<LMAX; ++i) if ( !Leute[i].free ) { NextFree = i; return; }
}


void MDelete ( short index )
{
  MAnz--;

  Leute[index].free             = 0;

  if ( index < NextFree ) NextFree = index;
}


void FInsert ( short ax, short ay, short dx, short dy, byte type )
{
  short i;

  FAnz++;
  if ( FAnz >= LMAX/2 ) { FAnz--; return; }

  Leute[NextFree].ax            = ax;
  Leute[NextFree].ay            = ay;
  Leute[NextFree].dx            = dx;
  Leute[NextFree].dy            = dy;
  Leute[NextFree].x             = ax-ScrollX;
  Leute[NextFree].y             = ay-ScrollY;
  Leute[NextFree].type          = type;
  Leute[NextFree].free          = 1;
  Leute[NextFree].feind         = 1;
  Leute[NextFree].shape         = type*400;

  switch ( type )
  {
    case 1: Leute[NextFree].shapeX = 20;
            Leute[NextFree].shapeY = 20;
            break;
  }

  for(i=NextFree; i<LMAX; ++i) if ( !Leute[i].free ) { NextFree = i; return; }
}


void FDelete ( short index )
{
  MAnz--;

  Leute[index].free             = 0;

  if ( index < NextFree ) NextFree = index;
}

void MSet ( short index )
{
  int i, j, farbe =0;
  int k=Leute[index].shape*(Leute[index].shapeX*Leute[index].shapeY);
  byte puffer;
               
  for ( i=0; i<Leute[index].shapeY; i++ )
  {
    for ( j=0; j<Leute[index].shapeX; j++ )
    {
      if ( ((Leute[index].x+j)<Mrechts)&&((Leute[index].x+j)>Mlinks)&&((Leute[index].y+i)>Moben)&&((Leute[index].y+i)<Munten) )
      {
        if ( LeuteData[k] != 3 )
        {
          puffer = getpix( Leute[index].x+j, Leute[index].y+i);
          if ( puffer < 164 )
          {
            if ( (LeuteData[k] == 0)||(LeuteData[k] == 255) ) setpix( Leute[index].x+j, Leute[index].y+i, farbe);
            else setpix( Leute[index].x+j, Leute[index].y+i, LeuteData[k]);
          }
        }
      }
      k++;
    }
  }
}

void MSetAkt ( short index )
{
  short i, j, farbe =0;
  int k=Leute[index].shape*(Leute[index].shapeX*Leute[index].shapeY);
  byte puffer;
               
  for ( i=0; i<Leute[index].shapeY; i++ )
  {
    for ( j=0; j<Leute[index].shapeX; j++ )
    {
      if ( ((Leute[index].x+j)<Mrechts)&&((Leute[index].x+j)>Mlinks)&&((Leute[index].y+i)>Moben)&&((Leute[index].y+i)<Munten) )
      {
        if ( LeuteData[k] != 3 )
        {
          puffer = getpix( Leute[index].x+j, Leute[index].y+i);
          if ( puffer < 164 )
          {
            if ( (LeuteData[k] == 0)||(LeuteData[k] == 255) ) setpix( Leute[index].x+j, Leute[index].y+i, farbe);
            else setpix( Leute[index].x+j, Leute[index].y+i, LeuteData[k]);
          }
        }
      }
      k++;
    }
  }

  i = Leute[index].shapeX/2; j = Leute[index].shapeX/4;
  if ( Leute[index].energie <= 0 ) puffer = 1;
  else puffer = (Leute[index].energie*i)/20;


  ssetpix(Leute[index].x+j-1, Leute[index].y+1,   ROT_DUNKEL);
  ssetpix(Leute[index].x+j-1, Leute[index].y+2,   ROT_DUNKEL);
  for(k=Leute[index].x+j-1; k<Leute[index].x+j+i+1; k++)
  {
    ssetpix(k, Leute[index].y,   BLAU_DUNKEL);
    ssetpix(k, Leute[index].y+3, BLAU_DUNKEL);
  }
  ssetpix(k-1, Leute[index].y+1,   ROT_DUNKEL);
  ssetpix(k-1, Leute[index].y+2,   ROT_DUNKEL);

  for(k=Leute[index].x+j; k<Leute[index].x+j+puffer; k++)
  {
    ssetpix(k, Leute[index].y+1, GELB_HELL);
    ssetpix(k, Leute[index].y+2, GELB_HELL); 
  }



}




void MVerhalten ( short index )
{
  byte rechts=0, links=0;
  byte schritt=1;

  if ( (Leute[index].ax == Leute[index].dx)&&(Leute[index].ay == Leute[index].dy) )
  {
    if ( Leute[index].dcount < Leute[index].dmax )
    {
      Leute[index].dx = Leute[index].d[Leute[index].dcount].x;
      Leute[index].dy = Leute[index].d[Leute[index].dcount++].y;
    }
    else
    {
      Leute[index].shape = R_ANFANG+(MANN_DIV*Leute[index].type);
      return;
    }
  }

//------------------------------ Nach RECHTS ---------------------------------------------------------------------
    if ( Leute[index].ax < Leute[index].dx )
    {
      Leute[index].ax+=schritt; Leute[index].x+=schritt;
      if ( (Leute[index].shape<R_ANFANG+((MANN_DIV*Leute[index].type)))&&((!(Leute[index].ay>Leute[index].dy)) &&(!(Leute[index].ay<Leute[index].dy))) ) Leute[index].shape = R_ANFANG+((MANN_DIV*Leute[index].type));
      if ( (Leute[index].shape>R_ANFANG+((MANN_DIV*Leute[index].type))+R_LANG)&&((!(Leute[index].ay>Leute[index].dy)) &&(!(Leute[index].ay<Leute[index].dy))) ) Leute[index].shape = R_ANFANG+((MANN_DIV*Leute[index].type));
      Leute[index].shape++; rechts= 1; 
    }
//------------------------------ Nach LINKS ---------------------------------
    if ( Leute[index].ax > Leute[index].dx )
    {
      Leute[index].ax-=schritt; Leute[index].x-=schritt;
      if ( (Leute[index].shape>L_ANFANG+((MANN_DIV*Leute[index].type))+L_LANG)&&((!(Leute[index].ay>Leute[index].dy)) &&(!(Leute[index].ay<Leute[index].dy))) ) Leute[index].shape = L_ANFANG+((MANN_DIV*Leute[index].type));
      Leute[index].shape++; links= 1; 
    }
//------------------------------ Nach UNTEN ---------------------------------
    if ( Leute[index].ay < Leute[index].dy )
    {
      Leute[index].ay+=schritt; Leute[index].y+=schritt;
      if ( links )
      {
        if ( Leute[index].shape < LU_ANFANG+((MANN_DIV*Leute[index].type)) ) Leute[index].shape = LU_ANFANG+((MANN_DIV*Leute[index].type))+1;
        if ( Leute[index].shape > LU_ANFANG+((MANN_DIV*Leute[index].type))+LU_LANG ) Leute[index].shape = LU_ANFANG+((MANN_DIV*Leute[index].type))+1;
      }
      if ( rechts )
      {
        if ( Leute[index].shape < RU_ANFANG+((MANN_DIV*Leute[index].type)) ) Leute[index].shape = RU_ANFANG+((MANN_DIV*Leute[index].type))+1;
        if ( Leute[index].shape > RU_ANFANG+((MANN_DIV*Leute[index].type))+RU_LANG ) Leute[index].shape = RU_ANFANG+((MANN_DIV*Leute[index].type))+1;
      }
      if ( (!rechts)&&(!links) )
      {
        if ( Leute[index].shape < U_ANFANG+((MANN_DIV*Leute[index].type)) ) Leute[index].shape = U_ANFANG+((MANN_DIV*Leute[index].type));
        if ( Leute[index].shape > U_ANFANG+((MANN_DIV*Leute[index].type))+U_LANG ) Leute[index].shape = U_ANFANG+((MANN_DIV*Leute[index].type));
        Leute[index].shape++;
      }
      
    }
//------------------------------ Nach OBEN ----------------------------------
    if ( Leute[index].ay > Leute[index].dy )
    {
      Leute[index].ay-=schritt; Leute[index].y-=schritt;
      if ( links )
      {
        if ( Leute[index].shape < LO_ANFANG+((MANN_DIV*Leute[index].type)) ) Leute[index].shape = LO_ANFANG+((MANN_DIV*Leute[index].type))+1;
        if ( Leute[index].shape > LO_ANFANG+((MANN_DIV*Leute[index].type))+LO_LANG ) Leute[index].shape = LO_ANFANG+((MANN_DIV*Leute[index].type))+1;
      }
      if ( rechts )
      {
        if ( Leute[index].shape < RO_ANFANG+((MANN_DIV*Leute[index].type)) ) Leute[index].shape = RO_ANFANG+((MANN_DIV*Leute[index].type))+1;
        if ( Leute[index].shape > RO_ANFANG+((MANN_DIV*Leute[index].type))+RO_LANG ) Leute[index].shape = RO_ANFANG+((MANN_DIV*Leute[index].type))+1;
      }
      if ( (!rechts)&&(!links) )
      {
        if ( Leute[index].shape < O_ANFANG+((MANN_DIV*Leute[index].type)) ) Leute[index].shape = O_ANFANG+((MANN_DIV*Leute[index].type));
        if ( Leute[index].shape > O_ANFANG+((MANN_DIV*Leute[index].type))+O_LANG ) Leute[index].shape = O_ANFANG+((MANN_DIV*Leute[index].type));
        Leute[index].shape++;
      }
      
    }
}
