//
// mann1.h
//

#define WASSER  650

void Mann1_compute ( BYTE index )
{
  int i, j;
  BYTE dist, schritt=1;
  BYTE links=0, rechts=0;

  MLi.del = 0;

////-- Mann ist durch die Explosion weggeschleudert worden, und steht nun
  //-- wieder normal, da. --//
  if ( MLi.explose == 255 )
  {
    MLi.explose = 0;
    MLi.dx = MLi.d[19].x;
    MLi.dy = MLi.d[19].y;
    MLi.shape = U_ANFANG+((MANN_DIV*3));
    return;
  }
  if ( MLi.explose == 254 ) goto explosion; 


////-- Mann ist von einer Explosion erwischt worden --//
  if ( MLi.explose > 0 )
  {
    MLi.d[19].x = MLi.dx; MLi.d[19].y = MLi.dy; // alte Koordinaten werden gesichert
    MLi.explose = 254; goto explosion;          // Mann wird vorbereitet
  }

////-- Ich glaub ich bin im Himmel, der Mann ist tod --//
  if ( MLi.energie <= 0 )
  {
     MF[MLi.feldy][MLi.feldx] = 0;               // Mann aus MannFeld lschen
     for(i=0; i<=FeindAnzahl; i++) if ( FL[i].attack == index ) { FL[i].attack = 255; FL[i].fire = 0; }
     insert_explosion(MLi.x-5, MLi.y-5, 1); // Durch das Ableben gibts eine Explosion
     MannDelete(index);                         // Mann aus MannListe lschen
     return;
  }
  
////-- Bin ich gerade in einem Spezial-Move --//
  if ( MLi.go == 1 ) goto spezial;


////-- Greife ich gerade an --//
  if ( MLi.attack < 255 )
  {
     if ( MLi.feldx < FL[MLi.attack].feldx ) dist = FL[MLi.attack].feldx-MLi.feldx;
     else dist = MLi.feldx-FL[MLi.attack].feldx;

     if ( MLi.feldy < FL[MLi.attack].feldy ) dist += FL[MLi.attack].feldy-MLi.feldy;
     else dist += MLi.feldy-FL[MLi.attack].feldy;

//   //-- Ist der Mann in Schureichweite --//
     if ( dist <= Data[MLi.type].weapon_reach+MLi.status )
     {
//     //-- Nach Rechts schieen --//
       if ( FL[MLi.attack].ax > MLi.ax )               // Feind weiter rechts
       {
         if ( FL[MLi.attack].ay > MLi.ay+1 )                  // Rechts unten
         {  
           if ( MLi.shape < ANGRIF_RU+((MANN_DIV*3)) ) MLi.shape = ANGRIF_RU+((MANN_DIV*3));
           if ( MLi.shape > ANGRIF_RU+ANGRIF_RUL+((MANN_DIV*3)) ) MLi.shape = ANGRIF_RU+((MANN_DIV*3));
           MLi.fire = 1; MLi.shape++; goto atack;
         }
         if ( FL[MLi.attack].ay < MLi.ay+1 ) // Rechts oben
         {
           if ( MLi.shape < ANGRIF_RO+((MANN_DIV*3)) ) MLi.shape = ANGRIF_RO+((MANN_DIV*3));
           if ( MLi.shape > ANGRIF_RO+ANGRIF_ROL+((MANN_DIV*3)) ) MLi.shape = ANGRIF_RO+((MANN_DIV*3));
           MLi.fire = 1; MLi.shape++; goto atack;
         }
         if ( MLi.shape < ANGRIF_R+((MANN_DIV*3)) ) MLi.shape = ANGRIF_R+((MANN_DIV*3));
         if ( MLi.shape > ANGRIF_R+ANGRIF_RL+((MANN_DIV*3)) ) MLi.shape = ANGRIF_R+((MANN_DIV*3));
         MLi.fire = 1; MLi.shape++; goto atack;
       }
//     //-- Nach Links schieen --//
       if ( FL[MLi.attack].ax < MLi.ax )     // Nach Links
       {
         if ( FL[MLi.attack].ay > MLi.ay+1 ) // Links unten
         {
           if ( MLi.shape < ANGRIF_LU+((MANN_DIV*3)) ) MLi.shape = ANGRIF_LU+((MANN_DIV*3));
           if ( MLi.shape > ANGRIF_LU+ANGRIF_LUL+((MANN_DIV*3)) ) MLi.shape = ANGRIF_LU+((MANN_DIV*3));
           MLi.fire = 1; MLi.shape++; goto atack;
         }
         if ( FL[MLi.attack].ay < MLi.ay+1 ) // Links oben
         {
           if ( MLi.shape < ANGRIF_LO+((MANN_DIV*3)) ) MLi.shape = ANGRIF_LO+((MANN_DIV*3));
           if ( MLi.shape > ANGRIF_LO+ANGRIF_ROL+((MANN_DIV*3)) ) MLi.shape = ANGRIF_LO+((MANN_DIV*3));
           MLi.fire = 1; MLi.shape++; goto atack;
         }
         if ( MLi.shape < ANGRIF_L+((MANN_DIV*3)) ) MLi.shape = ANGRIF_L+((MANN_DIV*3));
         if ( MLi.shape > ANGRIF_L+ANGRIF_LL+((MANN_DIV*3)) ) MLi.shape = ANGRIF_L+((MANN_DIV*3));
         MLi.fire = 1; MLi.shape++; goto atack;
       }  
//     //-- Nach Oben schieen --//
       if ( FL[MLi.attack].ay > MLi.ay )
       {
         if ( MLi.shape < ANGRIF_U+((MANN_DIV*3)) ) MLi.shape = ANGRIF_U+((MANN_DIV*3));
         if ( MLi.shape > ANGRIF_U+ANGRIF_UL+((MANN_DIV*3)) ) MLi.shape = ANGRIF_U+((MANN_DIV*3));
         MLi.fire = 1; MLi.shape++; goto atack;
       }
//     //-- Nach Unten schieen --//
       if ( FL[MLi.attack].ay <= MLi.ay )
       {
         if ( MLi.shape < ANGRIF_O+((MANN_DIV*3)) ) MLi.shape = ANGRIF_O+((MANN_DIV*3));
         if ( MLi.shape > ANGRIF_O+ANGRIF_OL+((MANN_DIV*3)) ) MLi.shape = ANGRIF_O+((MANN_DIV*3));
         MLi.fire = 1; MLi.shape++; goto atack;
       }
     
atack:
       h = rand() % (Data[MLi.type].hit_security-MLi.status);   // Trifft er?
       if ( MLi.status == 2 ) h = 1;// Wenn er der Beste ist trifft er sicher
       if ( h == 1 )
       {
         FL[MLi.attack].hit = 1;// Feind wird benachrichtigt, da er getroffen wurde
         if ( FL[MLi.attack].energie <= 1 )     // Habe ich den Feind gettet?
         {
           j = MLi.attack;
           MLi.kills++; FL[MLi.attack].atkanz=0; FL[j].energie = -1;
           for(i=0; i<=MannAnzahl; i++) if ( ML[i].attack == j ) ML[i].attack = 255;
         }
         FL[MLi.attack].energie-=Data[MLi.type].weapon_destruct;
       }
       return;
     } // if in Reichweite
  }


  if ( MLi.stop == 2 ) goto rest;
  if ( (MLi.ax==MLi.dx)&&(MLi.ay==MLi.dy) ) goto rest;
//------------------------------ Nach RECHTS ---------------------------------------------------------------------
    if ( MLi.ax < MLi.dx )
    {
      MLi.ax+=schritt; MLi.x+=schritt;
      if ( (MLi.shape<R_ANFANG+((MANN_DIV*3)))&&((!(MLi.ay>MLi.dy)) &&(!(MLi.ay<MLi.dy))) ) MLi.shape = R_ANFANG+((MANN_DIV*3));
      if ( (MLi.shape>R_ANFANG+((MANN_DIV*3))+R_LANG)&&((!(MLi.ay>MLi.dy)) &&(!(MLi.ay<MLi.dy))) ) MLi.shape = R_ANFANG+((MANN_DIV*3));
      MLi.shape++; rechts= 1; 
    }
//------------------------------ Nach LINKS ---------------------------------
    if ( MLi.ax > MLi.dx )
    {
      MLi.ax-=schritt; MLi.x-=schritt;
      if ( (MLi.shape>L_ANFANG+((MANN_DIV*3))+L_LANG)&&((!(MLi.ay>MLi.dy)) &&(!(MLi.ay<MLi.dy))) ) MLi.shape = L_ANFANG+((MANN_DIV*3));
      MLi.shape++; links= 1; 
    }
//------------------------------ Nach UNTEN ---------------------------------
    if ( MLi.ay < MLi.dy )
    {
      MLi.ay+=schritt; MLi.y+=schritt;
      if ( links )
      {
        if ( MLi.shape < LU_ANFANG+((MANN_DIV*3)) ) MLi.shape = LU_ANFANG+((MANN_DIV*3))+1;
        if ( MLi.shape > LU_ANFANG+((MANN_DIV*3))+LU_LANG ) MLi.shape = LU_ANFANG+((MANN_DIV*3))+1;
      }
      if ( rechts )
      {
        if ( MLi.shape < RU_ANFANG+((MANN_DIV*3)) ) MLi.shape = RU_ANFANG+((MANN_DIV*3))+1;
        if ( MLi.shape > RU_ANFANG+((MANN_DIV*3))+RU_LANG ) MLi.shape = RU_ANFANG+((MANN_DIV*3))+1;
      }
      if ( (!rechts)&&(!links) )
      {
        if ( MLi.shape < U_ANFANG+((MANN_DIV*3)) ) MLi.shape = U_ANFANG+((MANN_DIV*3));
        if ( MLi.shape > U_ANFANG+((MANN_DIV*3))+U_LANG ) MLi.shape = U_ANFANG+((MANN_DIV*3));
        MLi.shape++;
      }
      
    }
//------------------------------ Nach OBEN ----------------------------------
    if ( MLi.ay > MLi.dy )
    {
      MLi.ay-=schritt; MLi.y-=schritt;
      if ( links )
      {
        if ( MLi.shape < LO_ANFANG+((MANN_DIV*3)) ) MLi.shape = LO_ANFANG+((MANN_DIV*3))+1;
        if ( MLi.shape > LO_ANFANG+((MANN_DIV*3))+LO_LANG ) MLi.shape = LO_ANFANG+((MANN_DIV*3))+1;
      }
      if ( rechts )
      {
        if ( MLi.shape < RO_ANFANG+((MANN_DIV*3)) ) MLi.shape = RO_ANFANG+((MANN_DIV*3))+1;
        if ( MLi.shape > RO_ANFANG+((MANN_DIV*3))+RO_LANG ) MLi.shape = RO_ANFANG+((MANN_DIV*3))+1;
      }
      if ( (!rechts)&&(!links) )
      {
        if ( MLi.shape < O_ANFANG+((MANN_DIV*3)) ) MLi.shape = O_ANFANG+((MANN_DIV*3));
        if ( MLi.shape > O_ANFANG+((MANN_DIV*3))+O_LANG ) MLi.shape = O_ANFANG+((MANN_DIV*3));
        MLi.shape++;
      }
      
    }
//---------------------------- Sonstiges ------------------------------------


spezial:
    if ( MLi.go == 1 )
    {
      if ( MLi.shape == M1S1_A+M1S1_L ) MLi.go = 0; 
      else MLi.shape++;
    }
    goto rest;

explosion:
    if ( MLi.expl_count < 2 )
    {
      if ( EL[MLi.explose-1].y <  MLi.y ) { MLi.ay += 4; MLi.y += 4; MLi.shape = FU_ANFANG+((MANN_DIV*3)); goto x_dir; }
      if ( EL[MLi.explose-1].y >= MLi.y ) { MLi.ay -= 4; MLi.y -= 4; MLi.shape = FO_ANFANG+((MANN_DIV*3)); }
x_dir:
      if ( EL[MLi.explose-1].x <  MLi.x ) { MLi.ax += 4; MLi.x += 4; MLi.shape = FR_ANFANG+((MANN_DIV*3)); goto x_dir_end; }
      if ( EL[MLi.explose-1].x >= MLi.x ) { MLi.ax -= 4; MLi.x -= 4; MLi.shape = FL_ANFANG+((MANN_DIV*3)); }
x_dir_end:
      MLi.expl_count++;
    }
    if ( MLi.expl_count >= 2 ) { MLi.shape++; MLi.expl_count++; }
    if ( MLi.expl_count >  5 ) { MLi.expl_count = 0; MLi.explose = 255; }



rest:
  if ( (MLi.ax==MLi.dx)&&(MLi.ay==MLi.dy) )
  {
    if ( MLi.shape<R_ANFANG+((MANN_DIV*3)) ) MLi.shape=L_ANFANG+((MANN_DIV*3));
    if ( MLi.shape>R_ANFANG+((MANN_DIV*3)) ) MLi.shape=R_ANFANG+((MANN_DIV*3));
    i = rand() % 300;                          // Mann bewegt sich ein bichen
    if ( (i == 10)&&(MLi.go == 0) ) { MLi.go = 1; MLi.shape = M1S1_A; }
    if ( (i == 20)&&(MLi.go == 0) ) MLi.shape=L_ANFANG+((MANN_DIV*3));
    if ( (i == 30)&&(MLi.go == 0) ) MLi.shape=R_ANFANG+((MANN_DIV*3));
    if ( (i == 40)&&(MLi.go == 0) ) MLi.shape=O_ANFANG+((MANN_DIV*3));
    if ( (i == 50)&&(MLi.go == 0) ) MLi.shape=U_ANFANG+((MANN_DIV*3));
    MLi.go = 0;
  }
//============================================================================

//----------------------- Kommt immer dran -----------------------------------

}






void Mann_KI ( BYTE index )
{
  int i, j;
  BYTE see;

//  //-- Ins MannFeld eintragen --//
    MF[MLi.feldy][MLi.feldx] = index+1;

//  //-- Kann es sein, da ich schon besser geworden bin? --//
    if ( (MLi.kills == 1)&&(MLi.status == 0) ) MLi.status = 1; 
    if ( (MLi.kills == 2)&&(MLi.status == 1) ) MLi.status = 2; 


//  //-- Steh ich da auf einem Mann? --//
    if ( (MLi.dx == MLi.ax)&&(MLi.dy == MLi.ay) )
    {
      for(i=index+1; i<=MannAnzahl; i++)
      {
        if ( (ML[i].feldx == MLi.feldx)&&(ML[i].feldy == MLi.feldy) )
        {
          if ( (ML[i].ax != ML[i].dx)||(ML[i].ay != ML[i].dy) ) MLi.stop = 2;
          else                                // ich warte, oder gehe vorbeit
          {
            if ( MF[MLi.feldy][MLi.feldx+1] == 0 ) { MLi.dx+=10; return; }
            if ( MF[MLi.feldy][MLi.feldx-1] == 0 ) { MLi.dx-=10; return; }
            if ( MF[MLi.feldy+1][MLi.feldx] == 0 ) { MLi.dy+=10; return; }
            if ( MF[MLi.feldy-1][MLi.feldx] == 0 ) { MLi.dy-=10; return; }
          }
        }                                                                     
        MLi.stop = 1;
      }
    }
//  //-- Habe ich eine Fabrik eingenommen --//
    for (i=0; i<=fbcount; i++)
    {
      if ( (MLi.feldx == FB[i].x-1)&&(MLi.feldy == FB[i].y+1)&&(FB[i].owner!=1) ) { FB[i].owner = 1; return; }
      if ( (MLi.feldx == FB[i].x  )&&(MLi.feldy == FB[i].y+1)&&(FB[i].owner!=1) ) { FB[i].owner = 1; return; }
      if ( (MLi.feldx == FB[i].x+1)&&(MLi.feldy == FB[i].y+1)&&(FB[i].owner!=1) ) { FB[i].owner = 1; return; }
    }


//  //-- Ist ein Feind in Sichtweite --//
    if ( (MLi.attack == 255) )
    {
      see = (Data[MLi.type].see_reach+MLi.status)*20;

      for(i=0; i<=FeindAnzahl; i++)
      {
        if ( ((FL[i].ax<=MLi.ax+see)&&(FL[i].ax>=MLi.ax-see))&&((FL[i].ay<=MLi.ay+see)&&(FL[i].ay>=MLi.ay-see)) )
        {
          MLi.attack = i; FL[i].atkanz++;
          break;
        }
      }
    }

//  //-- Alte MannFeld-Position ev. lschen --//
    if ( MLi.feldx != MLi.ax/Teilung )              // alte X-Pos. im Feld lschen
    {
       MannFeld[MLi.feldy][MLi.feldx] = 0;
       MLi.feldx = MLi.ax/Teilung;
    }
    if ( MLi.feldy != MLi.ay/Teilung )              // alte Y-Pos. im Feld lschen
    {
       MannFeld[MLi.feldy][MLi.feldx] = 0;
       MLi.feldy = MLi.ay/Teilung;
    }
}







void Mann1_Fire ( BYTE index )
{
  int x=(FL[MLi.attack].x+rand()%20), y=(FL[MLi.attack].y+rand()%20);

  if ( (x<Mrechts)&&(x>Mlinks)&&(y<Munten)&&(y>Moben) ) vsetpix(x, y, 201, res_x); x--; y++; //braun oben
  if ( (x<Mrechts)&&(x>Mlinks)&&(y<Munten)&&(y>Moben) ) vsetpix(x, y, 103, res_x); x++;
  if ( (x<Mrechts)&&(x>Mlinks)&&(y<Munten)&&(y>Moben) ) vsetpix(x, y,  97, res_x); x++;
  if ( (x<Mrechts)&&(x>Mlinks)&&(y<Munten)&&(y>Moben) ) vsetpix(x, y, 103, res_x); x-=4; y++;

  MLi.fire = 0;
}


