//
//  Defkon.h
//
#include "data.h"

#define MANN_SIZE       31
#define STRG            36
#define ML              MannListe
#define FL              FeindListe
#define EL              ExplListe
#define RL              RocketListe
#define MF              MannFeld
#define Hindernis       18
#define Fabrik          64;
#define MHaupt          59;
#define FHaupt          58;
#define MLi             ML[index]
#define FLi             FL[index]
#define RLi             RL[index]
#define Teilung         20

#define FAHNEN          24
#define FAHNEN_L        3
#define STROEMUNG1      658
#define STROEMUNG1_L    13
#define STROEMUNG2      672
#define STROEMUNG2_L    11


typedef struct fbxy
{
        int  x, y;
        long time;
        BYTE owner;
        BYTE inrange;
        BYTE type;
} FBXY;


extern play_digital ( BYTE *puffer, long len, int prio );

char Mann_Msg[30][20] =
{
  "      Roboter      \0",
  "  Schon Unterwegs  \0", "    Breche auf     \0", " Ich gehe ja schon \0", "   Und auf gehts   \0",
  "     Greife an     \0", "Hasta la vista baby\0", "Ich mache ihn kalt \0", "  Auf Wiedersehen  \0",
  " Neuer Robo gebaut \0", "  Wir habe Zuwachs \0", "Einheit hergestellt\0", "    Verstrkung    \0",
  "      Ahhhhh       \0",
  "       Cool        \0", "   Toller Schuss   \0", "Dummer Blechtrottel\0", "   Der war einmal  \0", 
  "       Hilfe       \0", "      S O S        \0", "       Gnade       \0",
};

long AP_ANFANG, APF_ANFANG;


BYTE LandData[500000], MannData[800000];
BYTE ExploseData[82000], RauchData[785*2];
BYTE IntfcData[100000], intfc_count=0;
int  Feld[100][100];
int  MannFeld[100][100]; 
BYTE AktListe[200]; 
MANN MannListe[200], FeindListe[200];
EXPLOSION ExplListe[200];
long EXPL1_END, EXPL2_END;
ROCKET RocketListe[200];
int ExplAnzahl;
int f_x=0; f_y=0;
int MannAnzahl= -1, FeindAnzahl= -1, scroll_del, mann_del, ss_del, sm_del;
int sdel;
int aktive = 0, aktsel=-1, atkzoom=0, rahmen=0;
BYTE akt[6];
int VIEW_LANG  = 4, vx=230;
int VIEW_BREIT = 3; vy=130;
int FELD_X;
int FELD_Y;
int Radar_x, Radar_y, Radar_x1, Radar_y1, intro;
BYTE radar_akt=1, rad_res=0;
int x_lang, y_breit, aktzaehler;
char karte[13];
char pal[768];
int  O_ANFANG, U_ANFANG, R_ANFANG, L_ANFANG, MANN_DIV, O_LANG,
     U_LANG, R_LANG, L_LANG,
     LO_ANFANG, LU_ANFANG, RO_ANFANG, RU_ANFANG, LO_LANG, LU_LANG, RO_LANG, RU_LANG,
     ANGRIF_L, ANGRIF_R, ANGRIF_O, ANGRIF_U,
     ANGRIF_LL, ANGRIF_RL, ANGRIF_OL, ANGRIF_UL,
     ANGRIF_LO, ANGRIF_LU, ANGRIF_RO, ANGRIF_RU,
     ANGRIF_LOL, ANGRIF_LUL, ANGRIF_ROL, ANGRIF_RUL;
     F1S1_A, F1S1_L, F3S1_A, F3S1_L, F3S2_A, F3S2_L,
     M1S1_A, M1S1_L, M3S1_A, M3S1_L, M3S2_A, M3S2_L,
     FL_ANFANG, FR_ANFANG, FO_ANFANG, FU_ANFANG;    
FBXY FB[20];
BYTE fbcount=0, fast_scroll;
int  FHauptX, FHauptY, MHauptX, MHauptY;
BYTE mansel[50];
int  meldung, MediDelay, MediSave, MediSet=0, MediRand=200;
DEST MediKit;
BYTE svga;
int  RocketAnzahl=-1, RauchAnzahl=-1;
FDEST Fahnen[100], Rauch[400];
BYTE fcnt=0, rock_del=0, expl_disp=0;


/****************************************************************************/
/* put_sprite bring ein Sprite von 20x20 auf den Bildschirm. Zuvor mu ihr  */
/* aber die Position des Sprites im XMS bergeben werden, sowie die X- und  */
/* Y-Koordinaten.                                                           */
/*--------------------------------------------------------------------------*/
/* Parameter:                                                               */
/*            x................................... X-Koordinate des Sprites */
/*            y................................... Y-Koordinate des Sprites */
/*            pos................................... Sprite-Position im XMS */
/****************************************************************************/
void put_sprite( int x, int y, unsigned int pos )
{
  int i;

  for(i=0; i<20; i++)
  {
    memcpy(&VScreen[((y+i)*res_x)+x], &LandData[pos+(i*20)], 20);
  }
}

void hput_sprite( int x, int y, unsigned int pos )
{
  int i, j, h=pos;

  for(i=0; i<20; i++)
  {
    for (j=0; j<20; j++)
    {
      if ( vgetpix(x+j, y+i, res_x) < 230 ) vsetpix(x+j, y+i, LandData[h++], res_x);
    }
  }
}


/****************************************************************************/
/* Dies Funktion stellt das Grundgrst fr diese Spiel dar. Sie berechnet   */
/* welche Teile der Landschaft (Karte) angezeigt werden soll.               */
/* Gesteuert wird per Maus.                                                 */
/*--------------------------------------------------------------------------*/
/* Parameter:                                                               */
/*            weiter_x..................... wie weit in X-Richtung scrollen */
/*            weiter_y..................... wie weit in Y_Richtung scrollen */
/****************************************************************************/
void Landschaft ( int weiter_x, int weiter_y )
{
  int i, j;
  char strgeld[5];


  for (i=weiter_y; i<weiter_y+SPIEL_LANG; i++)
  {
    for (j=weiter_x; j<weiter_x+SPIEL_BREIT; j++)
    {
      put_sprite((j-weiter_x)*20, (i-weiter_y)*20, Feld[i][j]*400);
    }
  }
}


/****************************************************************************/
/* Initialisiert das Programm an sich.                                      */
/* ------------------------------------------------------------------------ */
/* keine Parameter                                                          */
/****************************************************************************/
void Init_Program( void )
{
  FILE *Datei;
  int i, Zeichen;
  char DateiName[127], *ptr;

  printf("Copyright (c) 1996 PCX-Brothers Entertainment\n");
  printf("Alle Rechte vorbehalten.\n");
  printf("Defkon17 Alpha\n");
  if ( maus_reset() )        // berprfen ob ein Maustreiber installiert ist
  {
   printf("\n\nERROR: Es wurde kein Maustreiber gefunden!\n\n");
   exit(0);
  }

  chdir("RESOURCE");
  if ( (Datei = fopen("maus.ref", "rb")) == NULL )             // Leute laden
  {
    textmodus();
    printf("\n\nERROR: Kann 'maus.ref' nicht laden!\n\n");
    exit(0);
  }
  i=256; ptr = m_images;
  while ((Zeichen = fgetc(Datei)) != EOF) ptr[i++] = (BYTE)Zeichen; 
  fclose(Datei);
  chdir("..");

  load_ini(); ss_del = scroll_del; sm_del = mann_del;

  fade_out(); init640x480();

  maus_reset();
  maus_off(); maus_put(160, 100);                              // Maus setzen
}

void Init_Mann ( void )
{
  FILE *Datei;
  int Zeichen;
  long i=0;

//==========================================================================//
////-- FEIND1.REF --//
  if ( (Datei = fopen("feind1.ref", "rb")) == NULL ) { textmodus(); printf("\n\nERROR: Kann 'feind1.ref' nicht laden!\n\n"); exit(0); }
  while ((Zeichen = fgetc(Datei)) != EOF) MannData[i++] = (BYTE)Zeichen;
  fclose(Datei);
////-- FEINDA1.REF --//
  if ( (Datei = fopen("feinda1.ref", "rb")) == NULL ) { textmodus(); printf("\n\nERROR: Kann 'feinda1.ref' nicht laden!\n\n"); exit(0); }
  while ((Zeichen = fgetc(Datei)) != EOF) MannData[i++] = (BYTE)Zeichen;
  fclose(Datei);
////-- MANNF.REF --//
  if ( (Datei = fopen("mannf.ref", "rb")) == NULL ) { textmodus(); printf("\n\nERROR: Kann 'mannf.ref' nicht laden!\n\n"); exit(0); }
  while ((Zeichen = fgetc(Datei)) != EOF) MannData[i++] = (BYTE)Zeichen;
  fclose(Datei);
//==========================================================================//

//==========================================================================//
////-- FEIND2.REF --//
  if ( (Datei = fopen("feind2.ref", "rb")) == NULL ) { textmodus(); printf("\n\nERROR: Kann 'feind2.ref' nicht laden!\n\n"); exit(0); }
  while ((Zeichen = fgetc(Datei)) != EOF) MannData[i++] = (BYTE)Zeichen;
  fclose(Datei);
////-- FEINDA2.REF --//
  if ( (Datei = fopen("feinda2.ref", "rb")) == NULL ) { textmodus(); printf("\n\nERROR: Kann 'feinda2.ref' nicht laden!\n\n"); exit(0); }
  while ((Zeichen = fgetc(Datei)) != EOF) MannData[i++] = (BYTE)Zeichen;
  fclose(Datei);
////-- MANNF.REF --//
  if ( (Datei = fopen("mannf.ref", "rb")) == NULL ) { textmodus(); printf("\n\nERROR: Kann 'mannf.ref' nicht laden!\n\n"); exit(0); }
  while ((Zeichen = fgetc(Datei)) != EOF) MannData[i++] = (BYTE)Zeichen;
  fclose(Datei);
//==========================================================================//

//==========================================================================//
////-- FEIND3.REF --//
  if ( (Datei = fopen("feind3.ref", "rb")) == NULL ) { textmodus(); printf("\n\nERROR: Kann 'feind3.ref' nicht laden!\n\n"); exit(0); }
  while ((Zeichen = fgetc(Datei)) != EOF) MannData[i++] = (BYTE)Zeichen;
  fclose(Datei);
////-- FEINDA3.REF --//
  if ( (Datei = fopen("feinda3.ref", "rb")) == NULL ) { textmodus(); printf("\n\nERROR: Kann 'feinda3.ref' nicht laden!\n\n"); exit(0); }
  while ((Zeichen = fgetc(Datei)) != EOF) MannData[i++] = (BYTE)Zeichen;
  fclose(Datei);
////-- MANNF.REF --//
  if ( (Datei = fopen("mannf.ref", "rb")) == NULL ) { textmodus(); printf("\n\nERROR: Kann 'mannf.ref' nicht laden!\n\n"); exit(0); }
  while ((Zeichen = fgetc(Datei)) != EOF) MannData[i++] = (BYTE)Zeichen;
  fclose(Datei);
//==========================================================================//

//==========================================================================//
////-- MANN1.REF --//
  if ( (Datei = fopen("mann1.ref", "rb")) == NULL ) { textmodus(); printf("\n\nERROR: Kann 'mann1.ref' nicht laden!\n\n"); exit(0); }
  while ((Zeichen = fgetc(Datei)) != EOF) MannData[i++] = (BYTE)Zeichen;
  fclose(Datei);
////-- MANNA1.REF --//
  if ( (Datei = fopen("manna1.ref", "rb")) == NULL ) { textmodus(); printf("\n\nERROR: Kann 'manna1.ref' nicht laden!\n\n"); exit(0); }
  while ((Zeichen = fgetc(Datei)) != EOF) MannData[i++] = (BYTE)Zeichen;
  fclose(Datei);
////-- MANNF.REF --//
  if ( (Datei = fopen("mannf.ref", "rb")) == NULL ) { textmodus(); printf("\n\nERROR: Kann 'mannf.ref' nicht laden!\n\n"); exit(0); }
  while ((Zeichen = fgetc(Datei)) != EOF) MannData[i++] = (BYTE)Zeichen;
  fclose(Datei);
//==========================================================================//

//==========================================================================//
////-- MANN2.REF --//
  if ( (Datei = fopen("mann2.ref", "rb")) == NULL ) { textmodus(); printf("\n\nERROR: Kann 'mann2.ref' nicht laden!\n\n"); exit(0); }
  while ((Zeichen = fgetc(Datei)) != EOF) MannData[i++] = (BYTE)Zeichen;
  fclose(Datei);
////-- MANNA2.REF --//
  if ( (Datei = fopen("manna2.ref", "rb")) == NULL ) { textmodus(); printf("\n\nERROR: Kann 'manna2.ref' nicht laden!\n\n"); exit(0); }
  while ((Zeichen = fgetc(Datei)) != EOF) MannData[i++] = (BYTE)Zeichen;
  fclose(Datei);
////-- MANNF.REF --//
  if ( (Datei = fopen("mannf.ref", "rb")) == NULL ) { textmodus(); printf("\n\nERROR: Kann 'mannf.ref' nicht laden!\n\n"); exit(0); }
  while ((Zeichen = fgetc(Datei)) != EOF) MannData[i++] = (BYTE)Zeichen;
  fclose(Datei);
//==========================================================================//

//==========================================================================//
////-- MANN3.REF --//
  if ( (Datei = fopen("mann3.ref", "rb")) == NULL ) { textmodus(); printf("\n\nERROR: Kann 'mann3.ref' nicht laden!\n\n"); exit(0); }
  while ((Zeichen = fgetc(Datei)) != EOF) MannData[i++] = (BYTE)Zeichen;
  fclose(Datei);
////-- MANNA3.REF --//
  if ( (Datei = fopen("manna3.ref", "rb")) == NULL ) { textmodus(); printf("\n\nERROR: Kann 'manna3.ref' nicht laden!\n\n"); exit(0); }
  while ((Zeichen = fgetc(Datei)) != EOF) MannData[i++] = (BYTE)Zeichen;
  fclose(Datei);
////-- MANNF.REF --//
  if ( (Datei = fopen("mannf.ref", "rb")) == NULL ) { textmodus(); printf("\n\nERROR: Kann 'mannf.ref' nicht laden!\n\n"); exit(0); }
  while ((Zeichen = fgetc(Datei)) != EOF) MannData[i++] = (BYTE)Zeichen;
  fclose(Datei);
//==========================================================================//


//==========================================================================//
////-- FEINDS1.REF --//
  if ( (Datei = fopen("feinds1.ref", "rb")) == NULL ) { textmodus(); printf("\n\nERROR: Kann 'feinds1.ref' nicht laden!\n\n"); exit(0); }
  while ((Zeichen = fgetc(Datei)) != EOF) MannData[i++] = (BYTE)Zeichen;
  fclose(Datei);
////-- FEINDS3a.REF --//
  if ( (Datei = fopen("feinds3a.ref", "rb")) == NULL ) { textmodus(); printf("\n\nERROR: Kann 'feinds3a.ref' nicht laden!\n\n"); exit(0); }
  while ((Zeichen = fgetc(Datei)) != EOF) MannData[i++] = (BYTE)Zeichen;
  fclose(Datei);
////-- FEINDS3b.REF --//
  if ( (Datei = fopen("feinds3b.ref", "rb")) == NULL ) { textmodus(); printf("\n\nERROR: Kann 'feinds3b.ref' nicht laden!\n\n"); exit(0); }
  while ((Zeichen = fgetc(Datei)) != EOF) MannData[i++] = (BYTE)Zeichen;
  fclose(Datei);
////-- MANNS1.REF --//
  if ( (Datei = fopen("manns1.ref", "rb")) == NULL ) { textmodus(); printf("\n\nERROR: Kann 'manns1.ref' nicht laden!\n\n"); exit(0); }
  while ((Zeichen = fgetc(Datei)) != EOF) MannData[i++] = (BYTE)Zeichen;
  fclose(Datei);
////-- MANNS3a.REF --//
  if ( (Datei = fopen("manns3a.ref", "rb")) == NULL ) { textmodus(); printf("\n\nERROR: Kann 'manns3a.ref' nicht laden!\n\n"); exit(0); }
  while ((Zeichen = fgetc(Datei)) != EOF) MannData[i++] = (BYTE)Zeichen;
  fclose(Datei);
////-- MANNS3b.REF --//
  if ( (Datei = fopen("manns3b.ref", "rb")) == NULL ) { textmodus(); printf("\n\nERROR: Kann 'manns3b.ref' nicht laden!\n\n"); exit(0); }
  while ((Zeichen = fgetc(Datei)) != EOF) MannData[i++] = (BYTE)Zeichen;
  fclose(Datei);
//==========================================================================//

////-- MANNF.REF --//
  if ( (Datei = fopen("mannf.ref", "rb")) == NULL ) { textmodus(); printf("\n\nERROR: Kann 'mannf.ref' nicht laden!\n\n"); exit(0); }
  while ((Zeichen = fgetc(Datei)) != EOF) MannData[i++] = (BYTE)Zeichen;
  fclose(Datei);

//==========================================================================//
//--                       J A G D   P A N Z E R                          --//
//==========================================================================//
  AP_ANFANG = i;                    // AnfangsVariable fr Jagd-Panzer setzen
////-- AP-MANN.REF --//
  if ( (Datei = fopen("ap-mann.ref", "rb")) == NULL ) { textmodus(); printf("\n\nERROR: Kann 'ap-mann.ref' nicht laden!\n\n"); exit(0); }
  while ((Zeichen = fgetc(Datei)) != EOF) MannData[i++] = (BYTE)Zeichen;
  fclose(Datei);
  APF_ANFANG = i;                   // AnfangsVariable fr Jagd-Panzer setzen
////-- AP-FEIND.REF --//
  if ( (Datei = fopen("ap-feind.ref", "rb")) == NULL ) { textmodus(); printf("\n\nERROR: Kann 'ap-feind.ref' nicht laden!\n\n"); exit(0); }
  while ((Zeichen = fgetc(Datei)) != EOF) MannData[i++] = (BYTE)Zeichen;
  fclose(Datei);

}


void Init_Landscp ( void )
{
  FILE *Datei, *Data;
  char puffer[14], anzahl=0, h, j=0;
  int Zeichen;
  long i=0;

  if ( (Datei = fopen("terrain.num", "rb")) == NULL ) { textmodus(); printf("\n\nERROR: Kann 'terrain.num' nicht laden!\n\n"); exit(0); }
  anzahl = get_ini_value(Datei); 

  for (h=0; h<anzahl; h++ )
  {
    memset(&puffer[1], 0, 13); while ( fgetc(Datei) != '=' );
    while ( (puffer[j++] = fgetc(Datei)) != ':');  puffer[--j] = 0x00; j = 0;

    if ( (Data = fopen(puffer, "rb")) == NULL ) { textmodus(); printf("\n\nERROR: Kann '%s' nicht laden!\n\n", puffer); exit(0); }
    while ((Zeichen = fgetc(Data)) != EOF) LandData[i++] = (BYTE)Zeichen;
    fclose(Data);
  }

  fclose(Datei);
}

/****************************************************************************/
/* Initialisiert das ein Spiel. (vom Men aus)                              */
/* ------------------------------------------------------------------------ */
/* keine Parameter                                                          */
/****************************************************************************/
void Init_Spiel ( char type )
{
  int j, Zeichen, x=1, laden_y=135, laden_y1=283, laden_inc=0, i;
  char puffer[13];
  long anz;
  FILE *Datei;



  chdir("DEFDATA");
  Screen_Off(); show_PCX("laden.xgf"); Set_Overscan_Color(0); cpy2screen(); Screen_On();
  chdir(".."); delay(500);

  //----------------------------------------------------------------------------------//
  laden_inc+=2; fill_box(0, laden_y, 640, laden_y+laden_inc+1, 0); memset(&VScreen[(laden_y+laden_inc)*640], 37, 640); cpy2screen();
  fill_box(0, laden_y1-laden_inc-1, 640, laden_y1, 0); memset(&VScreen[(laden_y1-laden_inc)*640], 37, 640); cpy2screen();
  //----------------------------------------------------------------------------------//
  if ( type )
  {
    MannAnzahl = FeindAnzahl = -1;
    f_x = f_y = 0;
    aktzaehler = -1; 
    memset(AktListe, 0, 200);
    memset(mansel, 0, 50);
  }
  memset(MannFeld, 0, 200*200*2);
  aktsel=-1; 

  if ( chdir("RESOURCE") ) { printf("\n\nERROR: Kann Verzeichnis RESOURCE nicht finden!\n\n"); exit(0); }
  //----------------------------------------------------------------------------------//
  laden_inc+=2; fill_box(0, laden_y, 640, laden_y+laden_inc+1, 0); memset(&VScreen[(laden_y+laden_inc)*640], 37, 640); cpy2screen();
  fill_box(0, laden_y1-laden_inc-1, 640, laden_y1, 0); memset(&VScreen[(laden_y1-laden_inc)*640], 37, 640); cpy2screen();
  //----------------------------------------------------------------------------------//
  Init_Mann();
  //----------------------------------------------------------------------------------//
  laden_inc+=2; fill_box(0, laden_y, 640, laden_y+laden_inc+1, 0); memset(&VScreen[(laden_y+laden_inc)*640], 37, 640); cpy2screen();
  fill_box(0, laden_y1-laden_inc-1, 640, laden_y1, 0); memset(&VScreen[(laden_y1-laden_inc)*640], 37, 640); cpy2screen();
  //----------------------------------------------------------------------------------//
  Init_Landscp();
  //----------------------------------------------------------------------------------//
  laden_inc+=2; fill_box(0, laden_y, 640, laden_y+laden_inc+1, 0); memset(&VScreen[(laden_y+laden_inc)*640], 37, 640); cpy2screen();
  fill_box(0, laden_y1-laden_inc-1, 640, laden_y1, 0); memset(&VScreen[(laden_y1-laden_inc)*640], 37, 640); cpy2screen();
  //----------------------------------------------------------------------------------//
  load_num();

  //----------------------------------------------------------------------------------//
  laden_inc+=2; fill_box(0, laden_y, 640, laden_y+laden_inc+1, 0); memset(&VScreen[(laden_y+laden_inc)*640], 37, 640); cpy2screen();
  fill_box(0, laden_y1-laden_inc-1, 640, laden_y1, 0); memset(&VScreen[(laden_y1-laden_inc)*640], 37, 640); cpy2screen();
  //----------------------------------------------------------------------------------//
  if ( (Datei = fopen("font.ref", "rb")) == NULL )             // Leute laden
  {
    textmodus();
    printf("\n\nERROR: Kann 'font.ref' nicht laden!\n\n");
    exit(0);
  }
  anz=0;
  while ((Zeichen = fgetc(Datei)) != EOF) bchst[anz++] = (BYTE)Zeichen;
  fclose(Datei);
  //----------------------------------------------------------------------------------//
  laden_inc+=2; fill_box(0, laden_y, 640, laden_y+laden_inc+1, 0); memset(&VScreen[(laden_y+laden_inc)*640], 37, 640); cpy2screen();
  fill_box(0, laden_y1-laden_inc-1, 640, laden_y1, 0); memset(&VScreen[(laden_y1-laden_inc)*640], 37, 640); cpy2screen();
  //----------------------------------------------------------------------------------//
  if ( (Datei = fopen("explose.ref", "rb")) == NULL )             // Leute laden
  {
    textmodus();
    printf("\n\nERROR: Kann 'explose.ref' nicht laden!\n\n");
    exit(0);
  }
  anz=0;
  while ((Zeichen = fgetc(Datei)) != EOF) ExploseData[anz++] = (BYTE)Zeichen;
  fclose(Datei); EXPL1_END = anz;
  //----------------------------------------------------------------------------------//
  laden_inc+=2; fill_box(0, laden_y, 640, laden_y+laden_inc+1, 0); memset(&VScreen[(laden_y+laden_inc)*640], 37, 640); cpy2screen();
  fill_box(0, laden_y1-laden_inc-1, 640, laden_y1, 0); memset(&VScreen[(laden_y1-laden_inc)*640], 37, 640); cpy2screen();
  //----------------------------------------------------------------------------------//
  if ( (Datei = fopen("explose1.ref", "rb")) == NULL )             // Leute laden
  {
    textmodus();
    printf("\n\nERROR: Kann 'explose1.ref' nicht laden!\n\n");
    exit(0);
  }
  while ((Zeichen = fgetc(Datei)) != EOF) ExploseData[anz++] = (BYTE)Zeichen;
  fclose(Datei); EXPL2_END = anz;
  //----------------------------------------------------------------------------------//
  laden_inc+=2; fill_box(0, laden_y, 640, laden_y+laden_inc+1, 0); memset(&VScreen[(laden_y+laden_inc)*640], 37, 640); cpy2screen();
  fill_box(0, laden_y1-laden_inc-1, 640, laden_y1, 0); memset(&VScreen[(laden_y1-laden_inc)*640], 37, 640); cpy2screen();
  //----------------------------------------------------------------------------------//
  if ( (Datei = fopen("explose2.ref", "rb")) == NULL )             // Leute laden
  {
    textmodus();
    printf("\n\nERROR: Kann 'explose2.ref' nicht laden!\n\n");
    exit(0);
  }
  while ((Zeichen = fgetc(Datei)) != EOF) ExploseData[anz++] = (BYTE)Zeichen;
  fclose(Datei);
  //----------------------------------------------------------------------------------//
  laden_inc+=2; fill_box(0, laden_y, 640, laden_y+laden_inc+1, 0); memset(&VScreen[(laden_y+laden_inc)*640], 37, 640); cpy2screen();
  fill_box(0, laden_y1-laden_inc-1, 640, laden_y1, 0); memset(&VScreen[(laden_y1-laden_inc)*640], 37, 640); cpy2screen();
  //----------------------------------------------------------------------------------//
  if ( (Datei = fopen("rauch.ref", "rb")) == NULL )             // Leute laden
  {
    textmodus();
    printf("\n\nERROR: Kann 'rauch.ref' nicht laden!\n\n");
    exit(0);
  }
  anz=0;
  while ((Zeichen = fgetc(Datei)) != EOF) RauchData[anz++] = (BYTE)Zeichen;
  fclose(Datei);
  //----------------------------------------------------------------------------------//
  laden_inc+=2; fill_box(0, laden_y, 640, laden_y+laden_inc+1, 0); memset(&VScreen[(laden_y+laden_inc)*640], 37, 640); cpy2screen();
  fill_box(0, laden_y1-laden_inc-1, 640, laden_y1, 0); memset(&VScreen[(laden_y1-laden_inc)*640], 37, 640); cpy2screen();
  //----------------------------------------------------------------------------------//
  if ( (Datei = fopen("intfc-ap.ref", "rb")) == NULL )             // Leute laden
  {
    textmodus();
    printf("\n\nERROR: Kann 'intfc-ap.ref' nicht laden!\n\n");
    exit(0);
  }
  anz=0;
  while ((Zeichen = fgetc(Datei)) != EOF) IntfcData[anz++] = (BYTE)Zeichen;
  fclose(Datei);
  //----------------------------------------------------------------------------------//
  laden_inc+=2; fill_box(0, laden_y, 640, laden_y+laden_inc+1, 0); memset(&VScreen[(laden_y+laden_inc)*640], 37, 640); cpy2screen();
  fill_box(0, laden_y1-laden_inc-1, 640, laden_y1, 0); memset(&VScreen[(laden_y1-laden_inc)*640], 37, 640); cpy2screen();
  //----------------------------------------------------------------------------------//
  chdir("..");
  if ( chdir("MISSION") ) { printf("\n\nERROR: Kann Verzeichnis MISSION nicht finden!\n\n"); exit(0); }
  if ( type ) load_gam(karte);
  else load_gamap(karte);
  //----------------------------------------------------------------------------------//
  laden_inc+=2; fill_box(0, laden_y, 640, laden_y+laden_inc+1, 0); memset(&VScreen[(laden_y+laden_inc)*640], 37, 640); cpy2screen();
  fill_box(0, laden_y1-laden_inc-1, 640, laden_y1, 0); memset(&VScreen[(laden_y1-laden_inc)*640], 37, 640); cpy2screen();
  //----------------------------------------------------------------------------------//
  CD_Init();
  CD_Update();
  //----------------------------------------------------------------------------------//
  laden_inc+=2; fill_box(0, laden_y, 640, laden_y+laden_inc+1, 0); memset(&VScreen[(laden_y+laden_inc)*640], 37, 640); cpy2screen();
  fill_box(0, laden_y1-laden_inc-1, 640, laden_y1, 0); memset(&VScreen[(laden_y1-laden_inc)*640], 37, 640); cpy2screen();
  //----------------------------------------------------------------------------------//

  Play_Musik(1);

  //----------------------------------------------------------------------------------//
  laden_inc+=2; fill_box(0, laden_y, 640, laden_y+laden_inc+1, 0); memset(&VScreen[(laden_y+laden_inc)*640], 37, 640); cpy2screen();
  fill_box(0, laden_y1-laden_inc-1, 640, laden_y1, 0); memset(&VScreen[(laden_y1-laden_inc)*640], 37, 640); cpy2screen();
  //----------------------------------------------------------------------------------//
  while( (laden_y+laden_inc) < (laden_y1-laden_inc) )
  {
    //----------------------------------------------------------------------------------//
    laden_inc+=2; fill_box(0, laden_y, 640, laden_y+laden_inc+1, 0); memset(&VScreen[(laden_y+laden_inc)*640], 37, 640); cpy2screen();
    fill_box(0, laden_y1-laden_inc-1, 640, laden_y1, 0); memset(&VScreen[(laden_y1-laden_inc)*640], 37, 640); cpy2screen();
    //----------------------------------------------------------------------------------//
  }
  if ( type )
  {
    UpdateScreen();
    maus_off(); maus_put(160, 100);
  }
  else UpdateScreen();

  get_factory(); set_DataBase();
  fade_out(); init640x480();
  if ( type )
  {
    for(j=0; j<6; j++) FeindInsert(((FHauptX-3)+j)*20, (FHauptY+1)*20, 1);
    for(j=0; j<3; j++) FeindInsert(((FHauptX-3)+j)*20, (FHauptY+2)*20, 2);
    for(j=0; j<4; j++) MannInsert (((MHauptX-3)+j)*20, (MHauptY+1)*20, 1);
    for(j=0; j<2; j++) MannInsert (((MHauptX-3)+j)*20, (MHauptY+2)*20, 2);

    f_x = MHauptX-5; f_y = MHauptY-5;
    for(j=0; j<=MannAnzahl; j++)  { ML[j].x=ML[j].x1-=20*f_x; ML[j].y=ML[j].y1-=20*f_y; }
    for(j=0; j<=FeindAnzahl; j++) { FL[j].x=FL[j].x1-=20*f_x; FL[j].y=FL[j].y1-=20*f_y; } 
    chdir("..");
    if ( chdir("DEFDATA") ) { printf("\n\nERROR: Kann Verzeichnis DEFDATA nicht finden!\n\n"); exit(0); }
    show_PCX("intfc-04.xgf");
  }
  chdir("..");
  Set_Overscan_Color(0);
  m_back_save(); m_place();
  cpy2screen(); /*set_pal_out(0, 232, 60);*/ Screen_On();

}

/****************************************************************************/
/* Maushandler fr die Funktion Spiel().                                    */
/* ------------------------------------------------------------------------ */
/* keine Parameter                                                          */
/****************************************************************************/
int maus_links ( void )
{
  int i, j, h, k;
  BYTE kb;
  union REGS regs;

  regs.x.ax = 0x0200;      
  int386( 0x16, &regs, &regs );
  kb = regs.h.al;
                                            
  //------------------------------------------------------------------------//
  for(i=0; i<=fbcount; i++)
  {
    if ( ((f_x+(m_x/Teilung))==FB[i].x)&&((f_y+(m_y/Teilung))==FB[i].y)&&(FB[i].owner==1) )
    {
      m_back_restore(); show_fb_menu(i); m_back_save(); m_place();
      return 0;
    }
  }
  if ( maus_innen(4, 184, 40, 194) ) { if ( spiel_menu() ) return 1; else return 0; }
  if ( maus_innen(266, 10, 279, 20)&&(atkzoom>-1) )
  {
    f_x = ML[atkzoom].feldx; f_y = ML[atkzoom].feldy;
    for ( i=0; i<=MannAnzahl; i++ ) { ML[i].y1=ML[i].y=(ML[i].ay-(f_y*Teilung)); ML[i].x1=ML[i].x=(ML[i].ax-(f_x*Teilung)); }
    for ( i=0; i<=FeindAnzahl; i++ ) { FL[i].y1=FL[i].y=(FL[i].ay-(f_y*Teilung)); FL[i].x1=FL[i].x=(FL[i].ax-(f_x*Teilung)); }
    return 0;
  }
  if ( maus_innen(526, 51, 543, 70) )
  {
    memset(AktListe, 0, 200);
    for ( i=0; i<=50; i++ ) if ( mansel[i] > 0 ) AktListe[mansel[i]-1]=1;
    go = 1; m_show_image = 6;
  }
  //------------------------------------------------------------------------//


  if ( (m_x>Mlinks)&&(m_x<Mrechts)&&(m_y>Moben)&&(m_y<Munten) ) // wenn auf Spielfeld
  {
    for ( i=0; i<FeindAnzahl+1; i++ )
    {
      if ( (m_x>FL[i].x-15)&&(m_x<FL[i].x+15)&&(m_y>FL[i].y-15)&&(m_y<FL[i].y+15) )
      {
        for ( j=0; j<MannAnzahl+1; j++ )                        // angreifen
        {
          if ( AktListe[j] == 1 )
          {
            ML[j].attack = i; FL[i].atkanz++;
            ML[j].dx = FL[i].ax; ML[j].dy = FL[i].ay;
            if ( ML[j].text_col != 251 ) { ML[j].on_text = 1; ML[j].text_col = 251; ML[j].text = Mann_Msg[4+rand()%4]; }
          }
        }
        return 0;
      }
    }
    for ( i=0; i<MannAnzahl+1; i++ )
    {
      if ( (m_x>ML[i].x-15)&&(m_x<ML[i].x+15)&&(m_y>ML[i].y-15)&&(m_y<ML[i].y+15) )
      {
        if ( AktListe[i] ) return 0;                    // ist schon markiert
        if ( kb == 32 )
	{
          for ( j=0; j<MannAnzahl+1; j++ )        // alle anderen demarkieren
	    if ( AktListe[j] )
	    {
               AktListe[j]=0; 
	    } 
          aktive = 0;
        }
        AktListe[i] = 1; m_show_image=6; go=1; aktive++; aktsel=i;
        atkzoom = i;
        m_back_restore(); mann_akt_set(i); m_back_save(); m_place();
        m_taste= 0; return 0;
      }
    }
    if ( (!noway)&&(aktive>0) )
    {
      k=h=0;
      for ( i=0; i<=MannAnzahl; i++ )
      { 
        if ( (AktListe[i]) )
        {
          if ( h == aktive/3 ) { k++; h=0; }
          ML[i].dx=((f_x+1+(m_x/Teilung)+h)*Teilung); ML[i].dy=((f_y+(m_y/Teilung)+k)*Teilung); ML[i].stop=0;
          ML[i].stop=0; h++;
          if ( ML[i].text_col != 252 ) { ML[i].on_text = 1; ML[i].text_col = 252; ML[i].text = Mann_Msg[1+rand()%4]; }
        }
      }
      return 0;
    }

    if ( !noway ) { r_x=m_x; r_y=m_y; rahmen=1; }
  }

  return 0;
}

/****************************************************************************/
/* Maushandler fr die Funktion Spiel().                                    */
/* ------------------------------------------------------------------------ */
/* keine Parameter                                                          */
/****************************************************************************/
void maus_rechts ( void )
{
  int i, j, akt;

  if ( rahmen == 1 )
  {
    akt=0;
    if (m_x>r_x) { i=m_x; m_x=r_x; r_x=i; }
    if (m_y>r_y) { i=m_y; m_y=r_y; r_y=i; }

    memset(AktListe, 0, 200);

    for(i=0; i<=MannAnzahl; i++)
    {
      if ( ((ML[i].x<=r_x)&&(ML[i].x>=m_x))&&((ML[i].y<=r_y)&&(ML[i].y>=m_y)) ) { akt++; AktListe[i] = 1; }
    }

    if ( akt > 0 ) { m_show_image=6; go=1; }
    else { m_show_image = 1; go = 0; }
    rahmen=0; aktive = akt; return;
  }

  if ( maus_innen(526, 51, 543, 70) )
  {
    memset(mansel, 0, 50);
    for(i=0, j=0; i<=MannAnzahl; i++) if ( AktListe[i]==1 ) mansel[j++]=i+1;
  }

  if ( (x1<m_x)&&(f_x<FELD_X-13) ) { scroll_right(); }
  if ( (x1>m_x)&&(f_x>0) )         { scroll_left();  }
  if ( (y1<m_y)&&(f_y<FELD_Y-12) ) { scroll_down();  }
  if ( (y1>m_y)&&(f_y>0) )         { scroll_up();    }
}

void maus_beide ( void )
{
  r_x=m_x; r_y=m_y; rahmen=1; 
}

void get_factory ()
{
  int i, j;

  for (i=0; i<=y_breit; i++)
  {
    for(j=0; j<=x_lang; j++)
    {
      if ( Feld[i][j] == FAHNEN )    {  Fahnen[fcnt].x = j; Fahnen[fcnt].y = i; Fahnen[fcnt].index = 0; Fahnen[fcnt].lang = FAHNEN_L;     Fahnen[fcnt++].anf = FAHNEN; }
      if ( Feld[i][j] == STROEMUNG1 ) { Fahnen[fcnt].x = j; Fahnen[fcnt].y = i; Fahnen[fcnt].index = 0; Fahnen[fcnt].lang = STROEMUNG1_L; Fahnen[fcnt++].anf = STROEMUNG1; }
      if ( Feld[i][j] == STROEMUNG2 ) { Fahnen[fcnt].x = j; Fahnen[fcnt].y = i; Fahnen[fcnt].index = 0; Fahnen[fcnt].lang = STROEMUNG2_L; Fahnen[fcnt++].anf = STROEMUNG2; }
    }
  }
}


void UpdateScreen ( void )
{
  int i, j;

  Landschaft(f_x, f_y);

  for ( i=0; i<MannAnzahl+1; i++ )
  {
    if ( ML[i].free )
    {
      if ( (ML[i].x>Mlinks-20)&&(ML[i].x<Mrechts)&&(ML[i].y>Moben-20)&&(ML[i].y<Munten) )
      {
        if ( AktListe[i] )
        {
         if ( ML[i].hit ) mann_white_akt_set(i);
         else mann_akt_set(i);
        }
        else
        {
          if ( ML[i].wasser ) { mann_wasser_set(i); goto weiter; }
          if ( ML[i].hit )  mann_white_set(i);
          else mann_set(i);
        }
weiter:
        if ( ML[i].on_text )
        {
          write(ML[i].x-40, ML[i].y-(ML[i].on_text*2), ML[i].text, ML[i].text_col);
          if ( rock_del >= mann_del ) ML[i].on_text++;
        }
        if ( ML[i].on_text == 20 ) { ML[i].on_text = ML[i].text_col = 0; }
        if ( (ML[i].type==1)&&(ML[i].fire!=0) ) Mann1_Fire(i);
        if ( (ML[i].type==2)&&(ML[i].fire!=0) ) Mann2_Fire(i);
        if ( (ML[i].type==3)&&(ML[i].fire!=0) ) Mann3_Fire(i);
        if ( (ML[i].type==4)&&(ML[i].fire!=0) ) MannJP_Fire(i);
      }
    }
  }

  for ( i=0; i<FeindAnzahl+1; i++ )
  {
    if ( (FL[i].x>Mlinks-20)&&(FL[i].x<Mrechts)&&(FL[i].y>Moben-20)&&(FL[i].y<Munten) )
    {
      if ( FL[i].hit ) feind_white_set(i); else feind_set(i); 
      if ( (FL[i].type==1)&&(FL[i].fire!=0) ) Feind1_Fire(i);
      if ( (FL[i].type==2)&&(FL[i].fire!=0) ) Feind2_Fire(i);
      if ( (FL[i].type==3)&&(FL[i].fire!=0) ) Feind3_Fire(i);
      if ( (FL[i].type==4)&&(FL[i].fire!=0) ) FeindJP_Fire(i);
    }
  }

  if ( rock_del == mann_del ) rock_del = 0;
  else rock_del++;

  for ( i=0; i<=RauchAnzahl; i++)  show_rauch(i);
  for ( i=0; i<=RocketAnzahl; i++) show_rocket(i);
  for ( i=0; i<=ExplAnzahl; i++)   compute_explosion(i);
  if ( expl_disp == 5 ) SetDispStart(0, expl_disp);
  if ( expl_disp > 0 ) expl_disp--;
  if ( expl_disp == 3 ) SetDispStart(0, 0);
}

void scroll_down ( void )
{
  int i;

  sdel=0; f_y+=fast_scroll;
  Landschaft(f_x, f_y); screen_refresh= 1;
    for ( i=0; i<MannAnzahl+1; i++ )
    {
      if ( ML[i].free )
      {
        ML[i].y1=ML[i].y-=20*fast_scroll;
        if ( (ML[i].x<res_x)&&(ML[i].x>-20)&&(ML[i].y<res_y)&&(ML[i].y>-20) )
        {
          if ( AktListe[i] ) mann_akt_set(i);
          else mann_set(i);
        }
      }
    }
    for ( i=0; i<FeindAnzahl+1; i++ )
    {
      FL[i].y1=FL[i].y-=20*fast_scroll;
      if ( (FL[i].x<res_x)&&(FL[i].x>-20)&&(FL[i].y<res_y)&&(FL[i].y>-20) ) feind_set(i);
    }
  for ( i=0; i<=ExplAnzahl; i++) EL[i].y-=fast_scroll*20;
  for ( i=0; i<=RauchAnzahl; i++) Rauch[i].y-=fast_scroll*20;
  for ( i=0; i<=RocketAnzahl; i++) { RL[i].ay-=fast_scroll*20; RL[i].y-=fast_scroll*20; RL[i].y1-=fast_scroll*20; RL[i].oldy-=fast_scroll*20; }
  m_show_image=m_down;
}

void scroll_up ( void )
{
  int i;


  sdel=0; f_y-=fast_scroll;
  if ( f_y < 0 ) f_y = 0;
  Landschaft(f_x, f_y); screen_refresh= 1;
    for ( i=0; i<=MannAnzahl; i++ )
    {
      if ( ML[i].free )
      {
        ML[i].y1=ML[i].y+=20*fast_scroll;
        if ( (ML[i].x<res_x)&&(ML[i].x>-20)&&(ML[i].y<res_y)&&(ML[i].y>-20) )
        {
          if ( AktListe[i] ) mann_akt_set(i);
          else mann_set(i);
        }
      }
    }
    for ( i=0; i<=FeindAnzahl; i++ )
    {
      FL[i].y1=FL[i].y+=20*fast_scroll;
      if ( (FL[i].x<res_x)&&(FL[i].x>-20)&&(FL[i].y<res_y)&&(FL[i].y>-20) ) feind_set(i);
    }

  for ( i=0; i<=ExplAnzahl; i++) EL[i].y+=fast_scroll*20;
  for ( i=0; i<=RauchAnzahl; i++) Rauch[i].y+=fast_scroll*20;
  for ( i=0; i<=RocketAnzahl; i++) { RL[i].ay+=fast_scroll*20; RL[i].y+=fast_scroll*20; RL[i].y1+=fast_scroll*20; RL[i].oldy+=fast_scroll*20; }
  m_show_image=m_up;
}

void scroll_right ( void )
{
  int i;

  sdel=0; f_x+=fast_scroll;
  Landschaft(f_x, f_y); screen_refresh= 1;
    for ( i=0; i<MannAnzahl+1; i++ )
    {
      if ( ML[i].free )
      {
        ML[i].x1=ML[i].x-=20*fast_scroll;
        if ( (ML[i].x<res_x)&&(ML[i].x>-20)&&(ML[i].y<res_y)&&(ML[i].y>-20) )
        {
          if ( AktListe[i] ) mann_akt_set(i);
          else mann_set(i);
        }
      }
    }
    for ( i=0; i<FeindAnzahl+1; i++ )
    {
      FL[i].x1=FL[i].x-=20*fast_scroll;
      if ( (FL[i].x<res_x)&&(FL[i].x>-20)&&(FL[i].y<res_y)&&(FL[i].y>-20) ) feind_set(i);
    }
  m_show_image=m_right; 
  for ( i=0; i<=ExplAnzahl; i++) EL[i].x-=fast_scroll*20;
  for ( i=0; i<=RauchAnzahl; i++) Rauch[i].x-=fast_scroll*20;
  for ( i=0; i<=RocketAnzahl; i++) { RL[i].ax-=fast_scroll*20; RL[i].x-=fast_scroll*20; RL[i].x1-=fast_scroll*20; RL[i].oldx-=fast_scroll*20; }
}

void scroll_left ( void )
{
  int i;

  sdel=0; f_x-=fast_scroll;
  if ( f_x < 0 ) f_x = 0;
  Landschaft(f_x, f_y); screen_refresh= 1;
    for ( i=0; i<MannAnzahl+1; i++ )
    {
      if ( ML[i].free )
      {
        ML[i].x1=ML[i].x+=20*fast_scroll; 
        if ( (ML[i].x<res_x)&&(ML[i].x>-20)&&(ML[i].y<res_y)&&(ML[i].y>-20) )
        {
          if ( AktListe[i] ) mann_akt_set(i);
          else mann_set(i);
        }
      }
    }
    for ( i=0; i<FeindAnzahl+1; i++ )
    {
      FL[i].x1=FL[i].x+=20*fast_scroll;
      if ( (FL[i].x<res_x)&&(FL[i].x>-20)&&(FL[i].y<res_y)&&(FL[i].y>-20) ) feind_set(i);
    }
  for ( i=0; i<=ExplAnzahl; i++) EL[i].x+=fast_scroll*20;
  for ( i=0; i<=RauchAnzahl; i++) Rauch[i].x+=fast_scroll*20;
  for ( i=0; i<=RocketAnzahl; i++) { RL[i].ax+=fast_scroll*20; RL[i].x+=fast_scroll*20; RL[i].x1+=fast_scroll*20; RL[i].oldx+=fast_scroll*20; }
  m_show_image=m_left;
}

/****************************************************************************/
/* Ld eine Karte.                                                          */
/* ------------------------------------------------------------------------ */
/* Parameter: Dateiname.                                                    */
/****************************************************************************/
void load_gam ( char *Datei )
{
  int i, j;
  FILE *D;
  char sign[2];
  union REGS regs;

  f_x = f_y = 0;

  if ( (D = fopen(Datei, "rb")) == NULL )
  {
    printf("\n\nERROR: Kann Datei '%s' nicht laden!\n\n", Datei);
    exit(0);
  }
  sign[0] = 'S'; sign[1] = 'M';
//------------------------------ Header --------------------------------------
  sign[0] = fgetc(D); sign[1] = fgetc(D);
  FELD_X = fgetc(D); x_lang = FELD_X + 12;
  FELD_Y = fgetc(D); y_breit = FELD_Y + 10;
  MannAnzahl =  fgetc(D); MannAnzahl--;
  FeindAnzahl = fgetc(D); FeindAnzahl--;
//---------------------------- Karte speichern -------------------------------
  for ( i=0; i<(FELD_Y+11); i++)
  {
    for ( j=0; j<(FELD_X+13); j++)
    {
      regs.h.al = fgetc(D); regs.h.ah = fgetc(D);
      Feld[i][j] = regs.x.ax; 
    }
  }
//---------------------------- Kennung fr Leute -----------------------------
  sign[0] = fgetc(D);
  if ( (MannAnzahl > -1) )
    for(i=0; i<MannAnzahl+1; i++)
    {
      fget_Mann(D, &ML[i]);
    }
  if ( (FeindAnzahl > -1) )
    for(i=0; i<FeindAnzahl+1; i++)
    {
      fget_Mann(D, &FL[i]);
    }
//-----------------------------------------------------------------------------
  fclose(D);
}

void load_gamap ( char *Datei )
{
  int i, j;
  FILE *D;
  char sign[2];
  union REGS regs;

  if ( (D = fopen(Datei, "rb")) == NULL )
  {
    printf("\n\nERROR: Kann Datei '%s' nicht laden!\n\n", Datei);
    exit(0);
  }
  sign[0] = 'S'; sign[1] = 'M';
//------------------------------ Header --------------------------------------
  sign[0] = fgetc(D); sign[1] = fgetc(D);
  FELD_X = fgetc(D); x_lang = FELD_X + 12;
  FELD_Y = fgetc(D); y_breit = FELD_Y + 10;
  sign[0] =  fgetc(D); sign[0] = fgetc(D); 
//---------------------------- Karte speichern -------------------------------
  for ( i=0; i<(FELD_Y+11); i++)
  {
    for ( j=0; j<(FELD_X+13); j++)
    {
      regs.h.al = fgetc(D); regs.h.ah = fgetc(D);
      Feld[i][j] = regs.x.ax; 
    }
  }
//--------------------------------------------------------------------------------------------------------------------------------------------
  fclose(D);
}





/****************************************************************************/
/* Speichert das momentane Spiel ab.                                        */
/* ------------------------------------------------------------------------ */
/* Parameter: Name des SaveGames.                                           */
/****************************************************************************/
void save_game ( char DateiName[13], char Name[50] )
{
  FILE *Datei;
  char sign[2]="SM";
  int i, j;

  chdir("system");

  if ( (Datei = fopen(DateiName, "w")) == NULL )
  {
    Screen_On(); textmodus();
    printf("\n\nERROR: Kann in Datei '%s' nicht schreiben!\n\n", DateiName);
    exit(0);
  }
  fwrite(sign, 2, 1, Datei);                                      // Signatur
  fwrite(Name, 50, 1, Datei);                                // Savegame-Name
  fwrite(karte, 13, 1, Datei);                                // xxx.map Name

  fputc(MannAnzahl, Datei);                                   // MannAnzahl
  fputc(FeindAnzahl, Datei);                                 // FeindAnzahl
  fputc(f_x, Datei); fputc(f_y, Datei);                 // Karten-Koordinaten
  for(i=0; i<=200; i++) fputc(AktListe[i], Datei);                // AktListe
  for(i=0; i<MannAnzahl+1; i++)  fput_Mann(Datei, &ML[i]);
  for(i=0; i<FeindAnzahl+1; i++) fput_Mann(Datei, &FL[i]);

  fclose(Datei);
  chdir("..");
}

/****************************************************************************/
/* Ld ein zuvor gespeichertes Spiel.                                       */
/* ------------------------------------------------------------------------ */
/* Parameter: Name des SaveGames.                                           */
/****************************************************************************/
void load_game ( char DateiName[13] )
{
  FILE *Datei;
  char sign[1], Name[50];
  int i, j;

  chdir("system");

  memset(sign, 0, 2);
  if ( (Datei = fopen(DateiName, "r")) == NULL )
  {
    Screen_On(); textmodus();
    printf("\n\nERROR: Kann Datei '%s' nicht laden!\n\n", DateiName);
    exit(0);
  }
  if ( (sign[0] = fgetc(Datei)) != 'S' )
  {
    Screen_On(); textmodus();
    printf("\n\nERROR: Das ist kein DEFKON17-Savegame!\n\n");
    exit(0);
  }
  if ( (sign[1] = fgetc(Datei)) != 'M' )
  {
    Screen_On(); textmodus();
    printf("\n\nERROR: Das ist kein DEFKON17-Savegame!\n\n");
    exit(0);
  }
  fread(Name, 50, 1, Datei);                                 // Savegame-Name
  fread(karte, 13, 1, Datei);                                   // x.map Name

  MannAnzahl  = fgetc(Datei);                                   // MannAnzahl
  FeindAnzahl = fgetc(Datei);                                  // FeindAnzahl
  f_x = fgetc(Datei); f_y = fgetc(Datei);               // Karten-Koordinaten
  for(i=0; i<=200; i++) AktListe[i] = fgetc(Datei);               // AktListe

  for(i=0; i<MannAnzahl+1; i++) fget_Mann(Datei, &ML[i]);
  for(i=0; i<MannAnzahl+1; i++)
  {
    ML[i].ay = ML[i].feldy*20; ML[i].ax = ML[i].feldx*20;
    ML[i].dy = ML[i].feldy*20; ML[i].dx = ML[i].feldx*20;
    ML[i].y = ML[i].ay-(f_y*20); ML[i].x = ML[i].ax-(f_x*20);
  }

  for(i=0; i<=FeindAnzahl+1; i++) fget_Mann(Datei, &FL[i]);
  for(i=0; i<FeindAnzahl+1; i++)
  {
    FL[i].ay = FL[i].feldy*20; FL[i].ax = FL[i].feldx*20;
    FL[i].dy = FL[i].feldy*20; FL[i].dx = FL[i].feldx*20;
    FL[i].y = FL[i].ay-(f_y*20); FL[i].x = FL[i].ax-(f_x*20);
  }

  fclose(Datei);
  chdir("..");
}

int get_ini_value ( FILE *D )
{
  char ini[5];
  int i= 0;

  memset(ini, 32, 5);
  while ( fgetc(D) != '=' );
  while ( (ini[i++] = fgetc(D)) != ':');
  return atoi(ini); 
}

/****************************************************************************/
/* Wertet die INI-Datei aus, und setzt die dazugehrigen Variablen          */
/* ------------------------------------------------------------------------ */
/* Keine Parameter.                                                         */
/****************************************************************************/
void load_ini ( void )
{
  int i;
  FILE *Datei;

  if ( (Datei = fopen("defkon.ini", "rb")) == NULL )
  {
    Screen_On(); textmodus();
    printf("\n\nERROR: Kann 'defkon.ini' nicht laden!\n\n");
    exit(0);
  }
//---------------------- scroll_del ------------------------------------------
    scroll_del = get_ini_value(Datei); 
//---------------------- mann_del --------------------------------------------
    mann_del = get_ini_value(Datei); 
//---------------------- svga -------------------------------------------------
    svga = get_ini_value(Datei); 
//---------------------- Intro -----------------------------------------------
    intro = get_ini_value(Datei); 
//---------------------- Radar_x ---------------------------------------------
    Radar_x = get_ini_value(Datei); 
//---------------------- Radar_y ---------------------------------------------
    Radar_y = get_ini_value(Datei); 
//---------------------- Radar_x1 --------------------------------------------
    Radar_x1 = get_ini_value(Datei); 
//---------------------- Radar_y1 --------------------------------------------
    Radar_y1 = get_ini_value(Datei); 
//---------------------- radar_akt -------------------------------------------
    radar_akt = get_ini_value(Datei); i= 0;
//---------------------- karte -----------------------------------------------
  memset(karte, 0, 13); while ( fgetc(Datei) != '=' ); while ( (karte[i++] = fgetc(Datei)) != ':');
  karte[--i] = 0x00;

  fclose(Datei);
}


/****************************************************************************/
/* Wertet die NUM-Datei aus, und setzt die dazugehrigen Variablen          */
/* ------------------------------------------------------------------------ */
/* Keine Parameter.                                                         */
/****************************************************************************/
void load_num ( void )
{
  FILE *Datei;

  if ( (Datei = fopen("mann.num", "rb")) == NULL )
  {
    Screen_On(); textmodus();
    printf("\n\nERROR: Kann 'mann.num' nicht laden!\n\n");
    exit(0);
  }
//----------------------L_ANFANG ---------------------------------------------
   L_ANFANG = get_ini_value(Datei);
   L_LANG   = get_ini_value(Datei);
//----------------------R_ANFANG ---------------------------------------------
   R_ANFANG = get_ini_value(Datei);
   R_LANG   = get_ini_value(Datei);
//----------------------O_ANFANG ---------------------------------------------
   O_ANFANG = get_ini_value(Datei);
   O_LANG   = get_ini_value(Datei);
//----------------------U_ANFANG ---------------------------------------------
   U_ANFANG = get_ini_value(Datei);
   U_LANG   = get_ini_value(Datei);
//----------------------LO_ANFANG ---------------------------------------------
   LO_ANFANG = get_ini_value(Datei);
   LO_LANG   = get_ini_value(Datei);
//----------------------LU_ANFANG ---------------------------------------------
   LU_ANFANG = get_ini_value(Datei);
   LU_LANG   = get_ini_value(Datei);
//----------------------RO_ANFANG ---------------------------------------------
   RO_ANFANG = get_ini_value(Datei);
   RO_LANG   = get_ini_value(Datei);
//----------------------RU_ANFANG ---------------------------------------------
   RU_ANFANG = get_ini_value(Datei);
   RU_LANG   = get_ini_value(Datei);


//----------------------MANN_DIV ---------------------------------------------
   MANN_DIV = get_ini_value(Datei);

//----------------------ANGRIF_L ---------------------------------------------
  ANGRIF_L  = get_ini_value(Datei);
  ANGRIF_LL = get_ini_value(Datei);
//----------------------ANGRIF_R ---------------------------------------------
  ANGRIF_R  = get_ini_value(Datei);
  ANGRIF_RL = get_ini_value(Datei);
//----------------------ANGRIF_O ---------------------------------------------
  ANGRIF_O  = get_ini_value(Datei);
  ANGRIF_OL = get_ini_value(Datei);
//----------------------ANGRIF_U ---------------------------------------------
  ANGRIF_U  = get_ini_value(Datei);
  ANGRIF_UL = get_ini_value(Datei);
//----------------------ANGRIF_LO ---------------------------------------------
  ANGRIF_LO  = get_ini_value(Datei);
  ANGRIF_LOL = get_ini_value(Datei);
//----------------------ANGRIF_LU ---------------------------------------------
  ANGRIF_LU  = get_ini_value(Datei);
  ANGRIF_LUL = get_ini_value(Datei);
//----------------------ANGRIF_RO ---------------------------------------------
  ANGRIF_RO  = get_ini_value(Datei);
  ANGRIF_ROL = get_ini_value(Datei);
//----------------------ANGRIF_RU ---------------------------------------------
  ANGRIF_RU  = get_ini_value(Datei);
  ANGRIF_RUL = get_ini_value(Datei);
//----------------------FL_ANFANG ---------------------------------------------
  FL_ANFANG  = get_ini_value(Datei);
//----------------------FR_ANFANG ---------------------------------------------
  FR_ANFANG  = get_ini_value(Datei);
//----------------------FO_ANFANG ---------------------------------------------
  FO_ANFANG  = get_ini_value(Datei);
//----------------------FU_ANFANG ---------------------------------------------
  FU_ANFANG  = get_ini_value(Datei);



//----------------------F1S1_A ------------------------------------------------
  F1S1_A     = get_ini_value(Datei);
  F1S1_L     = get_ini_value(Datei);
//----------------------F3S1_A ------------------------------------------------
  F3S1_A     = get_ini_value(Datei);
  F3S1_L     = get_ini_value(Datei);
//----------------------F3S2_A ------------------------------------------------
  F3S2_A     = get_ini_value(Datei);
  F3S2_L     = get_ini_value(Datei);
//----------------------M1S1_A ------------------------------------------------
  M1S1_A     = get_ini_value(Datei);
  M1S1_L     = get_ini_value(Datei);
//----------------------F3S1_A ------------------------------------------------
  M3S1_A     = get_ini_value(Datei);
  M3S1_L     = get_ini_value(Datei);
//----------------------F3S2_A ------------------------------------------------
  M3S2_A     = get_ini_value(Datei);
  M3S2_L     = get_ini_value(Datei);



  fclose(Datei);
}


/****************************************************************************/
/* Beendet das Spiel.                                                       */
/* ------------------------------------------------------------------------ */
/* keine Parameter                                                          */
/****************************************************************************/
void quit ( void )
{
  CD_Ende();
  textmodus();
  printf("Copyright (c) 1996 PCX-Brothers Entertainment\n");
  printf("Alle Rechte vorbehalten.\n");
  printf("\nDu hast diese Zeit verloren!\n");
  exit(0);
}



void show_fb_menu ( BYTE index )
{
   m_show_image = 1;
   m_back_restore();
   fill_box(80, 70, 200, 120, 240);
   fill_box(82, 72, 198, 81, 242); write(112, 75, "Mann-Fabrik", 255); write(111, 74, "Mann-Fabrik", 254); 
   if ( FB[index].time != 100000 ) { fill_box(150,84, 197, 90, 250);  write(162, 85, "Baue", 254); }
   else { fill_box(150,84, 197, 90, 253);  write(156, 85, "Bereit", 254); }
   draw_box(82, 84, 147, 105, 255);
   button_down(82, 107, 65, "Goder");

   button_up(150, 95,  47, "OK");
   button_up(150, 107, 47, "Ende");

   m_back_save();
   cpy2screen();

   while ( m_taste != 7 )
   {
     maus_pos(); maus_show();              // Mauspos. berechnen, und anzeigen
     
     if ( m_taste == 1 )
     {
       if ( maus_innen(150, 95, 197, 105) ) { button_punch(150, 95, 47, "OK"); FB[index].time =  2000; m_back_save(); return; }
       if ( maus_innen(150,107, 197, 117) ) { button_punch(150,107, 47, "Ende"); m_back_save(); return; }
     }

     cpy2screen();
   }

}

void Line( int x1, int y1, int x2, int y2, BYTE farbe )
{
 int d, dx, dy, aincr, bincr, xincr, yincr, x, y, swp;

 if ( abs((x2-x1)) < abs((y2-y1)) )       
  {
    if ( y1 > y2 )                                    
    {
     swp=x1; x1=x2; x2=swp;
     swp=y1; y1=y2; y2=swp;
    }

   xincr = ( x2 > x1 ) ?  1 : -1;       

   dy = y2 - y1;
   dx = abs( x2-x1 );
   d  = 2 * dx - dy;
   aincr = 2 * (dx - dy);
   bincr = 2 * dx;
   x = x1;
   y = y1;

   if ( (x<Mrechts)&&(x>Mlinks)&&(y<Munten)&&(y>Moben) ) vsetpix(x, y, farbe, res_x);                      
   for (y=y1+1; y<= y2; ++y )         
    {
     if ( d >= 0 )
      {
       x += xincr;
       d += aincr;
      }
     else
      d += bincr;
      if ( (x<Mrechts)&&(x>Mlinks)&&(y<Munten)&&(y>Moben) ) vsetpix(x, y, farbe, res_x);
    }
  }
 else                                             
  {
   if ( x1 > x2 )
   {
     swp=x1; x1=x2; x2=swp;
     swp=y1; y1=y2; y2=swp;
    }

   yincr = ( y2 > y1 ) ? 1 : -1;         

   dx = x2 - x1;
   dy = abs( y2-y1 );
   d  = 2 * dy - dx;
   aincr = 2 * (dy - dx);
   bincr = 2 * dy;
   x = x1;
   y = y1;

   if ( (x<Mrechts)&&(x>Mlinks)&&(y<Munten)&&(y>Moben) ) vsetpix(x, y, farbe, res_x);                        
   for (x=x1+1; x<=x2; ++x )          
    {
     if ( d >= 0 )
      {
       y += yincr;
       d += aincr;
      }
     else
      d += bincr;
     if ( (x<Mrechts)&&(x>Mlinks)&&(y<Munten)&&(y>Moben) ) vsetpix(x, y, farbe, res_x);
    }
  } 
}


