typedef unsigned char BYTE;
typedef unsigned WORD;
typedef struct                        /* Informationen fr XMS-Aufruf */
{
	  WORD AX,              /* nur die Register AX, BX, DX und SI */
	       BX,              /* werden je nach aufgerufener Funk-  */
	       DX,              /* tion bentigt, dazu noch eine Seg- */
	       SI,              /* mentadresse                        */
	       Segment;
} XMSRegs;

typedef struct                        /* eine extended-Memory-Move-Struktur */
{
	  long LenB;                             /* Anzahl zu versch. Bytes */
	  int  SHandle;                                    /* Source-Handle */
	  long SOffset;                                    /* Source-Offset */
	  int  DHandle;                               /* Destination-Handle */
	  long DOffset;                               /* Destination-Offset */
} EMMS;

typedef struct
{
	  BYTE shape, back, akt;
	  int del;
	  int x, y;
	  int ax, ay;
	  int dx, dy, dx1, dy1;
} MANN;

BYTE Feld [40] [30] = { 1, 0, 0, 0, 1, 0, 1, 0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
			0, 0, 1, 0, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
			1, 1, 0, 0, 1, 0, 1, 0, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
			0, 1, 0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
			1, 0, 1, 0, 1, 0, 3, 4, 5, 0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
			0, 1, 0, 0, 0, 0, 6, 7, 8, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
			0, 0, 0, 0, 0, 0, 0, 2, 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
			0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
			0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
			0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
			0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
			0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
			0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
			0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
			0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
			0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
			0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
			0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
			0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
			0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
			0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
			0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
			0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
			0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
			0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
			0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
			0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
			0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
			0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
			0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
			0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
			0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
			0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
			0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
			0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
			0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
			0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
			0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
			0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
			0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };


char m_images[7][120] =
{
		    { 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
		      0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
		      0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
		      0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
		      0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
		      0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
		      0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
		      0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
		      0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
		      0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
		      0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
		      0,  0,  0,  0,  0,  0,  0,  0,  0,  0, },
		    { 255,  0,  0,  0,  0,  0,  0,  0,  0,  0,
		      255,255,  0,  0,  0,  0,  0,  0,  0,  0,
		      255,254,255,  0,  0,  0,  0,  0,  0,  0,
		      255,254,254,255,  0,  0,  0,  0,  0,  0,
		      255,254,254,254,255,  0,  0,  0,  0,  0,
		      255,254,254,254,254,255,  0,  0,  0,  0,
		      255,254,254,254,254,254,255,  0,  0,  0,
		      255,254,254,254,254,254,254,255,  0,  0,
		      255,254,254,254,254,254,254,254,255,  0,
		      255,254,254,254,254,254,255,255,  0,  0,
		      255,254,254,255,255,255,  0,  0,  0,  0,
		      255,255,255,  0,  0,  0,  0,  0,  0,  0   },
		   {  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
		      0,  0,  0,  0,  0,  255,255,  0,  0,  0,
		      0,  0,  0,  0,  255,254,255,  0,  0,  0,
		      0,  0,  0,  255,254,254,255,  0,  0,  0,
		      0,  0,  255,254,254,254,255,255,255,255,
		      0,  255,254,254,254,254,254,254,254,255,
		      255,254,254,254,254,254,254,254,254,255,
		      0,  255,254,254,254,254,254,254,254,255,
		      0,  0,  255,254,254,254,255,255,255,255,
		      0,  0,  0,  255,254,254,255,  0,  0,  0,
		      0,  0,  0,  0,  255,254,255,  0,  0,  0,
		      0,  0,  0,  0,  0,  255,255,  0,  0,  0   },
		   {  0,  0,  0,  0,255,  0,  0,  0,  0,  0,
		      0,  0,  0,255,254,255,  0,  0,  0,  0,
		      0,  0,255,254,254,254,255,  0,  0,  0,
		      0,255,254,254,254,254,254,255,  0,  0,
		    255,254,254,254,254,254,254,254,255,  0,
		    255,255,255,254,254,254,255,255,255,  0,
		      0,  0,255,254,254,254,255,  0,  0,  0,
		      0,  0,255,255,255,255,255,  0,  0,  0,
		      0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
		      0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
		      0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
		      0,  0,  0,  0,  0,  0,  0,  0,  0,  0   },
		   {  0,  0,255,255,255,255,255,  0,  0,  0,
		      0,  0,255,254,254,254,255,  0,  0,  0,
		    255,255,255,254,254,254,255,255,255,  0,
		    255,254,254,254,254,254,254,254,255,  0,
		      0,255,254,254,254,254,254,255,  0,  0,
		      0,  0,255,254,254,254,255,  0,  0,  0,
		      0,  0,  0,255,254,255,  0,  0,  0,  0,
		      0,  0,  0,  0,255,  0,  0,  0,  0,  0,
		      0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
		      0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
		      0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
		      0,  0,  0,  0,  0,  0,  0,  0,  0,  0  },
		   {  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
		      0,  0,  0,255,255,  0,  0,  0,  0,  0,
		      0,  0,  0,255,254,255,  0,  0,  0,  0,
		      0,  0,  0,255,254,254,255,  0,  0,  0,
		    255,255,255,255,254,254,254,255,  0,  0,
		    255,254,254,254,254,254,254,254,255,  0,
		    255,254,254,254,254,254,254,254,254,255,
		    255,254,254,254,254,254,254,254,255,  0,
		    255,255,255,255,254,254,254,255,  0,  0,
		      0,  0,  0,255,254,254,255,  0,  0,  0,
		      0,  0,  0,255,254,255,  0,  0,  0,  0,
		      0,  0,  0,255,255,  0,  0,  0,  0,  0 },
		   {  251,251,251,251,251,251,251,251,251,251,
		      251,  2,  2,  2,  2,  2,  2,  2,  2,251,
		      251,  2,  2,  2,  2,  2,  2,  2,  2,251,
		      251,  2,  2,  2,  2,  2,  2,  2,  2,251,
		      251,  2,  2,  2,  2,  2,  2,  2,  2,251,
		      251,  2,  2,  2,251,251,  2,  2,  2,251,
		      251,  2,  2,  2,251,251,  2,  2,  2,251,
		      251,  2,  2,  2,  2,  2,  2,  2,  2,251,
		      251,  2,  2,  2,  2,  2,  2,  2,  2,251,
		      251,  2,  2,  2,  2,  2,  2,  2,  2,251,
		      251,  2,  2,  2,  2,  2,  2,  2,  2,251,
		      251,251,251,251,251,251,251,251,251,251 }
};
/*-------------------------- Externe Funktionen ----------------------------*/
extern void XMSCall( BYTE FktNr, XMSRegs *Xr );
extern void WaitRetrace ( void );
extern int  XMSInit( void );
extern void XMSQueryFree( int * GesFrei, int * MaxBl );
extern int  XMSGetMem( int LenKb );
extern void XMSFreeMem( int Handle );
extern void XMSCopy( int VonHandle, long VonOffset, int NachHandle, long NachOffset, long LenW );
extern long XMSLock( int Handle );
extern void XMSUnlock( int Handle );
extern void textmodus();
extern void move_down ( void );
