//**************************************************************************//
// Das hier wird die DEFKON17 Konvertierung auf WATCOM C                    //
// -----------------------------------------------------                    //
// von Stephan Meiner                                                      //
// ab 25. Mrz 1996                                                         //
//**************************************************************************//
#include <stdio.h>
#include <conio.h>
#include <graph.h>
#include <dos.h>
#include <i86.h>
#include <mem.h>
#include <bios.h>
#include <gfklib.h>
#include <pcxlib.h>
#include <maus.h>
#include <font.h>
#include <defkon.h>

#define STRG    36
#define M0      0
#define M1      4
#define M2      10
#define M3      17
#define M4      24
#define Mlinks   73
#define Mrechts 315
#define Moben    11
#define Munten  191

int x_lang, y_breit;

void main ( int argc, char *argv[] )
{
  BYTE i;

  if ( argc != 2 ) i=1;
  init_Spiel(); 
  if ( i == 1) load_map("new.map");
  else load_map(argv[1]);

  menu();

  quit();
}


void spiel ( void )
{
  int i=0, j;
  union REGS regs; char c, pal[768];

  Screen_Off();
  load_PCX("mr-003.dbl"); Set_Overscan_Color(0); 
  Landschaft(0, 0);
  cpy2screen(); Screen_On();

  while ( m_taste != 7 )                                  // sinnlose Abfrage
  {
    m_show_image= 1;
    if (go) m_show_image= 6;
    maus_pos(); maus_show();

    if ( m_taste == 1 ) maus_links();
    if ( m_taste == 2 ) maus_rechts();

    if ( kbhit() )
    {
      c = getch();
      if ( c == 27 ) { fade_out(); return; }
      if ( c == 45 ) { mann_del+=4; }                                // -
      if ( c == 43 ) { if ( mann_del > 4 ) mann_del-=4; }            // +
      if ( c == 47 ) { scroll_del+=4; }                              // /
      if ( c == 42 ) { if ( scroll_del > 4 ) scroll_del-=4; }        // *
      if ( c ==  8 ) { scroll_del = ss_del; mann_del = sm_del; }     // bs
      if ( c ==109 ) { if ( MannAnzahl > -1 ) { mann_back_restore(0); MannDelete(0); }}
      if ( c ==102 ) { if ( FeindAnzahl > -1 ) { feind_back_restore(0); FeindDelete(0); }}
      if ( c == 13 )
      {
        m_back_restore();
        MannInsert((f_x*20)+m_x, (f_y*20)+m_y, 0, 0); mann_set(MannAnzahl); m_back_save(); m_place();
      }
      if ( c == 32 )
      {
        m_back_restore();
        FeindInsert((f_x*20)+m_x, (f_y*20)+m_y, 0, 0); feind_set(FeindAnzahl); m_back_save(); m_place();
      }
    }
    memset(MoveListe, 0, MannAnzahl+1); 
    //-------------------------------------------------------------------
    if ( (m_y>180)&&(f_y<FELD_Y) ) { scroll_down();  delay(scroll_del); }
    if ( (m_y< 10)&&(f_y>0) )      { scroll_up();    delay(scroll_del); }
    if ( (m_x>310)&&(f_x<FELD_X) ) { scroll_right(); delay(scroll_del); }
    if ( (m_x< 10)&&(f_x>0) )      { scroll_left();  delay(scroll_del); }
    //-------------------------------------------------------------------

    if ( MannAnzahl > -1 )
    {
      m_back_restore();
      for ( i=0; i<MannAnzahl+1; i++ )
      {
        Mann_compute(i);
        if ( MoveListe[i] == 1 )
        {
          Mann_back_restore(i);
          if ( AktListe[i] ) mann_akt_set(i);
          else mann_set(i);
          ML[i].x1 = ML[i].x; ML[i].y1 = ML[i].y;
        }
      }
      m_back_save(); m_place();
    }

    if ( FeindAnzahl > -1 )
    {
      m_back_restore();
      for ( i=0; i<FeindAnzahl+1; i++ )
      {
        Feind_compute(i);
        if ( MoveListe[200+i] == 1 )
        {
          feind_back_restore(i);
          feind_set(i);
          FL[i].x1 = FL[i].x; FL[i].y1 = FL[i].y;
        }
      }
      m_back_save(); m_place();
    }

    if ( screen_refresh ) { wait_retrace(); cpy2screen(); }
  }

}


void menu ( void )
{
  char c;

  Screen_Off();
  m_back_restore();
  load_PCX("dg-03.dbl"); Set_Overscan_Color(0);
  write(109, 103, "neues spiel beginnen", 254);
  write(129, 127, "spiel laden", 254);
  write(136, 152, "credits", 254);
  write(124, 178, "spiel beenden", 254);

  write(245, 178, "alpha", 223);

  m_back_save(); m_place();
  cpy2screen(); Screen_On();

  while ( m_taste != 7 )                                  // sinnlose Abfrage
  {
    m_show_image= 1; maus_pos(); maus_show();

    if ( m_taste == 1 ) menu_maus_links();
    if ( kbhit() )
    {
      c = getch();
      if ( c == 27 ) quit();
    }
    if ( screen_refresh ) { wait_retrace(); cpy2screen(); }
  }

}

void menu_maus_links ( void )
{
  if ( (m_x>83)&&(m_x<237)&&(m_y>99)&&(m_y<109) )
  {
     m_back_restore();
     write(109, 103, "neues spiel beginnen", 93);
     button_down(83, 100, 154); wait_retrace(); cpy2screen();
     while ( m_taste == 1 ) { maus_pos(); maus_show(); }
     button_up(83, 100, 154); write(109, 103, "neues spiel beginnen", 254);
     m_back_save(); m_place(); fade_out();
     spiel();
     menu();
  }
}


void button_down ( int x, int y, int lang )
{
  int i;

  screen_refresh= 1;

  vsetpix(x, y+1, 250); vsetpix(x+lang-3, y+1, 250);
  vsetpix(x, y+9, 251); vsetpix(x+lang-3, y+9, 251);

  for ( i=(x-1); i<(x+lang-1); i++ ) vsetpix(i, y, 250);         // oben
  for ( i=(x-1); i<(x+lang-1); i++ ) vsetpix(i, y+10, 251);      // unten
  for ( i=y+1; i<y+11; i++ ) vsetpix(x-1, i, 251);               // links
  for ( i=y; i<y+10; i++ ) vsetpix(x+lang-2, i, 250);            // rechts
}

void button_up ( int x, int y, int lang )
{
  int i;

  screen_refresh= 1;

  vsetpix(x, y+1, 251); vsetpix(x+lang-3, y+1, 251);
  vsetpix(x, y+9, 250); vsetpix(x+lang-3, y+9, 250);

  for ( i=(x-1); i<(x+lang-1); i++ ) vsetpix(i, y, 251);
  for ( i=(x-1); i<(x+lang-1); i++ ) vsetpix(i, y+10, 250);
  for ( i=y+1; i<y+11; i++ ) vsetpix(x-1, i, 250);
  for ( i=y; i<y+10; i++ ) vsetpix(x+lang-2, i, 251);
}


void maus_links ( void )
{
  int i, j, keyb_flag=0;
  union REGS regs;

  regs.h.ah = 0x02; int386( 0x16, &regs, &regs );
  regs.h.ah = 0x00; keyb_flag = regs.x.ax;

  if ( (m_x>73)&&(m_x<314)&&(m_y>10)&&(m_y<191) )
  {
    for ( i=0; i<MannAnzahl+1; i++ )
    {
      if ( (m_x>ML[i].x-15)&&(m_x<ML[i].x+15)&&(m_y>ML[i].y-15)&&(m_y<ML[i].y+15) )
      {
        if ( keyb_flag != STRG )
        {
          for ( j=0; j<MannAnzahl+1; j++ )
            if ( AktListe[j] )
            {
               mann_back_restore(j); mann_set(j); AktListe[j]=0;
            } 
        }
        AktListe[i] = 1; m_show_image=6; go=1;
        m_back_restore(); mann_back_restore(i); mann_akt_set(i); m_back_save(); m_place();
        m_taste= 0; return;
      }
    }
    for ( i=0; i<MannAnzahl+1; i++ )
    {
      if ( (AktListe[i])&&(!ML[i].type) ) { ML[i].dx = (f_x*20)+m_x-10; ML[i].dy = (f_y*20)+m_y-10; }
    }
  }
}

void maus_rechts ( void )
{
  int i;

  for ( i=0; i<MannAnzahl+1; i++ )
  {
    if ( AktListe[i] ) { mann_back_restore(i); mann_set(i); }
    AktListe[i] = 0;
  }
  go=0;
}

void load_map ( char MapName[127] )
{
  FILE *Datei;
  int i, j;

  chdir(".."); chdir("map");

  Datei = fopen(MapName, "rb");
  FELD_X = fgetc(Datei); FELD_Y = fgetc(Datei); x_lang = fgetc(Datei); y_breit = fgetc(Datei)+1;
  for (i=0; i<y_breit+1; i++ )
  {
    for (j=0; j<x_lang+1; j++ ) Feld[i][j] = fgetc(Datei);
  }
  fclose(Datei);

  chdir(".."); chdir("data");
}

void load_ini ( void )
{
  FILE *Datei;
  char ini[3];
  int i;

  Datei = fopen("defkon.ini", "rb"); i= 0;
  memset(ini, 32, 3); while ( fgetc(Datei) != '=' ); while ( (ini[i++] = fgetc(Datei)) != '.');
    scroll_del = atoi(ini);
  memset(ini, 32, 3); while ( fgetc(Datei) != '=' ); while ( (ini[i++] = fgetc(Datei)) != '.');
    mann_del = atoi(ini);
  fclose(Datei);
}


/****************************************************************************/
/* Beendet das Spiel.                                                       */
/* ------------------------------------------------------------------------ */
/* keine Parameter                                                          */
/****************************************************************************/
void quit ( void )
{
  fade_out();
  chdir("..");
  textmodus();
  printf("Du hast diese Zeit verloren!\n");
  exit(0);
}



/****************************************************************************/
/* "Erschafft" einen neuen Mann.                                            */
/* ------------------------------------------------------------------------ */
/* Parameter: globale Koordinaten und das momentane Aussehen.               */
/****************************************************************************/
int MannInsert ( int ax, int ay, BYTE shape, BYTE type )
{

  MannAnzahl++;
  MannListe[MannAnzahl].del     = 0;
  MannListe[MannAnzahl].x       = ax-(f_x*20);
  MannListe[MannAnzahl].y       = ay-(f_y*20);
  MannListe[MannAnzahl].x1      = ax-(f_x*20);
  MannListe[MannAnzahl].y1      = ay-(f_y*20);
  MannListe[MannAnzahl].ax      = ax;
  MannListe[MannAnzahl].ay      = ay;
  MannListe[MannAnzahl].dx      = ax;
  MannListe[MannAnzahl].dy      = ay;
  MannListe[MannAnzahl].shape   = shape;
  MannListe[MannAnzahl].energie = 10;
  MannListe[MannAnzahl].type    = type;
  MannListe[MannAnzahl].back    = MannAnzahl*400;
  AktListe[MannAnzahl]          = 0;

  return 1;
}

void MannDelete( BYTE index )
{
  int i;

  for ( i=index; i<MannAnzahl; i++ ) ML[i] = ML[i+1];
  memmove(&MannBack[index*400], &MannBack[(index+1)*400], (MannAnzahl-index)*400);
  MannAnzahl--;
}
  

/****************************************************************************/
/* "Erschafft" einen neuen Feind.                                           */
/* ------------------------------------------------------------------------ */
/* Parameter: globale Koordinaten und das momentane Aussehen.               */
/****************************************************************************/
int FeindInsert ( int ax, int ay, BYTE shape, BYTE type )
{

  FeindAnzahl++;
  FL[FeindAnzahl].del     = 0;
  FL[FeindAnzahl].x       = ax-(f_x*20);
  FL[FeindAnzahl].y       = ay-(f_y*20);
  FL[FeindAnzahl].x1      = ax-(f_x*20);
  FL[FeindAnzahl].y1      = ay-(f_y*20);
  FL[FeindAnzahl].ax      = ax;
  FL[FeindAnzahl].ay      = ay;
  FL[FeindAnzahl].dx      = ax;
  FL[FeindAnzahl].dy      = ay;
  FL[FeindAnzahl].shape   = shape;
  FL[FeindAnzahl].energie = 10;
  FL[FeindAnzahl].type    = type;
  FL[FeindAnzahl].back    = FeindAnzahl*400;

  return 1;
}

void FeindDelete( BYTE index )
{
  int i;

  for ( i=index; i<FeindAnzahl; i++ ) FL[i] = FL[i+1];
  memmove(&FeindBack[index*400], &FeindBack[(index+1)*400], (FeindAnzahl-index)*400);
  FeindAnzahl--;
}


void Mann_back_restore ( BYTE index )
{
  int i, j, h=index*400;

  for ( i=0; i<20; i++ )
  {
    for ( j=0; j<20; j++ )
    {
      if ( ((ML[index].x1+j)<Mrechts)&&((ML[index].x1+j)>Mlinks)&&((ML[index].y1+i)>Moben)&&((ML[index].y1+i)<Munten) )
        vsetpix(ML[index].x1+j, ML[index].y1+i, MannBack[h]);
      h++;
    }
  }

}

void Mann_set ( BYTE index )
{
  int i, j, h=index*400, k=ML[index].shape*400;

  for ( i=0; i<20; i++ )
  {
    for ( j=0; j<20; j++ )
    {
      if ( ((ML[index].x1+j)<Mrechts)&&((ML[index].x1+j)>Mlinks)&&((ML[index].y1+i)>Moben)&&((ML[index].y1+i)<Munten) )
      {
        MannBack[h] = vgetpix( ML[index].x+j, ML[index].y+i);
        if ( ((MannData[k]>5)&&(MannBack[h]<38)) ) vsetpix( ML[index].x+j, ML[index].y+i, MannData[k]); 
      }
    h++; k++;
    }
  }
}


void Feind_back_restore ( BYTE index )
{
  int i, j, h=index*400;

  for ( i=0; i<20; i++ )
  {
    for ( j=0; j<20; j++ )
    {
      if ( ((FL[index].x1+j)<Mrechts)&&((FL[index].x1+j)>Mlinks)&&((FL[index].y1+i)>Moben)&&((FL[index].y1+i)<Munten) )
        vsetpix(FL[index].x1+j, FL[index].y1+i, FeindBack[h]);
      h++;
    }
  }

}

void Feind_set ( BYTE index )
{
  int i, j, h=index*400, k=FL[index].shape*400;

  for ( i=0; i<20; i++ )
  {
    for ( j=0; j<20; j++ )
    {
      if ( ((FL[index].x1+j)<Mrechts)&&((FL[index].x1+j)>Mlinks)&&((FL[index].y1+i)>Moben)&&((FL[index].y1+i)<Munten) )
      {
        FeindBack[h] = vgetpix( FL[index].x+j, FL[index].y+i);
        if ( ((MannData[k]>5)&&(FeindBack[h]<38)) ) vsetpix( FL[index].x+j, FL[index].y+i, MannData[k]); 
      }
    h++; k++;
    }
  }
}

void Mann_akt_set ( BYTE index )
{
  int i, j, h=index*400, k=ML[index].shape*400;

  for ( i=0; i<20; i++ )
  {
    for ( j=0; j<20; j++ )
    {
      if ( ((ML[index].x+j)<Mrechts)&&((ML[index].x+j)>Mlinks)&&((ML[index].y+i)>Moben)&&((ML[index].y+i)<Munten) )
      {
        MannBack[h] = vgetpix( ML[index].x+j, ML[index].y+i);
        if ( ((MannData[k]>5)&&(MannBack[h]<38)) ) vsetpix( ML[index].x+j, ML[index].y+i, MannData[k]); 
      }
    h++; k++;
    }
  }
  //---------------------------- Y-Werte ------------------------------
  for ( i= 2; i< 6; i++ ) if ( ((ML[index].x+i)<315)&&((ML[index].x+i)>79)&&((ML[index].y+ 1)>0)&&((ML[index].y+ 1)<200) ) vsetpix(ML[index].x+i, ML[index].y+1,  254);
  for ( i=14; i<18; i++ ) if ( ((ML[index].x+i)<315)&&((ML[index].x+i)>79)&&((ML[index].y+ 1)>0)&&((ML[index].y+ 1)<200) ) vsetpix(ML[index].x+i, ML[index].y+1,  254);
  for ( i= 2; i< 6; i++ ) if ( ((ML[index].x+i)<315)&&((ML[index].x+i)>79)&&((ML[index].y+15)>0)&&((ML[index].y+15)<200) ) vsetpix(ML[index].x+i, ML[index].y+15, 254);
  for ( i=14; i<18; i++ ) if ( ((ML[index].x+i)<315)&&((ML[index].x+i)>79)&&((ML[index].y+15)>0)&&((ML[index].y+15)<200) ) vsetpix(ML[index].x+i, ML[index].y+15, 254);
  //---------------------------- X-Werte ------------------------------
  for ( i= 2; i< 6; i++ ) if ( ((ML[index].x+ 2)<315)&&((ML[index].x+ 2)>79)&&((ML[index].y+i)>0)&&((ML[index].y+i)<200) ) vsetpix(ML[index].x+2,  ML[index].y+i,  254);
  for ( i=12; i<16; i++ ) if ( ((ML[index].x+ 2)<315)&&((ML[index].x+ 2)>79)&&((ML[index].y+i)>0)&&((ML[index].y+i)<200) ) vsetpix(ML[index].x+2,  ML[index].y+i,  254);
  for ( i= 2; i< 6; i++ ) if ( ((ML[index].x+17)<315)&&((ML[index].x+17)>79)&&((ML[index].y+i)>0)&&((ML[index].y+i)<200) ) vsetpix(ML[index].x+17, ML[index].y+i,  254);
  for ( i=12; i<16; i++ ) if ( ((ML[index].x+17)<315)&&((ML[index].x+17)>79)&&((ML[index].y+i)>0)&&((ML[index].y+i)<200) ) vsetpix(ML[index].x+17, ML[index].y+i,  254);
}

void Mann_compute ( BYTE index )
{
  int i;
  BYTE links=0, rechts=0;

  if ( MannListe[index].del >= mann_del-MannListe[index].energie )    // Ist der Mann berhaupt an der Reihe
  {
    MannListe[index].del = 0;
//------------------------------ Nach RECHTS --------------------------------
    if ( MannListe[index].ax < MannListe[index].dx )
    {
      MannListe[index].ax+=1; MannListe[index].x+=1;
      if ( MannListe[index].shape < M1+2 ) MannListe[index].shape = M1+2;
      if ( MannListe[index].shape > M2   ) MannListe[index].shape = M1+2;
      MannListe[index].shape++; rechts= 1; MoveListe[index] = 1;
    }
//------------------------------ Nach LINKS ---------------------------------
    if ( MannListe[index].ax > MannListe[index].dx )
    {
      MannListe[index].ax-=1; MannListe[index].x-=1;
      if ( MannListe[index].shape > M1 ) MannListe[index].shape = M0;
      MannListe[index].shape++; links= 1; MoveListe[index] = 1;
    }
//------------------------------ Nach UNTEN ---------------------------------
    if ( MannListe[index].ay < MannListe[index].dy )
    {
      MannListe[index].ay+=1; MannListe[index].y+=1;
      if ( MannListe[index].shape < M3+1 ) MannListe[index].shape = M3+1;
      if ( MannListe[index].shape > M4 ) MannListe[index].shape = M3+1;
      MannListe[index].shape++; MoveListe[index] = 1;
      if ( links ==  1 ) ML[index].shape=M4+3;
      if ( rechts == 1 ) ML[index].shape=M4+5;
    }
//------------------------------ Nach OBEN ----------------------------------
    if ( MannListe[index].ay > MannListe[index].dy )
    {
      MannListe[index].ay-=1; MannListe[index].y-=1;
      if ( MannListe[index].shape < M2+1 ) MannListe[index].shape = M2+1;
      if ( MannListe[index].shape > M3 ) MannListe[index].shape = M2+1;
      MannListe[index].shape++; MoveListe[index] = 1;
      if ( links ==  1 ) ML[index].shape=M4+2;
      if ( rechts == 1 ) ML[index].shape=M4+4;
    }

    if ( (!MoveListe[index])&&(ML[index].shape>0) )
    {
      if ( ML[index].shape<M1+2 ) ML[index].shape=0;
      if ( ML[index].shape>M1+2 ) ML[index].shape=M1+2;
      MoveListe[index]= 1;
    }
  }
  if ( (m_x>ML[index].x-15)&&(m_x<ML[index].x+15)&&(m_y>ML[index].y-15)&&(m_y<ML[index].y+15)&&(!AktListe[index]) ) m_show_image=7;
  
  MannListe[index].del++;
}



void Feind_compute ( BYTE index )
{
  int i;
  BYTE links=0, rechts=0;

  if ( FL[index].del >= (mann_del+15)-FL[index].energie )    // Ist der Mann berhaupt an der Reihe
  {
    FL[index].del = 0;
//------------------------------ Nach RECHTS --------------------------------
    if ( FL[index].ax < ML[index].ax )
    {
      FL[index].ax+=1; FL[index].x+=1;
      if ( FL[index].shape < M1+2 ) FL[index].shape = M1+2;
      if ( FL[index].shape > M2   ) FL[index].shape = M1+2;
      FL[index].shape++; rechts= 1; MoveListe[200+index] = 1;
    }
//------------------------------ Nach LINKS ---------------------------------
    if ( FL[index].ax > ML[index].ax )
    {
      FL[index].ax-=1; FL[index].x-=1;
      if ( FL[index].shape > M1 ) FL[index].shape = M0;
      FL[index].shape++; links= 1; MoveListe[200+index] = 1;
    }
//------------------------------ Nach UNTEN ---------------------------------
    if ( FL[index].ay < ML[index].ay )
    {
      FL[index].ay+=1; FL[index].y+=1;
      if ( FL[index].shape < M3+1 ) FL[index].shape = M3+1;
      if ( FL[index].shape > M4 ) FL[index].shape = M3+1;
      FL[index].shape++; MoveListe[200+index] = 1;
      if ( links ==  1 ) FL[index].shape=M4+3;
      if ( rechts == 1 ) FL[index].shape=M4+5;
    }
//------------------------------ Nach OBEN ----------------------------------
    if ( FL[index].ay > ML[index].ay )
    {
      FL[index].ay-=1; FL[index].y-=1;
      if ( FL[index].shape < M2+1 ) FL[index].shape = M2+1;
      if ( FL[index].shape > M3 ) FL[index].shape = M2+1;
      FL[index].shape++; MoveListe[200+index] = 1;
      if ( links ==  1 ) FL[index].shape=M4+2;
      if ( rechts == 1 ) FL[index].shape=M4+4;
    }

    if ( (!MoveListe[200+index])&&(FL[index].shape>0) )
    {
      if ( FL[index].shape<M1+2 ) FL[index].shape=0;
      if ( FL[index].shape>M1+2 ) FL[index].shape=M1+2;
      MoveListe[200+index]= 1;
    }
  }
  if ( (m_x>FL[index].x-15)&&(m_x<FL[index].x+15)&&(m_y>FL[index].y-15)&&(m_y<FL[index].y+15)&&(!AktListe[index]) ) m_show_image=7;
  
  FL[index].del++;
}



