#include <stdio.h>
#include <conio.h>
#include <dos.h>
#include <graph.h>
#include <stdlib.h>

#define VGA                             1
#define SVGA                            2
#define byte                            BYTE
#define word                            WORD
#define setpix(x,y,c,r)                 Screen[(y)*r+(x)]=(c)
#define vsetpix(x,y,c,r)                VScreen[((y)*r)+(x)]=(c)
#define getpix(x,y,r)                   Screen[(y)*r+(x)]
#define vgetpix(x,y,r)                  VScreen[((y)*r)+(x)]
#define out_Sequencer(index,value)      { outp(0x3c4,index); outp(0x3c5,value); }
#define in_Sequencer(index,data)        { outp(0x3c4,index); data=inp(0x3c5); }

typedef unsigned char BYTE;
typedef unsigned WORD;

extern void writeVideo ( char *mem );

#pragma aux writeVideo "*_" parm caller [esi];

char *Screen = (char *)0xa0000;
char VScreen[330000];
int res, res_x, res_y;


void main ( void )
{
  char pal[768];

  printf("Copyright (c) 1996 PCX-Brothers Entertainment\n");
  printf("Alle Rechte vorbehalten.\n");
  printf("Defkon17 Alpha\n");

  delay(1500); fade_out(); init640x480();

  chdir("RESOURCE");


  show_PCX("defkon01.dbl"); Set_Overscan_Color(0); cpy2screen(); if ( getch() == 27 ) goto ende; fade_out();
  show_PCX("defkon02.dbl"); Set_Overscan_Color(0); cpy2screen(); if ( getch() == 27 ) goto ende; fade_out();
  show_PCX("defkon03.dbl"); Set_Overscan_Color(0); cpy2screen(); if ( getch() == 27 ) goto ende; fade_out();
  show_PCX("defkon04.dbl"); Set_Overscan_Color(0); cpy2screen(); if ( getch() == 27 ) goto ende; fade_out();
  show_PCX("defkon05.dbl"); Set_Overscan_Color(0); cpy2screen(); if ( getch() == 27 ) goto ende; fade_out();
  show_PCX("defkon06.dbl"); Set_Overscan_Color(0); cpy2screen(); if ( getch() == 27 ) goto ende; fade_out();
  show_PCX("defkon07.dbl"); Set_Overscan_Color(0); cpy2screen(); if ( getch() == 27 ) goto ende; fade_out();
  show_PCX("defkon08.dbl"); Set_Overscan_Color(0); cpy2screen(); if ( getch() == 27 ) goto ende; fade_out();
  show_PCX("defkon09.dbl"); Set_Overscan_Color(0); cpy2screen(); if ( getch() == 27 ) goto ende; fade_out();

ende:
  chdir("..");

  textmodus();
  printf("Copyright (c) 1996 PCX-Brothers Entertainment\n");
  printf("Alle Rechte vorbehalten.\n");
  printf("\nDu hast diese Zeit verloren!\n");

}


void init640x480 ( void )
{
   union REGS regs;

   _setvideomode(_VRES256COLOR);
   res   = SVGA;
   res_x = 640;
   res_y = 480;
}

void textmodus( void )
{
   union REGS regs;

   regs.x.ax = 0x0003;               /* wieder in Textmodus zurckschalten */
   int386( 0x10, &regs, &regs );
}


/****************************************************************************/
/* Kopiert den virtuellen auf den "richtigen" Bildschirm.                   */
/* ------------------------------------------------------------------------ */
/* keine Parameter                                                          */
/****************************************************************************/
void cpy2screen( void )
{
   union REGS regs;

     regs.x.ax = 0x4F05; regs.x.bx = 0x0000; regs.x.dx = 0x0000;
     int386( 0x10, &regs, &regs );
     memcpy(Screen, VScreen, 65535);

     regs.x.ax = 0x4F05; regs.x.bx = 0x0000; regs.x.dx = 0x0001;
     int386( 0x10, &regs, &regs );
     memcpy(Screen, &VScreen[65536], 65535);

     regs.x.ax = 0x4F05; regs.x.bx = 0x0000; regs.x.dx = 0x0002;
     int386( 0x10, &regs, &regs );
     memcpy(Screen, &VScreen[131072], 65535); 

     regs.x.ax = 0x4F05; regs.x.bx = 0x0000; regs.x.dx = 0x0003;
     int386( 0x10, &regs, &regs );
     memcpy(Screen, &VScreen[196608], 65535); 

     regs.x.ax = 0x4F05; regs.x.bx = 0x0000; regs.x.dx = 0x0004;
     int386( 0x10, &regs, &regs );
     memcpy(Screen, &VScreen[262144], 65535); 

}


/****************************************************************************/
/* Entkodiert eine PCX-Datei in den virtuellen Bildschirm, ohne die         */
/* Palette zu setzen.                                                       */    
/* ------------------------------------------------------------------------ */
/* Parameter: Name der PCX-Datei                                            */
/****************************************************************************/
void put_PCX( char Name[127] )
{
  int i, Farbe, Faktor, Zeichen, x= 0, y= 0;
  FILE *Datei;

  if ( (Datei = fopen(Name, "rb")) == NULL )
  {
    Screen_On(); textmodus();
    printf("\n\nERROR: Kann '%s' nicht laden!\n\n", Name);
    exit(0);
  }
  for (i=0; i<128; i++) Zeichen = fgetc(Datei);        //den Header berlesen

  while ( y <= (res_y-1) )
  {
    Zeichen = fgetc(Datei);                      // wenn kein Wiederholfaktor

    if ( Zeichen > 191 )                          // wenn ein Wiederh.faktor
    {
      Faktor = ( Zeichen - 192 );
      Farbe  = fgetc(Datei);
      memset(&VScreen[(res_x*y)+x], Farbe, Faktor);
      x += Faktor;
      if ( x >= res_x ) { x = x-res_x; y++; }
    }
    if ( Zeichen <= 191 )
    {
      vsetpix(x, y, Zeichen, res_x); x++;
      if ( x >= res_x ) { x = 0; y++; }
    }
  }
  fclose(Datei);
}


/****************************************************************************/
/* Entkodiert eine PCX-Datei in den virtuellen Bildschirm, und setzt auch   */
/* gleich die Palette.                                                      */    
/* ------------------------------------------------------------------------ */
/* Parameter: Name der PCX-Datei                                            */
/****************************************************************************/
void show_PCX( char Name[127] )
{
  char pal[768];

  put_PCX(Name);
  LoadPalette(Name, pal);
  SetPalette(pal);
}

/****************************************************************************/
/* Ld die Palette aus der angegebenen Datei in einen bergebenen Puffer.   */
/* ------------------------------------------------------------------------ */
/* Parameter: Name der PCX-Datei, plus Speicherplatz fr die Palette.       */
/****************************************************************************/
void LoadPalette(char Name[127], char Palette[786] )
{
  FILE *Datei;

  Datei = fopen(Name, "rb");
  fseek(Datei, -768L, SEEK_END);
  fread(Palette, 768, 1, Datei);
  fclose(Datei);
}

/****************************************************************************/
/* Setzt die bergebene Palette.                                            */
/* ------------------------------------------------------------------------ */
/* Parameter: Zeiger auf die Palette.                                       */
/****************************************************************************/
void SetPalette(char *Palette)
{
  short int i;
  char far *p;

  for (i=0; i<768; i++) Palette[i] = Palette[i] >> 2;
  p = Palette;

  outp(0x3c6, 0xff);
  for (i=0; i<=255; i++)
  {
    outp(0x3c8, i);
    outp(0x3c9, *p++);
    outp(0x3c9, *p++);
    outp(0x3c9, *p++);
  }

return;
}

/****************************************************************************/
/* Blendet den Bildschirm aus.                                              */
/* ------------------------------------------------------------------------ */
/* keine Parameter.                                                         */
/****************************************************************************/
void fade_out(void)
{
  BYTE PALETTE[768];
  int blend_count;

  GetPalette(PALETTE);
  for (blend_count=128;blend_count>=0;blend_count-=2)
  {
     wait_vretrace();
     Set_Palette2(0,255,PALETTE,blend_count);
  }
}

void wait_vretrace(void)
{
  while ((inp(0x03da) & 8) != 0);
  while ((inp(0x03da) & 8) == 0);
}

void Set_Palette2(word start,word end,byte *palette,byte blend)
{
  WORD i;

  outp(0x03c8,start);
  start*=3; end++; end*=3;
  for (i=start;i<=end;i++) outp(0x03c9, (palette[i]*blend >> 7));
}

void GetPalette ( BYTE *Palette )
{
   WORD i;

   outp(0x03c7, 0);
   for (i=0; i<768; i++) Palette[i] = inp(0x03c9);
}

void Screen_On(void)
{
  BYTE old_clock;

  in_Sequencer(1,old_clock);
  out_Sequencer(1,old_clock & 0xDF);
}

void Screen_Off(void)
{
  BYTE old_clock;

  in_Sequencer(1,old_clock);
  out_Sequencer(1,old_clock | 0x20);
}


void Set_Overscan_Color( BYTE color )
{
  wait_retrace();
  outp(0x3c0,0x11);  // Index fr Overscan-Register schreiben
  outp(0x3c0,color); // Farbe setzen
  outp(0x3c0,0x20);  // Bit 5 im Indexregister lschen
}

void wait_retrace(void)
{
  while ((inp(0x03da) & 1) != 0);
  while ((inp(0x03da) & 1) == 0); 
}
