//
// button.h
//


void draw_box ( int x, int y, int x1, int y1, byte color )
{
  int i;

  for ( i=x; i<=x1; i++ ) { vsetpix(i, y, color, res_x); vsetpix(i, y1, color, res_x); }
  for ( i=y; i<=y1; i++ ) { vsetpix(x, i, color, res_x); vsetpix(x1, i, color, res_x); }
}

void fill_box ( int x, int y, int x1, int y1, byte color )
{
  int i, j=x;

  for ( i=y; i<=y1; i++ )
  {
    memset(&VScreen[(i*res_x)+x], color, x1-x+1);
  }
}

void button_up ( int x, int y, int lang, char *msg )
{
  int i, j;

  fill_box(x, y, x+lang-1, y+10, 243);
  memset(&VScreen[(y*res_x)+x], 239, lang);      // obere HELLE Linie
  memset(&VScreen[((y+10)*res_x)+x], 242, lang); // untere DUNKLE Linie
  for(i=y; i<y+11; i++) { vsetpix(x, i, 239, res_x); vsetpix(x+lang, i, 242, res_x); }

  i = (strlen(msg))*6; j = (lang-i)/2;
  write(x+j, y+3, msg, 254);
}


void button_down ( int x, int y, int lang, char *msg )
{
  int i, j;

  fill_box(x, y, x+lang-1, y+10, 255);
  memset(&VScreen[(y*res_x)+x], 242, lang);      // obere HELLE Linie
  memset(&VScreen[((y+10)*res_x)+x], 239, lang); // untere DUNKLE Linie
  for(i=y; i<y+11; i++) { vsetpix(x, i, 242, res_x); vsetpix(x+lang, i, 239, res_x); }

  i = (strlen(msg))*6; j = (lang-i)/2;
  write(x+j, y+3, msg, 243);
}

void ccbutton_down ( int x, int y, int lang, char *msg, BYTE bc, BYTE color )
{
  int i, j;

  screen_refresh= 1;

  for ( i=y+1; i<y+10; i++ )
  {
    for ( j=x; j<x+lang-2; j++ ) vsetpix(j, i, bc, res_x);
  }

  i = (strlen(msg))*6; j = (lang-i)/2;
  write(x+j, y+3, msg, color);
}


void ccbutton_up ( int x, int y, int lang, char *msg, BYTE fc, BYTE bc, BYTE color )
{
  int i, j;

  screen_refresh= 1;

  for ( i=(x-1); i<(x+lang-1); i++ ) vsetpix(i, y, fc, res_x);
  for ( i=(x-1); i<(x+lang-1); i++ ) vsetpix(i, y+10, fc, res_x);
  for ( i=y+1; i<y+11; i++ ) vsetpix(x-1, i, fc, res_x);
  for ( i=y; i<y+10; i++ ) vsetpix(x+lang-2, i, fc, res_x);
  for ( i=y+1; i<y+10; i++ )
  {
    for ( j=x; j<x+lang-2; j++ ) vsetpix(j, i, bc, res_x);
  }

  i = (strlen(msg))*6; j = (lang-i)/2;
  write(x+j, y+3, msg, color);
}

void cbutton_up ( int x, int y, int lang, char *msg, BYTE color )
{
  int i, j;

  fill_box(x, y, x+lang-1, y+10, 243);
  memset(&VScreen[(y*res_x)+x], 239, lang);      // obere HELLE Linie
  memset(&VScreen[((y+10)*res_x)+x], 242, lang); // untere DUNKLE Linie
  for(i=y; i<y+11; i++) { vsetpix(x, i, 239, res_x); vsetpix(x+lang, i, 242, res_x); }

  i = (strlen(msg))*6; j = (lang-i)/2;
  write(x+j, y+3, msg, color);
}



void button_punch ( int x, int y, int lang, char *msg )
{
  m_back_restore();
  button_down(x, y, lang, msg);
  m_back_save(); wait_retrace(); cpy2screen();
  while ( m_taste == 1 ) { maus_pos(); maus_show(); } delay(70);
  m_back_restore();
  button_up(x, y, lang, msg); m_back_save(); maus_show();
  cpy2screen(); delay(70);
  m_taste= 0;
}

void ccbutton_punch ( int x, int y, int lang, char *msg, BYTE fc, BYTE bc, BYTE bc1, BYTE color )
{
  m_back_restore();
  ccbutton_down(x, y, lang, msg, bc1, color);
  m_back_save(); wait_retrace(); cpy2screen();
  while ( m_taste == 1 ) { maus_pos(); maus_show(); } delay(70);
  m_back_restore();
  ccbutton_up(x, y, lang, msg, fc, bc, color); m_back_save(); maus_show();
  cpy2screen(); delay(70);
  m_taste= 0;
}

