//
// mann.h
//
#define MLi             ML[index]
#define FLi             FL[index]


/****************************************************************************/
/* "Erschafft" einen neuen Mann.                                            */
/* ------------------------------------------------------------------------ */
/* Parameter: globale Koordinaten und das momentane Aussehen.               */
/****************************************************************************/
int MannInsert ( int ax, int ay, BYTE shape )
{

  MannAnzahl++;
  if ( MannAnzahl > 199 ) { MannAnzahl--; return 1; }

  MannListe[MannAnzahl].del     = 0;
  MannListe[MannAnzahl].x       = ax-(f_x*20);
  MannListe[MannAnzahl].y       = ay-(f_y*20);
  MannListe[MannAnzahl].x1      = ax-(f_x*20);
  MannListe[MannAnzahl].y1      = ay-(f_y*20);
  MannListe[MannAnzahl].ax      = ax;
  MannListe[MannAnzahl].ay      = ay;
  MannListe[MannAnzahl].dx      = ax;
  MannListe[MannAnzahl].dy      = ay;
  MannListe[MannAnzahl].tx      = ax;
  MannListe[MannAnzahl].ty      = ay;
  MannListe[MannAnzahl].atkanz  = 0;
  MannListe[MannAnzahl].shape   = shape;
  MannListe[MannAnzahl].energie = 50;
  MannListe[MannAnzahl].stop    = 0;
  MannListe[MannAnzahl].type    = 3;
  MannListe[MannAnzahl].explose = 0;
  MannListe[MannAnzahl].feldx   = ax/20;
  MannListe[MannAnzahl].feldy   = ay/20;
  MannListe[MannAnzahl].dcount  = 0;
  MannListe[MannAnzahl].speed   = 1;
  MannListe[MannAnzahl].reach   = 6;
  AktListe[MannAnzahl]          = 0;

  return 1;
}

void MannDelete( BYTE index )
{
  int i;

  for ( i=index; i<MannAnzahl; i++ ) ML[i] = ML[i+1];     // index korrigieren
  memmove(&MannBack[index*400], &MannBack[(index+1)*400], (MannAnzahl-index)*400);
  MannAnzahl--;
}
  

/****************************************************************************/
/* "Erschafft" einen neuen Feind.                                           */
/* ------------------------------------------------------------------------ */
/* Parameter: globale Koordinaten und das momentane Aussehen.               */
/****************************************************************************/
int FeindInsert ( int ax, int ay, BYTE shape )
{

  FeindAnzahl++;
  if ( FeindAnzahl > 199 ) { FeindAnzahl--; return 1; }

  FL[FeindAnzahl].del     = 0;
  FL[FeindAnzahl].x       = ax-(f_x*20);
  FL[FeindAnzahl].y       = ay-(f_y*20);
  FL[FeindAnzahl].x1      = ax-(f_x*20);
  FL[FeindAnzahl].y1      = ay-(f_y*20);
  FL[FeindAnzahl].ax      = ax;
  FL[FeindAnzahl].ay      = ay;
  FL[FeindAnzahl].dx      = ax;
  FL[FeindAnzahl].dy      = ay;
  FL[FeindAnzahl].tx      = ax/20;
  FL[FeindAnzahl].ty      = ay/20;
  FL[FeindAnzahl].atkanz  = 0;
  FL[FeindAnzahl].shape   = shape;
  FL[FeindAnzahl].feldx   = ax/20;
  FL[FeindAnzahl].feldy   = ay/20;
  FL[FeindAnzahl].energie = 50;
  FL[FeindAnzahl].explose = 0;
  FL[FeindAnzahl].stop    = 0;
  FL[FeindAnzahl].job     = 0;
  FL[FeindAnzahl].speed   = 1;
  FL[FeindAnzahl].type    = 3;
  FL[FeindAnzahl].dcount  = 0;
  FL[FeindAnzahl].attack  = 255;
  FL[FeindAnzahl].reach   = 9;

  return 1;
}

void FeindDelete( BYTE index )
{
  int i;

  for ( i=index; i<FeindAnzahl; i++ ) FL[i] = FL[i+1];
  memmove(&FeindBack[index*400], &FeindBack[(index+1)*400], (FeindAnzahl-index)*400);
  FeindAnzahl--;
}

void Mann_back_restore ( BYTE index )
{
  int i, j, h=index*400;

  for ( i=0; i<20; i++ )
  {
    for ( j=0; j<20; j++ )
    {
      if ( ((MLi.x1+j)<Mrechts)&&((MLi.x1+j)>Mlinks)&&((MLi.y1+i)>Moben)&&((MLi.y1+i)<Munten) )
      {
        /*if ( MannBack[h] < 90 )*/ vsetpix(MLi.x1+j, MLi.y1+i, MannBack[h]);
      }
      h++;
    }
  }
}

void Mann_set ( BYTE index )
{
  int i, j, h=index*400, k=MLi.shape*400;

  for ( i=0; i<20; i++ )
  {
    for ( j=0; j<20; j++ )
    {
      if ( ((MLi.x+j)<Mrechts)&&((MLi.x+j)>Mlinks)&&((MLi.y+i)>Moben)&&((MLi.y+i)<Munten) )
      {
        MannBack[h] = vgetpix( MLi.x+j, MLi.y+i);
        if ( (MannData[k]>6)&&(MannBack[h]<90) ) vsetpix( MLi.x+j, MLi.y+i, MannData[k]); 
      }
    h++; k++;
    }
  }
}

void Feind_back_restore ( BYTE index )
{
  int i, j, h=index*400;

  for ( i=0; i<20; i++ )
  {
    for ( j=0; j<20; j++ )
    {
      if ( ((FLi.x1+j)<Mrechts)&&((FLi.x1+j)>Mlinks)&&((FLi.y1+i)>Moben)&&((FLi.y1+i)<Munten) )
        vsetpix(FLi.x1+j, FLi.y1+i, FeindBack[h]);
      h++;
    }
  }
}

void Feind_set ( BYTE index )
{
  int i, j, h=index*400, k=FLi.shape*400;

  for ( i=0; i<20; i++ )
  {
    for ( j=0; j<20; j++ )
    {
      if ( ((FLi.x+j)<Mrechts)&&((FLi.x+j)>Mlinks)&&((FLi.y+i)>Moben)&&((FLi.y+i)<Munten) )
      {
        FeindBack[h] = vgetpix( FLi.x+j, FLi.y+i);
        if ( (MannData[k]>6)&&(FeindBack[h]<90) ) vsetpix( FLi.x+j, FLi.y+i, MannData[k]); 
      }
    h++; k++;
    }
  }
}

void Mann_akt_set ( BYTE index )
{
  int i, j, h=index*400, k=MLi.shape*400;

  for ( i=0; i<20; i++ )
  {
    for ( j=0; j<20; j++ )
    {
      if ( ((MLi.x+j)<Mrechts)&&((MLi.x+j)>Mlinks)&&((MLi.y+i)>Moben)&&((MLi.y+i)<Munten) )
      {
        MannBack[h] = vgetpix( MLi.x+j, MLi.y+i);
        if ( ((MannData[k]>6)&&(MannBack[h]<90)) ) vsetpix( MLi.x+j, MLi.y+i, MannData[k]); 
      }
    h++; k++;
    }
  }
  //---------------------------- X-Werte ----------------------------------------------------------------------------------------------------------------------------------------------
  for ( i= 2; i< 6; i++ ) if ( ((MLi.x+i)<Mrechts)&&((MLi.x+i)>Mlinks)&&((MLi.y+ 1)>Moben)&&((MLi.y+ 1)<Munten) ) vsetpix(MLi.x+i, MLi.y+1,  254);
  for ( i=14; i<18; i++ ) if ( ((MLi.x+i)<Mrechts)&&((MLi.x+i)>Mlinks)&&((MLi.y+ 1)>Moben)&&((MLi.y+ 1)<Munten) ) vsetpix(MLi.x+i, MLi.y+1,  254);
  for ( i= 2; i< 6; i++ ) if ( ((MLi.x+i)<Mrechts)&&((MLi.x+i)>Mlinks)&&((MLi.y+15)>Moben)&&((MLi.y+15)<Munten) ) vsetpix(MLi.x+i, MLi.y+15, 254);
  for ( i=14; i<18; i++ ) if ( ((MLi.x+i)<Mrechts)&&((MLi.x+i)>Mlinks)&&((MLi.y+15)>Moben)&&((MLi.y+15)<Munten) ) vsetpix(MLi.x+i, MLi.y+15, 254);
  //---------------------------- Y-Werte ----------------------------------------------------------------------------------------------------------------------------------------------
  for ( i= 2; i< 6; i++ ) if ( ((MLi.x+ 2)<Mrechts)&&((MLi.x+ 2)>Mlinks)&&((MLi.y+i)>Moben)&&((MLi.y+i)<Munten) ) vsetpix(MLi.x+2,  MLi.y+i,  254);
  for ( i=12; i<16; i++ ) if ( ((MLi.x+ 2)<Mrechts)&&((MLi.x+ 2)>Mlinks)&&((MLi.y+i)>Moben)&&((MLi.y+i)<Munten) ) vsetpix(MLi.x+2,  MLi.y+i,  254);
  for ( i= 2; i< 6; i++ ) if ( ((MLi.x+17)<Mrechts)&&((MLi.x+17)>Mlinks)&&((MLi.y+i)>Moben)&&((MLi.y+i)<Munten) ) vsetpix(MLi.x+17, MLi.y+i,  254);
  for ( i=12; i<16; i++ ) if ( ((MLi.x+17)<Mrechts)&&((MLi.x+17)>Mlinks)&&((MLi.y+i)>Moben)&&((MLi.y+i)<Munten) ) vsetpix(MLi.x+17, MLi.y+i,  254);

}













void Mann_compute ( BYTE index )
{
  int i, j, h, ho, hu, hr, hl;
  BYTE dist;
  BYTE links=0, rechts=0;

  if ( MLi.del >= mann_del )// Ist der Mann berhaupt an der Reihe
  {
    MLi.del = 0;
    if ( MLi.explose )
    {
      MLi.explose++;
      show_explore(index, 0);
      if ( MLi.explose == 10 ) MannDelete(index);
      return;
    }
    MF[MLi.feldy][MLi.feldx] = index+1;

    if ( MLi.atkanz > 0 ) atkzoom = index;

    if ( MLi.energie <= 0 )
    {
       MF[MLi.feldy][MLi.feldx] = 0;
       if ( aktsel == index ) { aktsel = -1;  fill_box(264, 48, 317, 68, 255); }
       Mann_back_restore(index);
       MLi.explose = 1;
       fill_box(100, 186, 230, 194, 0); write(100, 187, "Mann verloren", 251); meldung=200;
       return;
    }

    if ( (MLi.feldx == FHauptX)&&(MLi.feldy == FHauptY) )
    {
      for(i=0; i<=FeindAnzahl; i++) FL[i].energie = 0;
    }

    if ( (MLi.attack == 255) )
    {
      if ( MLi.feldy-MLi.reach < 0 )       hu = MLi.feldy;          else hu = MLi.reach;
      if ( MLi.feldy+MLi.reach > y_breit ) ho = y_breit-MLi.feldy;  else ho = MLi.reach;
      if ( MLi.feldx-MLi.reach < 0 )       hr = MLi.feldx;          else hr = MLi.reach;
      if ( MLi.feldx+MLi.reach > x_lang )  hl = x_lang-MLi.feldx;   else hl = MLi.reach;

      for (i=MLi.feldy-hu; i<=MLi.feldy+ho; i++)
      {
        for (j=MLi.feldx-hr; j<=MLi.feldx+hl; j++)
        {
          if ( (MF[i][j] >= 200)&&(MF[i][j] < 399) )
          {
            h = MF[i][j]-200;
            MLi.attack = h;
            break;
          }
        }
      }
    }

    if ( MLi.attack < 255 )
    {
       if ( MLi.feldx < FL[MLi.attack].feldx ) dist = FL[MLi.attack].feldx-MLi.feldx;
       else dist = MLi.feldx-FL[MLi.attack].feldx;

       if ( MLi.feldy < FL[MLi.attack].feldy ) dist += FL[MLi.attack].feldy-MLi.feldy;
       else dist += MLi.feldy-FL[MLi.attack].feldy;

       if ( dist < 5 )
       {
         if ( FL[MLi.attack].ax > MLi.ax )
         {
           if ( MLi.shape < ANGRIF_R ) MLi.shape = ANGRIF_R;
           if ( MLi.shape > ANGRIF_R+ANGRIF_RL ) MLi.shape = ANGRIF_R;
           MLi.shape++; goto atack;
         }
         if ( FL[MLi.attack].ax < MLi.ax )
         {
           if ( MLi.shape < ANGRIF_L ) MLi.shape = ANGRIF_L;
           if ( MLi.shape > ANGRIF_L+ANGRIF_LL ) MLi.shape = ANGRIF_L;
           MLi.shape++; goto atack;
         }  
         if ( FL[MLi.attack].ay > MLi.ay ) MLi.shape = ANGRIF_U;
         if ( FL[MLi.attack].ay <= MLi.ay ) MLi.shape = ANGRIF_O;
       
atack:
         h = rand() % MLi.type;
         if ( h == 1 ) FL[MLi.attack].energie--;

         if ( FL[MLi.attack].energie <= 0 ) MLi.attack = 255;
         MoveListe[index] = 1; MoveListe[MLi.attack] = 1;
         return;
       } // if in Reichweite
    }

    for (i=0; i<=fbcount; i++)
    {
      if ( (MLi.feldx == FB[i].x-1)&&(MLi.feldy == FB[i].y+1)&&(FB[i].owner!=1) ) { FB[i].owner = 1; return; }
      if ( (MLi.feldx == FB[i].x  )&&(MLi.feldy == FB[i].y+1)&&(FB[i].owner!=1) ) { FB[i].owner = 1; return; }
      if ( (MLi.feldx == FB[i].x+1)&&(MLi.feldy == FB[i].y+1)&&(FB[i].owner!=1) ) { FB[i].owner = 1; return; }
    }

    for (i=0; i<fbcount; i++)
    {
      if ( ((MLi.feldx<FB[i].x+4)&&(MLi.feldx>FB[i].x-4))&&((MLi.feldy<FB[i].y+4)&&(MLi.feldy>FB[i].y-4)) )
           MLi.job = SaveFB+i;
      else MLi.job = 0;
    }

//------------------------------ Nach RECHTS ---------------------------------------------------------------------
    if ( MLi.ax < MLi.dx )
    {
      MLi.ax+=MLi.speed; MLi.x+=MLi.speed;
      if ( (MLi.shape<R_ANFANG+MANN_DIV)&&((!(MLi.ay>MLi.dy)) &&(!(MLi.ay<MLi.dy))) ) MLi.shape = R_ANFANG+MANN_DIV;
      if ( (MLi.shape>R_ANFANG+MANN_DIV+R_LANG)&&((!(MLi.ay>MLi.dy)) &&(!(MLi.ay<MLi.dy))) ) MLi.shape = R_ANFANG+MANN_DIV;
      MLi.shape++; rechts= 1; MoveListe[index] = 1;
    }
//------------------------------ Nach LINKS ---------------------------------
    if ( MLi.ax > MLi.dx )
    {
      MLi.ax-=MLi.speed; MLi.x-=MLi.speed;
      if ( (MLi.shape>L_ANFANG+MANN_DIV+L_LANG)&&((!(MLi.ay>MLi.dy)) &&(!(MLi.ay<MLi.dy))) ) MLi.shape = L_ANFANG+MANN_DIV;
      MLi.shape++; links= 1; MoveListe[index] = 1;
    }
//------------------------------ Nach UNTEN ---------------------------------
    if ( MLi.ay < MLi.dy )
    {
      MLi.ay+=MLi.speed; MLi.y+=MLi.speed;
      if ( links )
      {
        if ( MLi.shape < LU_ANFANG+MANN_DIV ) MLi.shape = LU_ANFANG+MANN_DIV+1;
        if ( MLi.shape > LU_ANFANG+MANN_DIV+LU_LANG ) MLi.shape = LU_ANFANG+MANN_DIV+1;
      }
      if ( rechts )
      {
        if ( MLi.shape < RU_ANFANG+MANN_DIV ) MLi.shape = RU_ANFANG+MANN_DIV+1;
        if ( MLi.shape > RU_ANFANG+MANN_DIV+RU_LANG ) MLi.shape = RU_ANFANG+MANN_DIV+1;
      }
      if ( (!rechts)&&(!links) )
      {
        if ( MLi.shape < U_ANFANG+MANN_DIV ) MLi.shape = U_ANFANG+MANN_DIV;
        if ( MLi.shape > U_ANFANG+MANN_DIV+U_LANG ) MLi.shape = U_ANFANG+MANN_DIV;
        MLi.shape++;
      }
      MoveListe[index] = 1;
    }
//------------------------------ Nach OBEN ----------------------------------
    if ( MLi.ay > MLi.dy )
    {
      MLi.ay-=MLi.speed; MLi.y-=MLi.speed;
      if ( links )
      {
        if ( MLi.shape < LO_ANFANG+MANN_DIV ) MLi.shape = LO_ANFANG+MANN_DIV+1;
        if ( MLi.shape > LO_ANFANG+MANN_DIV+LO_LANG ) MLi.shape = LO_ANFANG+MANN_DIV+1;
      }
      if ( rechts )
      {
        if ( MLi.shape < RO_ANFANG+MANN_DIV ) MLi.shape = RO_ANFANG+MANN_DIV+1;
        if ( MLi.shape > RO_ANFANG+MANN_DIV+RO_LANG ) MLi.shape = RO_ANFANG+MANN_DIV+1;
      }
      if ( (!rechts)&&(!links) )
      {
        if ( MLi.shape < O_ANFANG+MANN_DIV ) MLi.shape = O_ANFANG+MANN_DIV;
        if ( MLi.shape > O_ANFANG+MANN_DIV+O_LANG ) MLi.shape = O_ANFANG+MANN_DIV;
        MLi.shape++;
      }
      MoveListe[index] = 1;
    }
//---------------------------- Sonstiges ------------------------------------
    if ( (!MoveListe[index])&&(MLi.shape>0) )
    {
      if ( MLi.shape<R_ANFANG+MANN_DIV ) MLi.shape=L_ANFANG+MANN_DIV;
      if ( MLi.shape>R_ANFANG+MANN_DIV ) MLi.shape=R_ANFANG+MANN_DIV;
      MoveListe[index]= 0;
    }

//============================================================================

 
    if ( (MLi.ay==MLi.dy)&&(MLi.ax==MLi.dx) )
    {
      if ( MLi.stop == 4 ) { MLi.dx += 21; MLi.stop = 3; } // Rechts
      if ( MLi.stop == 5 ) { MLi.dx -= 21; MLi.stop = 3; } // Links
      if ( MLi.stop == 6 ) { MLi.dy += 21; MLi.stop = 3; } // Unten
      if ( MLi.stop == 7 ) { MLi.dy -= 21; MLi.stop = 3; } // Oben
    }

    if ( (MLi.ay==MLi.dy)&&(MLi.ax==MLi.dx)&&(MLi.stop==3) )
    {
      MLi.dy = MLi.d[MLi.dcount].y;
      MLi.dx = MLi.d[MLi.dcount--].x;
      MLi.stop = 0;
    }

    if ( MoveListe[index] == 0 )
    {
      j = rand() % 4;
      if ( MLi.stop == 0 ) MLi.stop = 51;
      if ( MLi.stop == 51 )
      {
        MLi.stop++;
        if ( j == 0 ) MLi.shape=L_ANFANG+MANN_DIV;
        if ( j == 1 ) MLi.shape=R_ANFANG+MANN_DIV;
        if ( j == 2 ) MLi.shape=O_ANFANG+MANN_DIV;
        if ( j == 3 ) MLi.shape=U_ANFANG+MANN_DIV;
        MoveListe[index]=1;
      }
      if ( MLi.stop > 51 ) MLi.stop++;
      if ( MLi.stop == 170 )
      {
        if ( j == 0 ) MLi.shape=L_ANFANG+MANN_DIV;
        if ( j == 1 ) MLi.shape=R_ANFANG+MANN_DIV;
        if ( j == 2 ) MLi.shape=O_ANFANG+MANN_DIV;
        if ( j == 3 ) MLi.shape=U_ANFANG+MANN_DIV;
        MoveListe[index]=1;
      }
      if ( MLi.stop == 220 ) MLi.stop = 51; 
    }

    if ( MLi.feldx != MLi.ax/20 )              // alte X-Pos. im Feld lschen
    {
       MannFeld[MLi.feldy][MLi.feldx] = 0;
       MLi.feldx = MLi.ax/20;
    }
    if ( MLi.feldy != MLi.ay/20 )              // alte Y-Pos. im Feld lschen
    {
       MannFeld[MLi.feldy][MLi.feldx] = 0;
       MLi.feldy = MLi.ay/20;
    }
  }
  if ( (m_x>MLi.x-15)&&(m_x<MLi.x+15)&&(m_y>MLi.y-15)&&(m_y<MLi.y+15)&&(!AktListe[index]) )
     m_show_image=7;
  
//----------------------- Kommt immer dran -----------------------------------
  MLi.del++;
}


















void Feind_compute ( BYTE index )
{
  int ho, hu, hr, hl;
  int i, j, h, dist;
  BYTE links=0, rechts=0;

  if ( FLi.del >= mann_del )    // Ist der Mann berhaupt an der Reihe
  {
//  //-- Mann ist schon tod, mu aber noch explodieren --//
    if ( FLi.explose )
    {
      FLi.explose++;
      show_explore(index, 1);
      if ( FLi.explose == 10 ) FeindDelete(index);
      return;
    }

    FLi.del = 0; MF[FLi.feldy][FLi.feldx] = index+200;

//  //-- Mann ist tod --//
    if ( FLi.energie <= 0 )
    {
       MF[FLi.feldy][FLi.feldx] = 0;
       if ( FLi.attack > -1 ) ML[FLi.attack].atkanz--;
       Feind_back_restore(index);
       FLi.explose = 1;
       fill_box(100, 186, 230, 194, 0); write(100, 187, "Ein Feind weniger", 251); meldung=200;
       return;
    }

//  //-- Feindliche Basis wurde erreicht --//
    if ( (FLi.feldx == MHauptX)&&(FLi.feldy == MHauptY) )
    {
      for(i=0; i<=MannAnzahl; i++) ML[i].energie = 0;
    }

//  //-- Sichere ich unsere Basis? //
    if ( (FLi.tx>=FHauptX)&&(FLi.ty==(FHauptY+1)) ) FLi.job = SaveMain;   

//  //-- Steh ich da auf einem Mann? --//
    for(i=index+1; i<=FeindAnzahl; i++)
    {
      if ( (FL[i].feldx == FLi.feldx)&&(FL[i].feldy == FLi.feldy) )
      {
        if ( (FL[i].ax != FL[i].dx)||(FL[i].ay != FL[i].dy) ) FLi.stop = 2;
        else { FL[i].dx+=20; FL[i].tx++; }
        goto gehen1;
      }
      FLi.stop = 1;
    }

//  //-- Umgebung wird gescannt, und wenn ntig wird angegriffen --//
    if ( FLi.attack == 255 )
    {
      if ( FLi.ty-FLi.reach < 0 )       hu = FLi.ty;          else hu = FLi.reach;
      if ( FLi.ty+FLi.reach > y_breit ) ho = y_breit-FLi.ty;  else ho = FLi.reach;
      if ( FLi.tx-FLi.reach < 0 )       hr = FLi.tx;          else hr = FLi.reach;
      if ( FLi.tx+FLi.reach > x_lang )  hl = x_lang-FLi.tx;   else hl = FLi.reach;

      if ( FLi.stop == 0 ) { FLi.dx = FLi.tx*20; FLi.dy = FLi.ty*20; }

      for (i=FLi.ty-hu; i<=FLi.ty+ho; i++)
      {
        for (j=FLi.tx-hr; j<=FLi.tx+hl; j++)
        {
          if ( (MF[i][j] < 200)&&(MF[i][j] > 0) )
          {
            h = MF[i][j]-1;
            if ( ML[h].atkanz <= 1 )
            {
              FLi.attack = h;
              ML[h].atkanz++;
              FLi.dx = ML[h].dx;
              FLi.dy = ML[h].dy;
              break;
            }
          }
        }
      }
    }

//  //-- Der T-X/Y Rahmen, soll immer mitgehen --//
    if ( FLi.stop == 1 ) { FLi.tx = FLi.feldx; FLi.ty = FLi.feldy; }

//  //-- T-X/Y Rahmen soll wieder stationr sein --//
    if ( (FLi.stop==1)&&((FLi.dx==FLi.ax)&&(FLi.dy==FLi.ay)) ) FLi.stop = 0;

//  //-- Wenn ich den T-X/Y Rahmen verlassen habe --//
    if ( (FLi.ax<(FLi.tx-(FLi.reach-1))*20)||(FLi.ax>(FLi.tx+(FLi.reach-1))*20) ) { FLi.dx = FLi.tx*20; FLi.dy = FLi.ty*20; ML[FLi.attack].atkanz--; FLi.attack=255; goto gehen1; }
    if ( (FLi.ay<(FLi.ty-(FLi.reach-1))*20)||(FLi.ay>(FLi.ty+(FLi.reach-1))*20) ) { FLi.dx = FLi.tx*20; FLi.dy = FLi.ty*20; ML[FLi.attack].atkanz--; FLi.attack=255; goto gehen1; }

//  //-- Dem, Mnnchen das gekillt werden soll, hinterherlaufen --//
    if ( FLi.attack != 255 ) { FLi.dx = ML[FLi.attack].ax; FLi.dy = ML[FLi.attack].ay; }

//  //-- Reichweite berprfen, und wenn mglich schieen --//
    if ( FLi.attack < 255 )
    {
       if ( FLi.feldx < ML[FLi.attack].feldx ) dist = ML[FLi.attack].feldx-FLi.feldx;
       else dist = FLi.feldx-ML[FLi.attack].feldx;

       if ( FLi.feldy < ML[FLi.attack].feldy ) dist += ML[FLi.attack].feldy-FLi.feldy;
       else dist += FLi.feldy-ML[FLi.attack].feldy;

       if ( dist < 6 )
       {
         if ( ML[FLi.attack].ax > FLi.ax )
         {
           if ( FLi.shape < ANGRIF_R ) FLi.shape = ANGRIF_R;
           if ( FLi.shape > ANGRIF_R+ANGRIF_RL ) FLi.shape = ANGRIF_R;
           FLi.shape++; goto atack;
         }
         if ( ML[FLi.attack].ax < FLi.ax )
         {
           if ( FLi.shape < ANGRIF_L ) FLi.shape = ANGRIF_L;
           if ( FLi.shape > ANGRIF_L+ANGRIF_LL ) FLi.shape = ANGRIF_L;
           FLi.shape++; goto atack;
         }  
         if ( ML[FLi.attack].ay > FLi.ay ) FLi.shape = ANGRIF_U;
         if ( ML[FLi.attack].ay <= FLi.ay ) FLi.shape = ANGRIF_O;
       
atack:
         h = rand() % FLi.type;
         if ( h == 1 ) ML[FLi.attack].energie--;

         if ( ML[FLi.attack].energie <= 0 )
         {
           FLi.dx = FLi.tx*20; FLi.dy = FLi.ty*20;
           FLi.attack = 255;
           ML[FLi.attack].atkanz--;
         }
         MoveListe[index+200] = 1; MoveListe[FLi.attack] = 1;
         return;
       } // if in Reichweite
    }

//  //-- Habe ich eine Fabrik eingenommen? --//
    for (i=0; i<=fbcount; i++)
    {
      if ( (FLi.feldx == FB[i].x-1)&&(FLi.feldy == FB[i].y+1) ) { FB[i].owner = 2; FLi.job = SaveFB+i; }
      if ( (FLi.feldx == FB[i].x+1)&&(FLi.feldy == FB[i].y+1) ) { FB[i].owner = 2; FLi.job = SaveFB+i; }
      if ( (FLi.feldx == FB[i].x  )&&(FLi.feldy == FB[i].y+1) ) { FB[i].owner = 2; FLi.job = SaveFB+i; }
    }

gehen1:
//  //-- Wenn ich nicht gehen soll, den nchsteb Block berspringen --//
    if ( FLi.stop == 2 ) goto end_gehen;
//------------------------------ Nach RECHTS --------------------------------
    if ( FLi.ax < FLi.dx )
    {
      FLi.ax+=FLi.speed; FLi.x+=FLi.speed;
      if ( (FLi.shape<R_ANFANG)&&((!(FLi.ay>FLi.dy))&&(!(FLi.ay<FLi.dy))) ) FLi.shape = R_ANFANG;
      if ( (FLi.shape>R_ANFANG+R_LANG)&&((!(FLi.ay>FLi.dy))&&(!(FLi.ay<FLi.dy))) ) FLi.shape = R_ANFANG;
      FLi.shape++; rechts= 1; MoveListe[200+index] = 1;
    }
//------------------------------ Nach LINKS ---------------------------------
    if ( FLi.ax > FLi.dx )
    {
      FLi.ax-=FLi.speed; FLi.x-=FLi.speed;
      if ( (FLi.shape>L_ANFANG+L_LANG)&&((!(FLi.ay>FLi.dy))&&(!(FLi.ay<FLi.dy))) ) FLi.shape = L_ANFANG;
      FLi.shape++; links= 1; MoveListe[200+index] = 1;
    }
//------------------------------ Nach UNTEN ---------------------------------
    if ( FLi.ay < FLi.dy )
    {
      FLi.ay+=FLi.speed; FLi.y+=FLi.speed;
      if ( links )
      {
        if ( FLi.shape < LU_ANFANG ) FLi.shape = LU_ANFANG;
        if ( FLi.shape > LU_ANFANG+LU_LANG ) FLi.shape = LU_ANFANG;
      }
      if ( rechts )
      {
        if ( FLi.shape < RU_ANFANG ) FLi.shape = RU_ANFANG;
        if ( FLi.shape > RU_ANFANG+RU_LANG ) FLi.shape = RU_ANFANG;
      }
      if ( (!rechts)&&(!links) )
      {
        if ( FLi.shape < U_ANFANG ) FLi.shape = U_ANFANG;
        if ( FLi.shape > U_ANFANG+U_LANG ) FLi.shape = U_ANFANG;
        FLi.shape++;
      }
      MoveListe[index+200] = 1;
    }
//------------------------------ Nach OBEN ----------------------------------
    if ( FLi.ay > FLi.dy )
    {
      FLi.ay-=FLi.speed; FLi.y-=FLi.speed;
      if ( links )
      {
        if ( FLi.shape < LO_ANFANG ) FLi.shape = LO_ANFANG;
        if ( FLi.shape > LO_ANFANG+LO_LANG ) FLi.shape = LO_ANFANG;
      }
      if ( rechts )
      {
        if ( FLi.shape < RO_ANFANG ) FLi.shape = RO_ANFANG;
        if ( FLi.shape > RO_ANFANG+RO_LANG ) FLi.shape = RO_ANFANG;
      }
      if ( (!rechts)&&(!links) )
      {
        if ( FLi.shape < O_ANFANG ) FLi.shape = O_ANFANG;
        if ( FLi.shape > O_ANFANG+O_LANG ) FLi.shape = O_ANFANG;
        FLi.shape++;
      }
      MoveListe[index+200] = 1;
    }

//----------------------------- Sonstiges ------------------------------------

end_gehen:
//  //-- Immer gerade stehen --//
    if ( (!MoveListe[index+200])&&(FLi.shape>0) )
    {
      if ( FLi.shape<R_ANFANG ) FLi.shape=L_ANFANG;
      if ( FLi.shape>R_ANFANG ) FLi.shape=R_ANFANG;
      MoveListe[index]= 0;
    }

    if ( FLi.feldx != FLi.ax/20 )              // alte X-Pos. im Feld lschen
    {
       MannFeld[FLi.feldy][FLi.feldx] = 0;
       FLi.feldx = FLi.ax/20;
    }
    if ( FLi.feldy != FLi.ay/20 )              // alte Y-Pos. im Feld lschen
    {
       MannFeld[FLi.feldy][FLi.feldx] = 0;
       FLi.feldy = FLi.ay/20;
    }

  }
  if ( (m_x>FLi.x-15)&&(m_x<FLi.x+15)&&(m_y>FLi.y-15)&&(m_y<FLi.y+15)&&(go) )
     atack= 1;
  
  FLi.del++;
}
