//**************************************************************************//
// Das hier wird die DEFKON17 Konvertierung auf WATCOM C                    //
// -----------------------------------------------------                    //
// von Stephan Meiner                                                      //
// ab 25. Mrz 1996                                                         //
//**************************************************************************//
#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <graph.h>
#include <dos.h>
#include <i86.h>
#include <string.h>
#include "gfklib.h"
#include "pcxlib.h"
#include "maus.h"
#include "font.h"
#include "button.h"
#include "defkon.h"
#include "smenu.h"
#include "menue.h"
#include "ki.h"
#include "explos.h"
#include "rocket.h"
#include "mann.h"
#include "cdrom.h"


#define px      1
#define py      90


void main ( int argc, char *argv[] )
{
  char p[768], i;

  Init_Program();
  if ( intro ) { play_dfl("defkon.dfl"); fade_out(); delay(500); }
  if ( (argc < 2) ) { Init_Spiel(1); Spiel(); quit(); }
  else { Menue(); quit(); }
}


void Spiel ( void )
{
  int i, j=0, pal_count=48, pal_delete=0;
  char strgeld[5], c, update=0; 
  S1 Ende=0;

  MannFeld[2][3] = 290;

  go = atack = noway = 0;
  write(265,29, "A", 255); write(276,29, "B", 255); write(287,29, "C", 255); write(298,29, "D", 255); write(309,29, "E", 255);
  write(270,12, "A", 255); write(271,13, "A", 254);
  write(11,188, "Menu", 255); write(10,187, "Menu", 254);

  m_back_save();
///-- CD-Audio Routinen -//
  CD_Init();
  CD_Update();
///---------------------//

  Play_Musik(1);

  while ( m_taste != 7 )                                  // sinnlose Abfrage
  {
    if (CD_Avail) CD_Update();                             // Polling-Abfrage

    m_back_restore();
    update = 0; fast_scroll = 1;
    m_show_image= 1;                         // Mauszeiger auf Default setzen
    if ( go == 1  ) m_show_image= 6;  // Bewegungszeiger, wenn Mann aktiv ist
    if ( atack==1 ) { m_show_image= 9; atack= 0; }           // Angrifszeiger
    if ( noway==1 ) { m_show_image= 8; noway= 0; }               // Hindernis
    if ( maus_innen(260, 0, 320, 200) ) m_show_image = 1;
    maus_pos();
    if ( (rahmen == 1)&&(m_x>(259*res)) ) m_x=259*res;
    if ( (rahmen == 1)&&(m_y>(179*res)) ) m_y=179*res;
    m_back_restore(); 

    if ( (Feld[f_y+(m_y/20)][f_x+(m_x/20)] > Hindernis)&&(aktive) ) noway=1; 
    if ( m_taste == 1 )
    {
      i = maus_links();
      if ( i ) { fade_out(); return; }                             // beenden
      if ( !i ) goto compute;               // im Men wurde 'Weiter' gewhlt
    }
    if ( m_taste == 2 ) { maus_rechts(); fast_scroll = 2; }
    if ( m_taste == 3 ) maus_beide();

    if ( kbhit() )
    {
      c = getch();
      if ( c == 0 )
      {
        c = getch();
        if ( c == 63 )
        {
          fade_out(); delay(300); 
          init320x200(); maus_reset(); maus_put(160, 100);
          chdir("defdata"); show_PCX("mr-005.dbl"); chdir("..");
          Set_Overscan_Color(0);
        }
        if ( c == 64 ) 
        {
          fade_out(); delay(300);
          init640x480(); maus_reset(); maus_put(160, 100);
          chdir("defdata"); show_PCX("intfc-01.pcx"); chdir(".."); 
          Set_Overscan_Color(0);
        }
      }
      else
      {
        if ( c == 27 ) { m_back_restore(); if ( spiel_menu() ) { fade_out(); return; }  screen_refresh= 1; }
        if ( c == 45 ) { mann_del+=4; }                                // -
        if ( c == 43 ) { if ( mann_del > 0 ) mann_del-=4; }            // +
        if ( c == 47 ) { scroll_del+=1; }                              // /
        if ( c == 42 ) { if ( scroll_del > 0 ) scroll_del-=1; }        // *
        if ( c ==  8 ) { scroll_del = ss_del; mann_del = sm_del; }     // bs
        if ( c ==109 ) { if ( MannAnzahl > -1 ) { MF[ML[0].feldy][ML[0].feldx]=0; MannDelete(0); } }
        if ( c ==102 ) { if ( FeindAnzahl > -1 )
        {
          MF[FL[0].feldy][FL[0].feldx]=0;
          if ( FL[0].job == SaveMain ) HauptAnz--;
          FeindDelete(0);
        } }
        if ( c == 13 )
        {
           MannInsert((f_x*Teilung)+m_x, (f_y*Teilung)+m_y, 1); mann_set(MannAnzahl);
        }
        if ( c ==108 )
        {
           MannInsert((f_x*Teilung)+m_x, (f_y*Teilung)+m_y, 2); mann_set(MannAnzahl);
        }
        if ( c ==103  )
        {
           FeindInsert((f_x*Teilung)+m_x, (f_y*Teilung)+m_y, 2); feind_set(FeindAnzahl);
        }
        if ( c ==104  )
        {
           FeindInsert((f_x*Teilung)+m_x, (f_y*Teilung)+m_y, 1); feind_set(FeindAnzahl);
        }
        if ( c == 32 )
        {
          for ( i=0; i<MannAnzahl+1; i++ )
          {
            if ( AktListe[i] ) mann_set(i);
            AktListe[i] = 0;
          }
          fill_box(264, 48, 317, 68, 255); fill_box(264, 79, 315, 87, 251);
          go=0; atack=0; aktzaehler = -1; aktive = 0; aktsel = -1;
        } 
        if ( (c>48)&&(c<58) ) Play_Musik(c-49);

      } // c == 0;
    }

    if ( meldung == 0 ) fill_box(100, 186, 230, 194, 0);
    if ( meldung >  0 ) meldung--;
    for (i=0; i<=fbcount; i++)
    {
      if ( FB[i].time != 100000 ) FB[i].time--;
      if ( FB[i].time == 0 )
      {
         if ( FB[i].owner == 1 )
         {
           MannInsert((FB[i].x*Teilung), ((FB[i].y+1)*Teilung), 1);
           fill_box(100, 186, 230, 194, 0); write(100, 187, "Neuer Mann erstellt", 245); meldung=200;
         }
         if ( FB[i].owner == 2 ) FeindInsert((FB[i].x*Teilung), ((FB[i].y+1)*Teilung), 1);
         FB[i].time=100000;
      }
    }

    if ( pal_delete == 10 )
    {
      rotate_pal(pal_count++, 48, 54, pal, 48);
      if ( pal_count == 54 ) pal_count = 48;
      pal_delete = 0;
    }
    else pal_delete++;
    //-------------------------------------------------------------------------------------------------
    if ( (m_y>(res_y-10))&&(f_y<FELD_Y) )  { if ((sdel>=scroll_del)&&(!rahmen)) { scroll_down(); update=1; } else sdel++; }
    if ( (m_y<  5)&&(f_y>1) )       { if ((sdel>=scroll_del)&&(!rahmen)) { scroll_up(); update=1;   } else sdel++; }
    if ( (m_x>(res_x-10))&&(f_x<FELD_X)) { if (sdel>=scroll_del) { scroll_right(); update=1;} else sdel++; }
    if ( (m_x<  5)&&(f_x>0) )       { if ((sdel>=scroll_del)&&(!rahmen)) { scroll_left(); update=1; } else sdel++; }
    //-------------------------------------------------------------------------------------------------

compute:

    Feind_KI();

    for(i=0; i<=fbcount; i++) FB[i].inrange = 0;

//  //-- Alle Mnner werden berechnet --//
    inRange = 0; atkzoom = -1;
    for ( i=0; i<MannAnzahl+1; i++ )
    {
      if ( ML[i].type == 1 ) Mann1_compute(i);
      if ( ML[i].type == 2 ) Mann2_compute(i);
      if ( ML[i].type == 3 ) Mann3_compute(i);

      //-- Ist er nahe einer Fabrik --//
      for (j=0; j<=fbcount; j++) if ( ((ML[i].feldx<FB[j].x+4)&&(ML[i].feldx>FB[j].x-4))&&((ML[i].feldy<FB[j].y+4)&&(ML[i].feldy>FB[j].y-4)) ) FB[j].inrange++;
      if ( ML[i].feldy < FHauptY+15 ) inRange++;
      if ( ML[i].atkanz > 0 ) atkzoom = i;
    }

//  //-- Alle Feinde werden berechnet --//
    HauptAnz=0; FBAnzahl=0; avaiable=FeindAnzahl;
    for ( i=0; i<FeindAnzahl+1; i++ )
    {
      if ( FL[i].type == 1 ) Feind1_compute(i);
      if ( FL[i].type == 2 ) Feind2_compute(i);
      if ( FL[i].type == 3 ) Feind3_compute(i);

      if ( FL[i].job == SaveMain ) HauptAnz++;
      if ( FL[i].job == SaveFB )   FBAnzahl++; 
      if ( FL[i].job != 0 ) avaiable--;
    }

    if ( !update ) UpdateScreen();
    else {
//----------------------------------------------------------------------------
    for ( i=0; i<MannAnzahl+1; i++ ) 
    {
      if ( AktListe[i] ) mann_akt_set(i);
      else mann_set(i);
      if ( (ML[i].type==1)&&(ML[i].fire!=0) ) Mann1_Fire(i);
      if ( (ML[i].type==2)&&(ML[i].fire!=0) ) Mann2_Fire(i);
      if ( (ML[i].type==3)&&(ML[i].fire!=0) ) Mann3_Fire(i);
      ML[i].ax1= ML[i].ax; ML[i].ay1= ML[i].ay;
    }

    for ( i=0; i<FeindAnzahl+1; i++ )
    {
      feind_set(i);
      if ( (FL[i].type==1)&&(FL[i].fire!=0) ) Feind1_Fire(i);
      if ( (FL[i].type==2)&&(FL[i].fire!=0) ) Feind2_Fire(i);
      if ( (FL[i].type==3)&&(FL[i].fire!=0) ) Feind3_Fire(i);
      FL[i].ax1= FL[i].ax; FL[i].ay1= FL[i].ay;
    }

    for ( i=0; i<=ExplAnzahl; i++) compute_explosion(i);
    for ( i=0; i<=RocketAnzahl; i++) compute_rocket(i);

    }
    if ( maus_innen(4, 184, 40, 194) )  { m_show_image = 1; write(10,187, "Menu", 211); }
    else write(10,187, "Menu", 254);
    //--------------------------------------------------------------------------
    fill_box(263, 122, 273, 128, 97); Iwrite(263, 123, MannAnzahl+1, 255);
    fill_box(263, 134, 273, 139, 247); Iwrite(263, 135, FeindAnzahl+1, 255);
    //--------------------------------------------------------------------------

    if ( atkzoom > -1 ) write(271,13, "A", 251);
    else write(271,13, "A", 254);

    if ( rahmen == 1 )
    {
      if ( r_x!=m_x )
      {
        if ( r_x<m_x ) for(i=r_x; i<=m_x; i++) { vsetpix(i, r_y, 254, res_x); vsetpix(i, m_y, 254, res_x); }
        if ( r_x>m_x ) for(i=m_x; i<=r_x; i++) { vsetpix(i, r_y, 254, res_x); vsetpix(i, m_y, 254, res_x); }
      }
      if ( r_y!=m_y )
      {
        if ( r_y<m_y ) for(i=r_y; i<=m_y; i++) { vsetpix(r_x, i, 254, res_x); vsetpix(m_x, i, 254, res_x); }
        if ( r_y>m_y ) for(i=m_y; i<=r_y; i++) { vsetpix(r_x, i, 254, res_x); vsetpix(m_x, i, 254, res_x); }
      }
    }
    //--------------------------------------------------------------------------
    if ( radar_akt ) radar();

    if ( (MannAnzahl < 0)||(FeindAnzahl < 0) ) { return; }
    m_back_restore(); m_back_save(); m_place(); x1 = m_x; y1 = m_y;
    cpy2screen();
  }

}







void radar ( void )
{
  int i, j;

  fill_box(Radar_x+1, Radar_y+1, Radar_x1-2, Radar_y1, 110);
  draw_box(((f_x*50)/x_lang)+Radar_x+1, ((f_y*50)/y_breit)+Radar_y+1, (((f_x+16)*50)/x_lang)+Radar_x+1, (((f_y+10)*50)/y_breit)+Radar_y+1, 254);

  for (i=0; i<=y_breit; i++)
  {
    for (j=0; j<=x_lang; j++)
    {
      if ( MannFeld[i][j] > 0 )
      {
        if ( MannFeld[i][j] <= 199 ) vsetpix(((j*50)/x_lang)+Radar_x+1, ((i*50)/y_breit)+Radar_y+1, 252, res_x);
        else vsetpix(((j*50)/x_lang)+Radar_x+1, ((i*50)/y_breit)+Radar_y+1, 251, res_x);
      }
    }
  }

  for (i=0; i<=fbcount; i++)
  {
    if ( FB[i].owner == 0 ) vsetpix(((FB[i].x*50)/x_lang)+Radar_x+1, ((FB[i].y*50)/y_breit)+Radar_y+1, 254, res_x);
    if ( FB[i].owner == 1 ) vsetpix(((FB[i].x*50)/x_lang)+Radar_x+1, ((FB[i].y*50)/y_breit)+Radar_y+1, 244, res_x);
    if ( FB[i].owner == 2 ) vsetpix(((FB[i].x*50)/x_lang)+Radar_x+1, ((FB[i].y*50)/y_breit)+Radar_y+1, 247, res_x);
  }

  if ( MediSet == 1 ) vsetpix(((MediKit.x*50)/x_lang)+Radar_x+1, ((MediKit.y*50)/y_breit)+Radar_y+1, 249, res_x);
  screen_refresh = 1;
}


