//
// Interface-Datei
//
#define GELB            98
#define GELB_HELL       96
#define GELB_DUNKEL     100
#define BLAU            108
#define BLAU_HELL       106
#define BLAU_DUNKEL     110
#define ROT             148
#define ROT_HELL        236
#define ROT_DUNKEL      144



void draw_box ( int x, int y, int x1, int y1, byte color )
{
  int i;

  if ( x > x1 ) { i=x; x=x1; x1=i; }
  if ( y > y1 ) { i=y; y=y1; y1=i; }

  for ( i=x; i<=x1; i++ ) { setpix(i, y, color); setpix(i, y1, color); }
  for ( i=y; i<=y1; i++ ) { setpix(x, i, color); setpix(x1, i, color); }
}


void fill_box ( int x, int y, int x1, int y1, byte color )
{
  int i;

  for ( i=y; i<=y1; i++ )
  {
    memset(&VScreen[(i*ResX)+x], color, x1-x+1);
  }
}


void gbalken ( int x, int y, int lang )
{
  memset(&VScreen[y*ResX+x+4],  GELB_HELL, lang-7);                 // obere Linie
  memset(&VScreen[(y+11)*ResX+x+4], GELB_DUNKEL, lang-7);           // untere Linie
  // vordere Linie
  setpix(x, y+4, GELB_HELL); setpix(x, y+5, GELB_HELL);
  setpix(x, y+6, GELB_HELL); setpix(x, y+7, GELB_HELL);

  // hintere Linie
  setpix(x+lang, y+4, GELB_DUNKEL); setpix(x+lang, y+5, GELB_DUNKEL);
  setpix(x+lang, y+6, GELB_DUNKEL); setpix(x+lang, y+7, GELB_DUNKEL);


  // Schrge Linien vorne
  setpix(x+1, y+3,  GELB_HELL); setpix(x+2, y+2,  GELB_HELL); setpix(x+3, y+1,  GELB_HELL);
  setpix(x+1, y+8, GELB_DUNKEL); setpix(x+2, y+9, GELB_DUNKEL); setpix(x+3, y+10, GELB_DUNKEL);

  // Schrge Linien hinten
  setpix(x+lang-1, y+3,  GELB_HELL); setpix(x+lang-2, y+2,  GELB_HELL); setpix(x+lang-3, y+1,  GELB_HELL);
  setpix(x+lang-1, y+8, GELB_DUNKEL); setpix(x+lang-2, y+9, GELB_DUNKEL); setpix(x+lang-3, y+10, GELB_DUNKEL);

  fill_box(x+4, y+1, x+lang-4, y+10, GELB);
  setpix(x+1, y+4, GELB); setpix(x+1, y+5, GELB); setpix(x+1, y+6, GELB); setpix(x+1, y+7, GELB);
  setpix(x+2, y+3, GELB); setpix(x+2, y+4, GELB); setpix(x+2, y+5, GELB);
   setpix(x+2, y+6, GELB); setpix(x+2, y+7, GELB); setpix(x+2, y+8, GELB);
  setpix(x+3, y+2, GELB); setpix(x+3, y+3, GELB); setpix(x+3, y+4, GELB);
   setpix(x+3, y+5, GELB); setpix(x+3, y+6, GELB); setpix(x+3, y+7, GELB);
   setpix(x+3, y+8, GELB); setpix(x+3, y+9, GELB);

  setpix(x+lang-1, y+4, GELB); setpix(x+lang-1, y+5, GELB); setpix(x+lang-1, y+6, GELB); setpix(x+lang-1, y+7, GELB);
  setpix(x+lang-2, y+3, GELB); setpix(x+lang-2, y+4, GELB); setpix(x+lang-2, y+5, GELB);
   setpix(x+lang-2, y+6, GELB); setpix(x+lang-2, y+7, GELB); setpix(x+lang-2, y+8, GELB);
  setpix(x+lang-3, y+2, GELB); setpix(x+lang-3, y+3, GELB); setpix(x+lang-3, y+4, GELB);
   setpix(x+lang-3, y+5, GELB); setpix(x+lang-3, y+6, GELB); setpix(x+lang-3, y+7, GELB);
   setpix(x+lang-3, y+8, GELB); setpix(x+lang-3, y+9, GELB);
}


void gbalken_links ( int x, int y, int lang )
{
  memset(&VScreen[y*ResX+x+4],  GELB_HELL, lang-3);                 // obere Linie
  memset(&VScreen[(y+11)*ResX+x+4], GELB_DUNKEL, lang-3);           // untere Linie
  // vordere Linie
  setpix(x, y+4, GELB_HELL); setpix(x, y+5, GELB_HELL);
  setpix(x, y+6, GELB_HELL); setpix(x, y+7, GELB_HELL);

  // hintere Linie
  setpix(x+lang, y+1, GELB_DUNKEL); setpix(x+lang, y+2, GELB_DUNKEL); setpix(x+lang, y+3, GELB_DUNKEL);
  setpix(x+lang, y+4, GELB_DUNKEL); setpix(x+lang, y+5, GELB_DUNKEL); setpix(x+lang, y+6, GELB_DUNKEL);
  setpix(x+lang, y+7, GELB_DUNKEL); setpix(x+lang, y+8, GELB_DUNKEL); setpix(x+lang, y+9, GELB_DUNKEL);
  setpix(x+lang, y+10, GELB_DUNKEL);

  // Schrge Linien vorne
  setpix(x+1, y+3,  GELB_HELL); setpix(x+2, y+2,  GELB_HELL); setpix(x+3, y+1,  GELB_HELL);
  setpix(x+1, y+8, GELB_DUNKEL); setpix(x+2, y+9, GELB_DUNKEL); setpix(x+3, y+10, GELB_DUNKEL);

  fill_box(x+4, y+1, x+lang-1, y+10, GELB);
  setpix(x+1, y+4, GELB); setpix(x+1, y+5, GELB); setpix(x+1, y+6, GELB); setpix(x+1, y+7, GELB);
  setpix(x+2, y+3, GELB); setpix(x+2, y+4, GELB); setpix(x+2, y+5, GELB);
   setpix(x+2, y+6, GELB); setpix(x+2, y+7, GELB); setpix(x+2, y+8, GELB);
  setpix(x+3, y+2, GELB); setpix(x+3, y+3, GELB); setpix(x+3, y+4, GELB);
   setpix(x+3, y+5, GELB); setpix(x+3, y+6, GELB); setpix(x+3, y+7, GELB);
   setpix(x+3, y+8, GELB); setpix(x+3, y+9, GELB);
}


void gbalken_rechts ( int x, int y, int lang )
{
  memset(&VScreen[y*ResX+x],  GELB_HELL, lang-3);                 // obere Linie
  memset(&VScreen[(y+11)*ResX+x], GELB_DUNKEL, lang-3);           // untere Linie
  // vordere Linie
  setpix(x, y+1, GELB_HELL); setpix(x, y+2, GELB_HELL); setpix(x, y+3, GELB_HELL);
  setpix(x, y+4, GELB_HELL); setpix(x, y+5, GELB_HELL); setpix(x, y+6, GELB_HELL);
  setpix(x, y+7, GELB_HELL); setpix(x, y+8, GELB_HELL); setpix(x, y+9, GELB_HELL);
  setpix(x, y+10, GELB_HELL);

  // hintere Linie
  setpix(x+lang, y+4, GELB_DUNKEL); setpix(x+lang, y+5, GELB_DUNKEL);
  setpix(x+lang, y+6, GELB_DUNKEL); setpix(x+lang, y+7, GELB_DUNKEL);


  // Schrge Linien hinten
  setpix(x+lang-1, y+3,  GELB_HELL); setpix(x+lang-2, y+2,  GELB_HELL); setpix(x+lang-3, y+1,  GELB_HELL);
  setpix(x+lang-1, y+8, GELB_DUNKEL); setpix(x+lang-2, y+9, GELB_DUNKEL); setpix(x+lang-3, y+10, GELB_DUNKEL);

  fill_box(x+1, y+1, x+lang-4, y+10, GELB);
  setpix(x+lang-1, y+4, GELB); setpix(x+lang-1, y+5, GELB); setpix(x+lang-1, y+6, GELB); setpix(x+lang-1, y+7, GELB);
  setpix(x+lang-2, y+3, GELB); setpix(x+lang-2, y+4, GELB); setpix(x+lang-2, y+5, GELB);
   setpix(x+lang-2, y+6, GELB); setpix(x+lang-2, y+7, GELB); setpix(x+lang-2, y+8, GELB);
  setpix(x+lang-3, y+2, GELB); setpix(x+lang-3, y+3, GELB); setpix(x+lang-3, y+4, GELB);
   setpix(x+lang-3, y+5, GELB); setpix(x+lang-3, y+6, GELB); setpix(x+lang-3, y+7, GELB);
   setpix(x+lang-3, y+8, GELB); setpix(x+lang-3, y+9, GELB);
}


//--------------------------------------------------------------------------//


void bbalken ( int x, int y, int lang )
{
  memset(&VScreen[y*ResX+x+4],  BLAU_HELL, lang-7);                 // obere Linie
  memset(&VScreen[(y+11)*ResX+x+4], BLAU_DUNKEL, lang-7);           // untere Linie
  // vordere Linie
  setpix(x, y+4, BLAU_HELL); setpix(x, y+5, BLAU_HELL);
  setpix(x, y+6, BLAU_HELL); setpix(x, y+7, BLAU_HELL);

  // hintere Linie
  setpix(x+lang, y+4, BLAU_DUNKEL); setpix(x+lang, y+5, BLAU_DUNKEL);
  setpix(x+lang, y+6, BLAU_DUNKEL); setpix(x+lang, y+7, BLAU_DUNKEL);


  // Schrge Linien vorne
  setpix(x+1, y+3,  BLAU_HELL); setpix(x+2, y+2,  BLAU_HELL); setpix(x+3, y+1,  BLAU_HELL);
  setpix(x+1, y+8, BLAU_DUNKEL); setpix(x+2, y+9, BLAU_DUNKEL); setpix(x+3, y+10, BLAU_DUNKEL);

  // Schrge Linien hinten
  setpix(x+lang-1, y+3,  BLAU_HELL); setpix(x+lang-2, y+2,  BLAU_HELL); setpix(x+lang-3, y+1,  BLAU_HELL);
  setpix(x+lang-1, y+8, BLAU_DUNKEL); setpix(x+lang-2, y+9, BLAU_DUNKEL); setpix(x+lang-3, y+10, BLAU_DUNKEL);

  fill_box(x+4, y+1, x+lang-4, y+10, BLAU);
  setpix(x+1, y+4, BLAU); setpix(x+1, y+5, BLAU); setpix(x+1, y+6, BLAU); setpix(x+1, y+7, BLAU);
  setpix(x+2, y+3, BLAU); setpix(x+2, y+4, BLAU); setpix(x+2, y+5, BLAU);
   setpix(x+2, y+6, BLAU); setpix(x+2, y+7, BLAU); setpix(x+2, y+8, BLAU);
  setpix(x+3, y+2, BLAU); setpix(x+3, y+3, BLAU); setpix(x+3, y+4, BLAU);
   setpix(x+3, y+5, BLAU); setpix(x+3, y+6, BLAU); setpix(x+3, y+7, BLAU);
   setpix(x+3, y+8, BLAU); setpix(x+3, y+9, BLAU);

  setpix(x+lang-1, y+4, BLAU); setpix(x+lang-1, y+5, BLAU); setpix(x+lang-1, y+6, BLAU); setpix(x+lang-1, y+7, BLAU);
  setpix(x+lang-2, y+3, BLAU); setpix(x+lang-2, y+4, BLAU); setpix(x+lang-2, y+5, BLAU);
   setpix(x+lang-2, y+6, BLAU); setpix(x+lang-2, y+7, BLAU); setpix(x+lang-2, y+8, BLAU);
  setpix(x+lang-3, y+2, BLAU); setpix(x+lang-3, y+3, BLAU); setpix(x+lang-3, y+4, BLAU);
   setpix(x+lang-3, y+5, BLAU); setpix(x+lang-3, y+6, BLAU); setpix(x+lang-3, y+7, BLAU);
   setpix(x+lang-3, y+8, BLAU); setpix(x+lang-3, y+9, BLAU);
}


void bbalken_links ( int x, int y, int lang )
{
  memset(&VScreen[y*ResX+x+4],  BLAU_HELL, lang-3);                 // obere Linie
  memset(&VScreen[(y+11)*ResX+x+4], BLAU_DUNKEL, lang-3);           // untere Linie
  // vordere Linie
  setpix(x, y+4, BLAU_HELL); setpix(x, y+5, BLAU_HELL);
  setpix(x, y+6, BLAU_HELL); setpix(x, y+7, BLAU_HELL);

  // hintere Linie
  setpix(x+lang, y+1, BLAU_DUNKEL); setpix(x+lang, y+2, BLAU_DUNKEL); setpix(x+lang, y+3, BLAU_DUNKEL);
  setpix(x+lang, y+4, BLAU_DUNKEL); setpix(x+lang, y+5, BLAU_DUNKEL); setpix(x+lang, y+6, BLAU_DUNKEL);
  setpix(x+lang, y+7, BLAU_DUNKEL); setpix(x+lang, y+8, BLAU_DUNKEL); setpix(x+lang, y+9, BLAU_DUNKEL);


  // Schrge Linien vorne
  setpix(x+1, y+3,  BLAU_HELL); setpix(x+2, y+2,  BLAU_HELL); setpix(x+3, y+1,  BLAU_HELL);
  setpix(x+1, y+8, BLAU_DUNKEL); setpix(x+2, y+9, BLAU_DUNKEL); setpix(x+3, y+10, BLAU_DUNKEL);

  fill_box(x+4, y+1, x+lang-1, y+10, BLAU);
  setpix(x+1, y+4, BLAU); setpix(x+1, y+5, BLAU); setpix(x+1, y+6, BLAU); setpix(x+1, y+7, BLAU);
  setpix(x+2, y+3, BLAU); setpix(x+2, y+4, BLAU); setpix(x+2, y+5, BLAU);
   setpix(x+2, y+6, BLAU); setpix(x+2, y+7, BLAU); setpix(x+2, y+8, BLAU);
  setpix(x+3, y+2, BLAU); setpix(x+3, y+3, BLAU); setpix(x+3, y+4, BLAU);
   setpix(x+3, y+5, BLAU); setpix(x+3, y+6, BLAU); setpix(x+3, y+7, BLAU);
   setpix(x+3, y+8, BLAU); setpix(x+3, y+9, BLAU);
}


void bbalken_rechts ( int x, int y, int lang )
{
  memset(&VScreen[y*ResX+x],  BLAU_HELL, lang-3);                 // obere Linie
  memset(&VScreen[(y+11)*ResX+x], BLAU_DUNKEL, lang-3);           // untere Linie
  // vordere Linie
  setpix(x, y+1, BLAU_HELL); setpix(x, y+2, BLAU_HELL); setpix(x, y+3, BLAU_HELL);
  setpix(x, y+4, BLAU_HELL); setpix(x, y+5, BLAU_HELL); setpix(x, y+6, BLAU_HELL);
  setpix(x, y+7, BLAU_HELL); setpix(x, y+8, BLAU_HELL); setpix(x, y+9, BLAU_HELL);

  // hintere Linie
  setpix(x+lang, y+4, BLAU_DUNKEL); setpix(x+lang, y+5, BLAU_DUNKEL);
  setpix(x+lang, y+6, BLAU_DUNKEL); setpix(x+lang, y+7, BLAU_DUNKEL);


  // Schrge Linien hinten
  setpix(x+lang-1, y+3,  BLAU_HELL); setpix(x+lang-2, y+2,  BLAU_HELL); setpix(x+lang-3, y+1,  BLAU_HELL);
  setpix(x+lang-1, y+8, BLAU_DUNKEL); setpix(x+lang-2, y+9, BLAU_DUNKEL); setpix(x+lang-3, y+10, BLAU_DUNKEL);

  fill_box(x+1, y+1, x+lang-4, y+10, BLAU);
  setpix(x+lang-1, y+4, BLAU); setpix(x+lang-1, y+5, BLAU); setpix(x+lang-1, y+6, BLAU); setpix(x+lang-1, y+7, BLAU);
  setpix(x+lang-2, y+3, BLAU); setpix(x+lang-2, y+4, BLAU); setpix(x+lang-2, y+5, BLAU);
   setpix(x+lang-2, y+6, BLAU); setpix(x+lang-2, y+7, BLAU); setpix(x+lang-2, y+8, BLAU);
  setpix(x+lang-3, y+2, BLAU); setpix(x+lang-3, y+3, BLAU); setpix(x+lang-3, y+4, BLAU);
   setpix(x+lang-3, y+5, BLAU); setpix(x+lang-3, y+6, BLAU); setpix(x+lang-3, y+7, BLAU);
   setpix(x+lang-3, y+8, BLAU); setpix(x+lang-3, y+9, BLAU);
}

//--------------------------------------------------------------------------//

void rbalken ( int x, int y, int lang )
{
  memset(&VScreen[y*ResX+x+4],  ROT_HELL, lang-7);                 // obere Linie
  memset(&VScreen[(y+11)*ResX+x+4], ROT_DUNKEL, lang-7);           // untere Linie
  // vordere Linie
  setpix(x, y+4, ROT_HELL); setpix(x, y+5, ROT_HELL);
  setpix(x, y+6, ROT_HELL); setpix(x, y+7, ROT_HELL);

  // hintere Linie
  setpix(x+lang, y+4, ROT_DUNKEL); setpix(x+lang, y+5, ROT_DUNKEL);
  setpix(x+lang, y+6, ROT_DUNKEL); setpix(x+lang, y+7, ROT_DUNKEL);


  // Schrge Linien vorne
  setpix(x+1, y+3,  ROT_HELL); setpix(x+2, y+2,  ROT_HELL); setpix(x+3, y+1,  ROT_HELL);
  setpix(x+1, y+8, ROT_DUNKEL); setpix(x+2, y+9, ROT_DUNKEL); setpix(x+3, y+10, ROT_DUNKEL);

  // Schrge Linien hinten
  setpix(x+lang-1, y+3,  ROT_HELL); setpix(x+lang-2, y+2,  ROT_HELL); setpix(x+lang-3, y+1,  ROT_HELL);
  setpix(x+lang-1, y+8, ROT_DUNKEL); setpix(x+lang-2, y+9, ROT_DUNKEL); setpix(x+lang-3, y+10, ROT_DUNKEL);

  fill_box(x+4, y+1, x+lang-4, y+10, ROT);
  setpix(x+1, y+4, ROT); setpix(x+1, y+5, ROT); setpix(x+1, y+6, ROT); setpix(x+1, y+7, ROT);
  setpix(x+2, y+3, ROT); setpix(x+2, y+4, ROT); setpix(x+2, y+5, ROT);
   setpix(x+2, y+6, ROT); setpix(x+2, y+7, ROT); setpix(x+2, y+8, ROT);
  setpix(x+3, y+2, ROT); setpix(x+3, y+3, ROT); setpix(x+3, y+4, ROT);
   setpix(x+3, y+5, ROT); setpix(x+3, y+6, ROT); setpix(x+3, y+7, ROT);
   setpix(x+3, y+8, ROT); setpix(x+3, y+9, ROT);

  setpix(x+lang-1, y+4, ROT); setpix(x+lang-1, y+5, ROT); setpix(x+lang-1, y+6, ROT); setpix(x+lang-1, y+7, ROT);
  setpix(x+lang-2, y+3, ROT); setpix(x+lang-2, y+4, ROT); setpix(x+lang-2, y+5, ROT);
   setpix(x+lang-2, y+6, ROT); setpix(x+lang-2, y+7, ROT); setpix(x+lang-2, y+8, ROT);
  setpix(x+lang-3, y+2, ROT); setpix(x+lang-3, y+3, ROT); setpix(x+lang-3, y+4, ROT);
   setpix(x+lang-3, y+5, ROT); setpix(x+lang-3, y+6, ROT); setpix(x+lang-3, y+7, ROT);
   setpix(x+lang-3, y+8, ROT); setpix(x+lang-3, y+9, ROT);
}


void rbalken_links ( int x, int y, int lang )
{
  memset(&VScreen[y*ResX+x+4],  ROT_HELL, lang-3);                 // obere Linie
  memset(&VScreen[(y+11)*ResX+x+4], ROT_DUNKEL, lang-3);           // untere Linie
  // vordere Linie
  setpix(x, y+4, ROT_HELL); setpix(x, y+5, ROT_HELL);
  setpix(x, y+6, ROT_HELL); setpix(x, y+7, ROT_HELL);

  // hintere Linie
  setpix(x+lang, y+1, ROT_DUNKEL); setpix(x+lang, y+2, ROT_DUNKEL); setpix(x+lang, y+3, ROT_DUNKEL);
  setpix(x+lang, y+4, ROT_DUNKEL); setpix(x+lang, y+5, ROT_DUNKEL); setpix(x+lang, y+6, ROT_DUNKEL);
  setpix(x+lang, y+7, ROT_DUNKEL); setpix(x+lang, y+8, ROT_DUNKEL); setpix(x+lang, y+9, ROT_DUNKEL);


  // Schrge Linien vorne
  setpix(x+1, y+3,  ROT_HELL); setpix(x+2, y+2,  ROT_HELL); setpix(x+3, y+1,  ROT_HELL);
  setpix(x+1, y+8, ROT_DUNKEL); setpix(x+2, y+9, ROT_DUNKEL); setpix(x+3, y+10, ROT_DUNKEL);

  fill_box(x+4, y+1, x+lang-1, y+10, ROT);
  setpix(x+1, y+4, ROT); setpix(x+1, y+5, ROT); setpix(x+1, y+6, ROT); setpix(x+1, y+7, ROT);
  setpix(x+2, y+3, ROT); setpix(x+2, y+4, ROT); setpix(x+2, y+5, ROT);
   setpix(x+2, y+6, ROT); setpix(x+2, y+7, ROT); setpix(x+2, y+8, ROT);
  setpix(x+3, y+2, ROT); setpix(x+3, y+3, ROT); setpix(x+3, y+4, ROT);
   setpix(x+3, y+5, ROT); setpix(x+3, y+6, ROT); setpix(x+3, y+7, ROT);
   setpix(x+3, y+8, ROT); setpix(x+3, y+9, ROT);
}


void rbalken_rechts ( int x, int y, int lang )
{
  memset(&VScreen[y*ResX+x],  ROT_HELL, lang-3);                 // obere Linie
  memset(&VScreen[(y+11)*ResX+x], ROT_DUNKEL, lang-3);           // untere Linie
  // vordere Linie
  setpix(x, y+1, ROT_HELL); setpix(x, y+2, ROT_HELL); setpix(x, y+3, ROT_HELL);
  setpix(x, y+4, ROT_HELL); setpix(x, y+5, ROT_HELL); setpix(x, y+6, ROT_HELL);
  setpix(x, y+7, ROT_HELL); setpix(x, y+8, ROT_HELL); setpix(x, y+9, ROT_HELL);

  // hintere Linie
  setpix(x+lang, y+4, ROT_DUNKEL); setpix(x+lang, y+5, ROT_DUNKEL);
  setpix(x+lang, y+6, ROT_DUNKEL); setpix(x+lang, y+7, ROT_DUNKEL);


  // Schrge Linien hinten
  setpix(x+lang-1, y+3,  ROT_HELL); setpix(x+lang-2, y+2,  ROT_HELL); setpix(x+lang-3, y+1,  ROT_HELL);
  setpix(x+lang-1, y+8, ROT_DUNKEL); setpix(x+lang-2, y+9, ROT_DUNKEL); setpix(x+lang-3, y+10, ROT_DUNKEL);

  fill_box(x+1, y+1, x+lang-4, y+10, ROT);
  setpix(x+lang-1, y+4, ROT); setpix(x+lang-1, y+5, ROT); setpix(x+lang-1, y+6, ROT); setpix(x+lang-1, y+7, ROT);
  setpix(x+lang-2, y+3, ROT); setpix(x+lang-2, y+4, ROT); setpix(x+lang-2, y+5, ROT);
   setpix(x+lang-2, y+6, ROT); setpix(x+lang-2, y+7, ROT); setpix(x+lang-2, y+8, ROT);
  setpix(x+lang-3, y+2, ROT); setpix(x+lang-3, y+3, ROT); setpix(x+lang-3, y+4, ROT);
   setpix(x+lang-3, y+5, ROT); setpix(x+lang-3, y+6, ROT); setpix(x+lang-3, y+7, ROT);
   setpix(x+lang-3, y+8, ROT); setpix(x+lang-3, y+9, ROT);
}



//--------------------------------------------------------------------------//


void gbalken_offen ( int x, int y, int lang )
{
  memset(&VScreen[y*ResX+x+4],  GELB_HELL, lang-7);                 // obere Linie
  memset(&VScreen[(y+1)*ResX+x+4],  GELB_DUNKEL, lang-7);                 // obere Linie
  memset(&VScreen[(y+11)*ResX+x+4], GELB_DUNKEL, lang-7);           // untere Linie
  memset(&VScreen[(y+10)*ResX+x+4], GELB_HELL, lang-7);           // untere Linie
  // vordere Linie
  setpix(x, y+4, GELB_HELL); setpix(x, y+5, GELB_HELL);
  setpix(x, y+6, GELB_HELL); setpix(x, y+7, GELB_HELL);

  // hintere Linie
  setpix(x+lang, y+4, GELB_DUNKEL); setpix(x+lang, y+5, GELB_DUNKEL);
  setpix(x+lang, y+6, GELB_DUNKEL); setpix(x+lang, y+7, GELB_DUNKEL);


  // Schrge Linien vorne
  setpix(x+1, y+3,  GELB_HELL); setpix(x+2, y+2,  GELB_HELL); setpix(x+3, y+1,  GELB_HELL);
  setpix(x+1, y+8, GELB_DUNKEL); setpix(x+2, y+9, GELB_DUNKEL); setpix(x+3, y+10, GELB_DUNKEL);

  // Schrge Linien hinten
  setpix(x+lang-1, y+3,  GELB_HELL); setpix(x+lang-2, y+2,  GELB_HELL); setpix(x+lang-3, y+1,  GELB_HELL);
  setpix(x+lang-1, y+8, GELB_DUNKEL); setpix(x+lang-2, y+9, GELB_DUNKEL); setpix(x+lang-3, y+10, GELB_DUNKEL);

  setpix(x+1, y+4, GELB); setpix(x+1, y+5, GELB); setpix(x+1, y+6, GELB); setpix(x+1, y+7, GELB);
  setpix(x+2, y+3, GELB); setpix(x+2, y+4, GELB); setpix(x+2, y+5, GELB);
   setpix(x+2, y+6, GELB); setpix(x+2, y+7, GELB); setpix(x+2, y+8, GELB);
  setpix(x+3, y+2, GELB); setpix(x+3, y+3, GELB); setpix(x+3, y+4, GELB);
   setpix(x+3, y+5, GELB); setpix(x+3, y+6, GELB); setpix(x+3, y+7, GELB);
   setpix(x+3, y+8, GELB); setpix(x+3, y+9, GELB);

  setpix(x+lang-1, y+4, GELB); setpix(x+lang-1, y+5, GELB); setpix(x+lang-1, y+6, GELB); setpix(x+lang-1, y+7, GELB);
  setpix(x+lang-2, y+3, GELB); setpix(x+lang-2, y+4, GELB); setpix(x+lang-2, y+5, GELB);
   setpix(x+lang-2, y+6, GELB); setpix(x+lang-2, y+7, GELB); setpix(x+lang-2, y+8, GELB);
  setpix(x+lang-3, y+2, GELB); setpix(x+lang-3, y+3, GELB); setpix(x+lang-3, y+4, GELB);
   setpix(x+lang-3, y+5, GELB); setpix(x+lang-3, y+6, GELB); setpix(x+lang-3, y+7, GELB);
   setpix(x+lang-3, y+8, GELB); setpix(x+lang-3, y+9, GELB);
}


void gbalken_offen_links ( int x, int y, int lang )
{
  memset(&VScreen[y*ResX+x+4],  GELB_HELL, lang-3);                 // obere Linie
  memset(&VScreen[(y+1)*ResX+x+4],  GELB_DUNKEL, lang-3);                 // obere Linie
  memset(&VScreen[(y+11)*ResX+x+4], GELB_DUNKEL, lang-3);           // untere Linie
  memset(&VScreen[(y+10)*ResX+x+4], GELB_HELL, lang-3);           // untere Linie
  // vordere Linie
  setpix(x, y+4, GELB_HELL); setpix(x, y+5, GELB_HELL);
  setpix(x, y+6, GELB_HELL); setpix(x, y+7, GELB_HELL);

  // hintere Linie
  setpix(x+lang, y+1, GELB_DUNKEL); setpix(x+lang, y+2, GELB_DUNKEL); setpix(x+lang, y+3, GELB_DUNKEL);
  setpix(x+lang, y+4, GELB_DUNKEL); setpix(x+lang, y+5, GELB_DUNKEL); setpix(x+lang, y+6, GELB_DUNKEL);
  setpix(x+lang, y+7, GELB_DUNKEL); setpix(x+lang, y+8, GELB_DUNKEL); setpix(x+lang, y+9, GELB_DUNKEL);
  setpix(x+lang, y+10, GELB_DUNKEL); 


  // Schrge Linien vorne
  setpix(x+1, y+3,  GELB_HELL); setpix(x+2, y+2,  GELB_HELL); setpix(x+3, y+1,  GELB_HELL);
  setpix(x+1, y+8, GELB_DUNKEL); setpix(x+2, y+9, GELB_DUNKEL); setpix(x+3, y+10, GELB_DUNKEL);

  setpix(x+1, y+4, GELB); setpix(x+1, y+5, GELB); setpix(x+1, y+6, GELB); setpix(x+1, y+7, GELB);
  setpix(x+2, y+3, GELB); setpix(x+2, y+4, GELB); setpix(x+2, y+5, GELB);
   setpix(x+2, y+6, GELB); setpix(x+2, y+7, GELB); setpix(x+2, y+8, GELB);
  setpix(x+3, y+2, GELB); setpix(x+3, y+3, GELB); setpix(x+3, y+4, GELB);
   setpix(x+3, y+5, GELB); setpix(x+3, y+6, GELB); setpix(x+3, y+7, GELB);
   setpix(x+3, y+8, GELB); setpix(x+3, y+9, GELB);
}


void gbalken_offen_rechts ( int x, int y, int lang )
{
  memset(&VScreen[y*ResX+x],  GELB_HELL, lang-3);                 // obere Linie
  memset(&VScreen[(y+1)*ResX+x],  GELB_DUNKEL, lang-3);                 // obere Linie
  memset(&VScreen[(y+11)*ResX+x], GELB_DUNKEL, lang-3);           // untere Linie
  memset(&VScreen[(y+10)*ResX+x], GELB_HELL, lang-3);           // untere Linie
  // vordere Linie
  setpix(x, y+1, GELB_HELL); setpix(x, y+2, GELB_HELL); setpix(x, y+3, GELB_HELL);
  setpix(x, y+4, GELB_HELL); setpix(x, y+5, GELB_HELL); setpix(x, y+6, GELB_HELL);
  setpix(x, y+7, GELB_HELL); setpix(x, y+8, GELB_HELL); setpix(x, y+9, GELB_HELL);
  setpix(x, y+10, GELB_HELL);

  // hintere Linie
  setpix(x+lang, y+4, GELB_DUNKEL); setpix(x+lang, y+5, GELB_DUNKEL);
  setpix(x+lang, y+6, GELB_DUNKEL); setpix(x+lang, y+7, GELB_DUNKEL);


  // Schrge Linien hinten
  setpix(x+lang-1, y+3,  GELB_HELL); setpix(x+lang-2, y+2,  GELB_HELL); setpix(x+lang-3, y+1,  GELB_HELL);
  setpix(x+lang-1, y+8, GELB_DUNKEL); setpix(x+lang-2, y+9, GELB_DUNKEL); setpix(x+lang-3, y+10, GELB_DUNKEL);

  setpix(x+lang-1, y+4, GELB); setpix(x+lang-1, y+5, GELB); setpix(x+lang-1, y+6, GELB); setpix(x+lang-1, y+7, GELB);
  setpix(x+lang-2, y+3, GELB); setpix(x+lang-2, y+4, GELB); setpix(x+lang-2, y+5, GELB);
   setpix(x+lang-2, y+6, GELB); setpix(x+lang-2, y+7, GELB); setpix(x+lang-2, y+8, GELB);
  setpix(x+lang-3, y+2, GELB); setpix(x+lang-3, y+3, GELB); setpix(x+lang-3, y+4, GELB);
   setpix(x+lang-3, y+5, GELB); setpix(x+lang-3, y+6, GELB); setpix(x+lang-3, y+7, GELB);
   setpix(x+lang-3, y+8, GELB); setpix(x+lang-3, y+9, GELB);
}


//--------------------------------------------------------------------------//


void bbalken_offen ( int x, int y, int lang )
{
  memset(&VScreen[y*ResX+x+4],  BLAU_HELL, lang-7);                 // obere Linie
  memset(&VScreen[(y+1)*ResX+x+4],  BLAU_DUNKEL, lang-7);                 // obere Linie
  memset(&VScreen[(y+11)*ResX+x+4], BLAU_DUNKEL, lang-7);           // untere Linie
  memset(&VScreen[(y+10)*ResX+x+4], BLAU_HELL, lang-7);           // untere Linie
  // vordere Linie
  setpix(x, y+4, BLAU_HELL); setpix(x, y+5, BLAU_HELL);
  setpix(x, y+6, BLAU_HELL); setpix(x, y+7, BLAU_HELL);

  // hintere Linie
  setpix(x+lang, y+4, BLAU_DUNKEL); setpix(x+lang, y+5, BLAU_DUNKEL);
  setpix(x+lang, y+6, BLAU_DUNKEL); setpix(x+lang, y+7, BLAU_DUNKEL);


  // Schrge Linien vorne
  setpix(x+1, y+3,  BLAU_HELL); setpix(x+2, y+2,  BLAU_HELL); setpix(x+3, y+1,  BLAU_HELL);
  setpix(x+1, y+8, BLAU_DUNKEL); setpix(x+2, y+9, BLAU_DUNKEL); setpix(x+3, y+10, BLAU_DUNKEL);

  // Schrge Linien hinten
  setpix(x+lang-1, y+3,  BLAU_HELL); setpix(x+lang-2, y+2,  BLAU_HELL); setpix(x+lang-3, y+1,  BLAU_HELL);
  setpix(x+lang-1, y+8, BLAU_DUNKEL); setpix(x+lang-2, y+9, BLAU_DUNKEL); setpix(x+lang-3, y+10, BLAU_DUNKEL);

  setpix(x+1, y+4, BLAU); setpix(x+1, y+5, BLAU); setpix(x+1, y+6, BLAU); setpix(x+1, y+7, BLAU);
  setpix(x+2, y+3, BLAU); setpix(x+2, y+4, BLAU); setpix(x+2, y+5, BLAU);
   setpix(x+2, y+6, BLAU); setpix(x+2, y+7, BLAU); setpix(x+2, y+8, BLAU);
  setpix(x+3, y+2, BLAU); setpix(x+3, y+3, BLAU); setpix(x+3, y+4, BLAU);
   setpix(x+3, y+5, BLAU); setpix(x+3, y+6, BLAU); setpix(x+3, y+7, BLAU);
   setpix(x+3, y+8, BLAU); setpix(x+3, y+9, BLAU);

  setpix(x+lang-1, y+4, BLAU); setpix(x+lang-1, y+5, BLAU); setpix(x+lang-1, y+6, BLAU); setpix(x+lang-1, y+7, BLAU);
  setpix(x+lang-2, y+3, BLAU); setpix(x+lang-2, y+4, BLAU); setpix(x+lang-2, y+5, BLAU);
   setpix(x+lang-2, y+6, BLAU); setpix(x+lang-2, y+7, BLAU); setpix(x+lang-2, y+8, BLAU);
  setpix(x+lang-3, y+2, BLAU); setpix(x+lang-3, y+3, BLAU); setpix(x+lang-3, y+4, BLAU);
   setpix(x+lang-3, y+5, BLAU); setpix(x+lang-3, y+6, BLAU); setpix(x+lang-3, y+7, BLAU);
   setpix(x+lang-3, y+8, BLAU); setpix(x+lang-3, y+9, BLAU);
}


void bbalken_offen_links ( int x, int y, int lang )
{
  memset(&VScreen[y*ResX+x+4],  BLAU_HELL, lang-3);                 // obere Linie
  memset(&VScreen[(y+1)*ResX+x+4],  BLAU_DUNKEL, lang-3);                 // obere Linie
  memset(&VScreen[(y+11)*ResX+x+4], BLAU_DUNKEL, lang-3);           // untere Linie
  memset(&VScreen[(y+10)*ResX+x+4], BLAU_HELL, lang-3);           // untere Linie
  // vordere Linie
  setpix(x, y+4, BLAU_HELL); setpix(x, y+5, BLAU_HELL);
  setpix(x, y+6, BLAU_HELL); setpix(x, y+7, BLAU_HELL);

  // hintere Linie
  setpix(x+lang, y+1, BLAU_DUNKEL); setpix(x+lang, y+2, BLAU_DUNKEL); setpix(x+lang, y+3, BLAU_DUNKEL);
  setpix(x+lang, y+4, BLAU_DUNKEL); setpix(x+lang, y+5, BLAU_DUNKEL); setpix(x+lang, y+6, BLAU_DUNKEL);
  setpix(x+lang, y+7, BLAU_DUNKEL); setpix(x+lang, y+8, BLAU_DUNKEL); setpix(x+lang, y+9, BLAU_DUNKEL);
  setpix(x+lang, y+10, BLAU_DUNKEL);


  // Schrge Linien vorne
  setpix(x+1, y+3,  BLAU_HELL); setpix(x+2, y+2,  BLAU_HELL); setpix(x+3, y+1,  BLAU_HELL);
  setpix(x+1, y+8, BLAU_DUNKEL); setpix(x+2, y+9, BLAU_DUNKEL); setpix(x+3, y+10, BLAU_DUNKEL);

  setpix(x+1, y+4, BLAU); setpix(x+1, y+5, BLAU); setpix(x+1, y+6, BLAU); setpix(x+1, y+7, BLAU);
  setpix(x+2, y+3, BLAU); setpix(x+2, y+4, BLAU); setpix(x+2, y+5, BLAU);
   setpix(x+2, y+6, BLAU); setpix(x+2, y+7, BLAU); setpix(x+2, y+8, BLAU);
  setpix(x+3, y+2, BLAU); setpix(x+3, y+3, BLAU); setpix(x+3, y+4, BLAU);
   setpix(x+3, y+5, BLAU); setpix(x+3, y+6, BLAU); setpix(x+3, y+7, BLAU);
   setpix(x+3, y+8, BLAU); setpix(x+3, y+9, BLAU);
}


void bbalken_offen_rechts ( int x, int y, int lang )
{
  memset(&VScreen[y*ResX+x],  BLAU_HELL, lang-3);                 // obere Linie
  memset(&VScreen[(y+1)*ResX+x],  BLAU_DUNKEL, lang-3);                 // obere Linie
  memset(&VScreen[(y+11)*ResX+x], BLAU_DUNKEL, lang-3);           // untere Linie
  memset(&VScreen[(y+10)*ResX+x], BLAU_HELL, lang-3);           // untere Linie
  // vordere Linie
  setpix(x, y+1, BLAU_HELL); setpix(x, y+2, BLAU_HELL); setpix(x, y+3, BLAU_HELL);
  setpix(x, y+4, BLAU_HELL); setpix(x, y+5, BLAU_HELL); setpix(x, y+6, BLAU_HELL);
  setpix(x, y+7, BLAU_HELL); setpix(x, y+8, BLAU_HELL); setpix(x, y+9, BLAU_HELL);
  setpix(x, y+10, BLAU_HELL); 

  // hintere Linie
  setpix(x+lang, y+4, BLAU_DUNKEL); setpix(x+lang, y+5, BLAU_DUNKEL);
  setpix(x+lang, y+6, BLAU_DUNKEL); setpix(x+lang, y+7, BLAU_DUNKEL);


  // Schrge Linien hinten
  setpix(x+lang-1, y+3,  BLAU_HELL); setpix(x+lang-2, y+2,  BLAU_HELL); setpix(x+lang-3, y+1,  BLAU_HELL);
  setpix(x+lang-1, y+8, BLAU_DUNKEL); setpix(x+lang-2, y+9, BLAU_DUNKEL); setpix(x+lang-3, y+10, BLAU_DUNKEL);

  setpix(x+lang-1, y+4, BLAU); setpix(x+lang-1, y+5, BLAU); setpix(x+lang-1, y+6, BLAU); setpix(x+lang-1, y+7, BLAU);
  setpix(x+lang-2, y+3, BLAU); setpix(x+lang-2, y+4, BLAU); setpix(x+lang-2, y+5, BLAU);
   setpix(x+lang-2, y+6, BLAU); setpix(x+lang-2, y+7, BLAU); setpix(x+lang-2, y+8, BLAU);
  setpix(x+lang-3, y+2, BLAU); setpix(x+lang-3, y+3, BLAU); setpix(x+lang-3, y+4, BLAU);
   setpix(x+lang-3, y+5, BLAU); setpix(x+lang-3, y+6, BLAU); setpix(x+lang-3, y+7, BLAU);
   setpix(x+lang-3, y+8, BLAU); setpix(x+lang-3, y+9, BLAU);
}
