//
// mann.h
//
#define MLi             ML[index]
#define FLi             FL[index]


/****************************************************************************/
/* "Erschafft" einen neuen Mann.                                            */
/* ------------------------------------------------------------------------ */
/* Parameter: globale Koordinaten und das momentane Aussehen.               */
/****************************************************************************/
int MannInsert ( int ax, int ay, BYTE shape )
{

  MannAnzahl++;
  MannListe[MannAnzahl].del     = 0;
  MannListe[MannAnzahl].x       = ax-(f_x*20);
  MannListe[MannAnzahl].y       = ay-(f_y*20);
  MannListe[MannAnzahl].x1      = ax-(f_x*20);
  MannListe[MannAnzahl].y1      = ay-(f_y*20);
  MannListe[MannAnzahl].ax      = ax;
  MannListe[MannAnzahl].ay      = ay;
  MannListe[MannAnzahl].dx      = ax;
  MannListe[MannAnzahl].dy      = ay;
  MannListe[MannAnzahl].tx      = ax;
  MannListe[MannAnzahl].ty      = ay;
  MannListe[MannAnzahl].shape   = shape;
  MannListe[MannAnzahl].energie = 50;
  MannListe[MannAnzahl].stop    = 0;
  MannListe[MannAnzahl].feldx   = ax/20;
  MannListe[MannAnzahl].feldy   = ay/20;
  MannListe[MannAnzahl].dcount  = 0;
  MannListe[MannAnzahl].speed   = 1;
  AktListe[MannAnzahl]          = 0;

  return 1;
}

void MannDelete( BYTE index )
{
  int i;

  for ( i=index; i<MannAnzahl; i++ ) ML[i] = ML[i+1];     // index korrigieren
  memmove(&MannBack[index*400], &MannBack[(index+1)*400], (MannAnzahl-index)*400);
  MannAnzahl--;
}
  

/****************************************************************************/
/* "Erschafft" einen neuen Feind.                                           */
/* ------------------------------------------------------------------------ */
/* Parameter: globale Koordinaten und das momentane Aussehen.               */
/****************************************************************************/
int FeindInsert ( int ax, int ay, BYTE shape )
{

  FeindAnzahl++;
  FL[FeindAnzahl].del     = 0;
  FL[FeindAnzahl].x       = ax-(f_x*20);
  FL[FeindAnzahl].y       = ay-(f_y*20);
  FL[FeindAnzahl].x1      = ax-(f_x*20);
  FL[FeindAnzahl].y1      = ay-(f_y*20);
  FL[FeindAnzahl].ax      = ax;
  FL[FeindAnzahl].ay      = ay;
  FL[FeindAnzahl].dx      = ax;
  FL[FeindAnzahl].dy      = ay;
  FL[FeindAnzahl].tx      = ax/20;
  FL[FeindAnzahl].ty      = ay/20;
  FL[FeindAnzahl].shape   = shape;
  FL[FeindAnzahl].feldx   = ax/20;
  FL[FeindAnzahl].feldy   = ay/20;
  FL[FeindAnzahl].energie = 50;
  FL[FeindAnzahl].stop    = 0;
  FL[FeindAnzahl].dcount  = 0;
  FL[FeindAnzahl].attack  = 255;
  FL[FeindAnzahl].reach   = 9;


  return 1;
}

void FeindDelete( BYTE index )
{
  int i;

  for ( i=index; i<FeindAnzahl; i++ ) FL[i] = FL[i+1];
  memmove(&FeindBack[index*400], &FeindBack[(index+1)*400], (FeindAnzahl-index)*400);
  FeindAnzahl--;
}

void Mann_back_restore ( BYTE index )
{
  int i, j, h=index*400;

  for ( i=0; i<20; i++ )
  {
    for ( j=0; j<20; j++ )
    {
      if ( ((MLi.x1+j)<Mrechts)&&((MLi.x1+j)>Mlinks)&&((MLi.y1+i)>Moben)&&((MLi.y1+i)<Munten) )
      {
        /*if ( MannBack[h] < 90 )*/ vsetpix(MLi.x1+j, MLi.y1+i, MannBack[h]);
      }
      h++;
    }
  }
}

void Mann_set ( BYTE index )
{
  int i, j, h=index*400, k=MLi.shape*400;

  for ( i=0; i<20; i++ )
  {
    for ( j=0; j<20; j++ )
    {
      if ( ((MLi.x+j)<Mrechts)&&((MLi.x+j)>Mlinks)&&((MLi.y+i)>Moben)&&((MLi.y+i)<Munten) )
      {
        MannBack[h] = vgetpix( MLi.x+j, MLi.y+i);
        if ( (MannData[k]>6)&&(MannData[k]<111)&&(MannBack[h]<90) ) vsetpix( MLi.x+j, MLi.y+i, MannData[k]); 
      }
    h++; k++;
    }
  }
}

void Feind_back_restore ( BYTE index )
{
  int i, j, h=index*400;

  for ( i=0; i<20; i++ )
  {
    for ( j=0; j<20; j++ )
    {
      if ( ((FLi.x1+j)<Mrechts)&&((FLi.x1+j)>Mlinks)&&((FLi.y1+i)>Moben)&&((FLi.y1+i)<Munten) )
        vsetpix(FLi.x1+j, FLi.y1+i, FeindBack[h]);
      h++;
    }
  }
}

void Feind_set ( BYTE index )
{
  int i, j, h=index*400, k=FLi.shape*400;

  for ( i=0; i<20; i++ )
  {
    for ( j=0; j<20; j++ )
    {
      if ( ((FLi.x+j)<Mrechts)&&((FLi.x+j)>Mlinks)&&((FLi.y+i)>Moben)&&((FLi.y+i)<Munten) )
      {
        FeindBack[h] = vgetpix( FLi.x+j, FLi.y+i);
        if ( (MannData[k]>6)&&(MannData[k]<111)&&(FeindBack[h]<90) ) vsetpix( FLi.x+j, FLi.y+i, MannData[k]); 
      }
    h++; k++;
    }
  }
}

void Mann_akt_set ( BYTE index )
{
  int i, j, h=index*400, k=MLi.shape*400;

  for ( i=0; i<20; i++ )
  {
    for ( j=0; j<20; j++ )
    {
      if ( ((MLi.x+j)<Mrechts)&&((MLi.x+j)>Mlinks)&&((MLi.y+i)>Moben)&&((MLi.y+i)<Munten) )
      {
        MannBack[h] = vgetpix( MLi.x+j, MLi.y+i);
        if ( ((MannData[k]>6)&&(MannBack[h]<90)) ) vsetpix( MLi.x+j, MLi.y+i, MannData[k]); 
      }
    h++; k++;
    }
  }
  //---------------------------- X-Werte ----------------------------------------------------------------------------------------------------------------------------------------------
  for ( i= 2; i< 6; i++ ) if ( ((MLi.x+i)<Mrechts)&&((MLi.x+i)>Mlinks)&&((MLi.y+ 1)>Moben)&&((MLi.y+ 1)<Munten) ) vsetpix(MLi.x+i, MLi.y+1,  254);
  for ( i=14; i<18; i++ ) if ( ((MLi.x+i)<Mrechts)&&((MLi.x+i)>Mlinks)&&((MLi.y+ 1)>Moben)&&((MLi.y+ 1)<Munten) ) vsetpix(MLi.x+i, MLi.y+1,  254);
  for ( i= 2; i< 6; i++ ) if ( ((MLi.x+i)<Mrechts)&&((MLi.x+i)>Mlinks)&&((MLi.y+15)>Moben)&&((MLi.y+15)<Munten) ) vsetpix(MLi.x+i, MLi.y+15, 254);
  for ( i=14; i<18; i++ ) if ( ((MLi.x+i)<Mrechts)&&((MLi.x+i)>Mlinks)&&((MLi.y+15)>Moben)&&((MLi.y+15)<Munten) ) vsetpix(MLi.x+i, MLi.y+15, 254);
  //---------------------------- Y-Werte ----------------------------------------------------------------------------------------------------------------------------------------------
  for ( i= 2; i< 6; i++ ) if ( ((MLi.x+ 2)<Mrechts)&&((MLi.x+ 2)>Mlinks)&&((MLi.y+i)>Moben)&&((MLi.y+i)<Munten) ) vsetpix(MLi.x+2,  MLi.y+i,  254);
  for ( i=12; i<16; i++ ) if ( ((MLi.x+ 2)<Mrechts)&&((MLi.x+ 2)>Mlinks)&&((MLi.y+i)>Moben)&&((MLi.y+i)<Munten) ) vsetpix(MLi.x+2,  MLi.y+i,  254);
  for ( i= 2; i< 6; i++ ) if ( ((MLi.x+17)<Mrechts)&&((MLi.x+17)>Mlinks)&&((MLi.y+i)>Moben)&&((MLi.y+i)<Munten) ) vsetpix(MLi.x+17, MLi.y+i,  254);
  for ( i=12; i<16; i++ ) if ( ((MLi.x+17)<Mrechts)&&((MLi.x+17)>Mlinks)&&((MLi.y+i)>Moben)&&((MLi.y+i)<Munten) ) vsetpix(MLi.x+17, MLi.y+i,  254);

  for ( i=13; i>13-((MLi.energie*100)/16); i-=2 )
  {
    if ( ((MLi.x+15)<Mrechts)&&((MLi.x+15)>Mlinks)&&((MLi.y+i)>Moben)&&((MLi.y+i)<Munten) )
    {
      if ( (i == 13) || ( i == 11 ) ) vsetpix(MLi.x+15, MLi.y+i,  242);
      if ( (i ==  9) || ( i ==  7 ) ) vsetpix(MLi.x+15, MLi.y+i,  251);
      if ( (i ==  5) || ( i ==  3 ) ) vsetpix(MLi.x+15, MLi.y+i,  244);
    }
  }
}













void Mann_compute ( BYTE index )
{
  int i, j, ho, hu, hr, hl;
  BYTE links=0, rechts=0;

  if ( MLi.del >= mann_del )// Ist der Mann berhaupt an der Reihe
  {
    MLi.del = 0;
    MF[(MLi.feldy)][(MLi.feldx)] = index+1; 

    if ( MLi.energie <= 0 )
    {
       MF[MLi.feldy][MLi.feldx] = 0;
       Mann_back_restore(index); MannDelete(index); return;
    }

    //--------------------- Hindernis RECHTS ----------------------------------------
    if ( (MLi.ax < MLi.dx)&&(Feld[MLi.feldy][MLi.feldx+1] > Hindernis)&&(MLi.stop<=3) )
    {
      ho = hu = 0;
      MLi.stop = 4;         // 3 bedeutet, da ein 2.Koordinatanpaar vorliegt
      if ( MLi.dcount <= 5 )
      {
        MLi.dcount++;
        MLi.d[MLi.dcount].x = MLi.dx;
        MLi.d[MLi.dcount].y   = MLi.dy;
      }
      else { MLi.dx = MLi.d[0].x; MLi.dy = MLi.d[0].y; MLi.stop = 0; MLi.dcount = 0; goto gehen; }
      if ( (Feld[MLi.feldy-1][MLi.feldx+1] > Hindernis) )
      {
        for ( i=1; i<MLi.feldy; i++ )
        {
          if ( (Feld[MLi.feldy-i][MLi.feldx+1] > Hindernis) ) ho++;
          else break;
        }
      }
      if ( (Feld[MLi.feldy+1][MLi.feldx+1] > Hindernis) )
      {
        for ( i=1; i<(FELD_Y+10)-MLi.feldy; i++ )
        {
          if ( (Feld[MLi.feldy+i][MLi.feldx+1] > Hindernis) ) hu++;
          else break;
        }
      }
      MLi.dx = MLi.ax;
      if ( MLi.d[MLi.dcount].y >  MLi.ay ) MLi.dy = ((MLi.feldy+hu+1)*20);
      if ( MLi.d[MLi.dcount].y <  MLi.ay ) MLi.dy = ((MLi.feldy-ho-1)*20);
      if ( MLi.d[MLi.dcount].y == MLi.ay )
      {
        if ( hu <  ho ) MLi.dy = ((MLi.feldy+hu+1)*20);
        if ( ho <  hu ) MLi.dy = ((MLi.feldy-ho-1)*20);
        if ( ho == hu ) MLi.dy = ((MLi.feldy-ho-1)*20);
      }
      goto gehen;
    }
    //--------------------- Hindernis LINKS -----------------------------------------
    if ( (MLi.ax > MLi.dx)&&(Feld[MLi.feldy][MLi.feldx] > Hindernis)&&(MLi.stop<=3) )
    {
      ho = hu = 0;
      MLi.stop = 5;         // 3 bedeutet, da ein 2.Koordinatanpaar vorliegt
      if ( MLi.dcount <= 5 )
      {
        MLi.dcount++;
        MLi.d[MLi.dcount].x = MLi.dx;
        MLi.d[MLi.dcount].y   = MLi.dy;
      }
      else { MLi.dx = MLi.d[0].x; MLi.dy = MLi.d[0].y; MLi.stop = 0; MLi.dcount = 0; goto gehen; }
      if ( (Feld[MLi.feldy-1][MLi.feldx] > Hindernis) )
      {
        for ( i=1; i<MLi.feldy; i++ )
        {
          if ( (Feld[MLi.feldy-i][MLi.feldx] > Hindernis) ) ho++;
          else break;
        }
      }
      if ( (Feld[MLi.feldy+1][MLi.feldx] > Hindernis) )
      {
        for ( i=1; i<(FELD_Y+10)-MLi.feldy; i++ )
        {
          if ( (Feld[MLi.feldy+i][MLi.feldx] > Hindernis) ) hu++;
          else break;
        }
      }
      MLi.dx = MLi.ax;
      if ( MLi.d[MLi.dcount].y >  MLi.ay ) MLi.dy = ((MLi.feldy+hu+1)*20);
      if ( MLi.d[MLi.dcount].y <  MLi.ay ) MLi.dy = ((MLi.feldy-ho-1)*20);
      if ( MLi.d[MLi.dcount].y == MLi.ay )
      {
        if ( hu <  ho ) MLi.dy = ((MLi.feldy+hu+1)*20);
        if ( ho <  hu ) MLi.dy = ((MLi.feldy-ho-1)*20);
        if ( ho == hu ) MLi.dy = ((MLi.feldy-ho-1)*20);
      }
      goto gehen;
    }
    // --------------------------- Nach UNTEN ---------------------------------------
    if ( (MLi.ay < MLi.dy)&&(Feld[MLi.feldy+1][MLi.feldx] > Hindernis)&&(MLi.stop<=3) )
    {                                                                             
      hr = hl = 0;
      MLi.stop = 6;         // 3 bedeutet, da ein 2.Koordinatanpaar vorliegt
      if ( MLi.dcount <= 5 )
      {
        MLi.dcount++;
        MLi.d[MLi.dcount].x = MLi.dx;
        MLi.d[MLi.dcount].y   = MLi.dy;
      }
      else { MLi.dx = MLi.d[0].x; MLi.dy = MLi.d[0].y; MLi.stop = 0; MLi.dcount = 0; goto gehen; }
      if ( (Feld[MLi.feldy+1][MLi.feldx-1] > Hindernis) )
      {
        for ( i=1; i<MLi.feldx; i++ )
        {
          if ( (Feld[MLi.feldy+1][MLi.feldx-i] > Hindernis) ) hl++;
          else break;
        }
      }
      if ( (Feld[MLi.feldy+1][MLi.feldx+1] > Hindernis) )
      {
        for ( i=1; i<(FELD_X+20)-MLi.feldx; i++ )
        {
          if ( (Feld[MLi.feldy+1][MLi.feldx+i] > Hindernis) ) hr++;
          else break;
        }
      }
      MLi.dy = MLi.ay;
      if ( MLi.d[MLi.dcount].x >  MLi.ax ) MLi.dx = ((MLi.feldx+hr+1)*20);
      if ( MLi.d[MLi.dcount].x <  MLi.ax ) MLi.dx = ((MLi.feldx-hl-1)*20);
      if ( MLi.d[MLi.dcount].x == MLi.ax )
      {
        if ( hr <  hl ) MLi.dx = ((MLi.feldx+hr+1)*20);
        if ( hl <  hr ) MLi.dx = ((MLi.feldx-hl-1)*20);
        if ( hl == hr ) MLi.dx = ((MLi.feldx-hl-1)*20);
      }
      goto gehen;
    }
    // --------------------------- Nach OBEN ----------------------------------------
    if ( (MLi.ay > MLi.dy)&&(Feld[MLi.feldy][MLi.feldx] > Hindernis)&&(MLi.stop<=3) )
    {
      hr = hl = 0;
      MLi.stop = 7;         // 3 bedeutet, da ein 2.Koordinatanpaar vorliegt
      if ( MLi.dcount <= 5 )
      {
        MLi.dcount++;
        MLi.d[MLi.dcount].x = MLi.dx;
        MLi.d[MLi.dcount].y   = MLi.dy;
      }
      else { MLi.dx = MLi.d[0].x; MLi.dy = MLi.d[0].y; MLi.stop = 0; MLi.dcount = 0; goto gehen; }
      if ( (Feld[MLi.feldy][MLi.feldx-1] > Hindernis) )
      {
        for ( i=1; i<MLi.feldx; i++ )
        {
          if ( (Feld[MLi.feldy][MLi.feldx-i] > Hindernis) ) hl++;
          else break;
        }
      }
      if ( (Feld[MLi.feldy][MLi.feldx+1] > Hindernis) )
      {
        for ( i=1; i<(FELD_X+20)-MLi.feldx; i++ )
        {
          if ( (Feld[MLi.feldy][MLi.feldx+i] > Hindernis) ) hr++;
          else break;
        }
      }
      MLi.dy = MLi.ay;
      if ( MLi.d[MLi.dcount].x >  MLi.ax ) MLi.dx = ((MLi.feldx+hr+1)*20);
      if ( MLi.d[MLi.dcount].x <  MLi.ax ) MLi.dx = ((MLi.feldx-hl-1)*20);
      if ( MLi.d[MLi.dcount].x == MLi.ax )
      {
        if ( hr <  hl ) MLi.dx = ((MLi.feldx+hr+1)*20);
        if ( hl <  hr ) MLi.dx = ((MLi.feldx-hl-1)*20);
        if ( hl == hr ) MLi.dx = ((MLi.feldx-hl-1)*20);
      }
      goto gehen;
    }

//======================================================================================
gehen:
//------------------------------ Nach RECHTS ---------------------------------------------------------------------
    if ( MLi.ax < MLi.dx )
    {
      MLi.ax+=MLi.speed; MLi.x+=MLi.speed;
      if ( MLi.shape < R_ANFANG+MANN_DIV ) MLi.shape = R_ANFANG+MANN_DIV;
      if ( MLi.shape > R_ANFANG+MANN_DIV+R_LANG ) MLi.shape = R_ANFANG+MANN_DIV;
      MLi.shape++; rechts= 1; MoveListe[index] = 1;
    }
//------------------------------ Nach LINKS ---------------------------------
    if ( MLi.ax > MLi.dx )
    {
      MLi.ax-=MLi.speed; MLi.x-=MLi.speed;
      if ( (MLi.shape>L_ANFANG+MANN_DIV+L_LANG)&&(!(MLi.ay>MLi.dy)) ) MLi.shape = L_ANFANG+MANN_DIV;
      MLi.shape++; links= 1; MoveListe[index] = 1;
    }
//------------------------------ Nach UNTEN ---------------------------------
    if ( MLi.ay < MLi.dy )
    {
      MLi.ay+=MLi.speed; MLi.y+=MLi.speed;
      if ( MLi.shape < U_ANFANG+MANN_DIV ) MLi.shape = U_ANFANG+MANN_DIV;
      if ( MLi.shape > U_ANFANG+MANN_DIV+U_LANG ) MLi.shape = U_ANFANG+MANN_DIV;
      MLi.shape++; MoveListe[index] = 1;
    }
//------------------------------ Nach OBEN ----------------------------------
    if ( MLi.ay > MLi.dy )
    {
      MLi.ay-=MLi.speed; MLi.y-=MLi.speed;
      if ( links )
      {
        if ( MLi.shape < 63 ) MLi.shape = 63;
        if ( MLi.shape > 68 ) MLi.shape = 63;
      }
      else
      {
        if ( MLi.shape < O_ANFANG+MANN_DIV ) MLi.shape = O_ANFANG+MANN_DIV;
        if ( MLi.shape > O_ANFANG+MANN_DIV+O_LANG ) MLi.shape = O_ANFANG+MANN_DIV;
        MLi.shape++;
      }
      MoveListe[index] = 1;
    }
//---------------------------- Sonstiges ------------------------------------
    if ( (!MoveListe[index])&&(MLi.shape>0) )
    {
      if ( MLi.shape<R_ANFANG+MANN_DIV ) MLi.shape=L_ANFANG+MANN_DIV;
      if ( MLi.shape>R_ANFANG+MANN_DIV ) MLi.shape=R_ANFANG+MANN_DIV;
      MoveListe[index]= 0;
    }

//============================================================================

 
    if ( (MLi.ay==MLi.dy)&&(MLi.ax==MLi.dx) )
    {
      if ( MLi.stop == 4 ) { MLi.dx += 21; MLi.stop = 3; } // Rechts
      if ( MLi.stop == 5 ) { MLi.dx -= 21; MLi.stop = 3; } // Links
      if ( MLi.stop == 6 ) { MLi.dy += 21; MLi.stop = 3; } // Unten
      if ( MLi.stop == 7 ) { MLi.dy -= 21; MLi.stop = 3; } // Oben
    }

    if ( (MLi.ay==MLi.dy)&&(MLi.ax==MLi.dx)&&(MLi.stop==3) )
    {
      MLi.dy = MLi.d[MLi.dcount].y;
      MLi.dx = MLi.d[MLi.dcount--].x;
      MLi.stop = 0;
    }

    if ( MoveListe[index] == 0 )
    {
      j = rand() % 4;
      if ( MLi.stop == 0 ) MLi.stop = 51;
      if ( MLi.stop == 51 )
      {
        MLi.stop++;
        if ( j == 0 ) MLi.shape=L_ANFANG+MANN_DIV;
        if ( j == 1 ) MLi.shape=R_ANFANG+MANN_DIV;
        if ( j == 2 ) MLi.shape=O_ANFANG+MANN_DIV;
        if ( j == 3 ) MLi.shape=U_ANFANG+MANN_DIV;
        MoveListe[index]=1;
      }
      if ( MLi.stop > 51 ) MLi.stop++;
      if ( MLi.stop == 170 )
      {
        if ( j == 0 ) MLi.shape=L_ANFANG+MANN_DIV;
        if ( j == 1 ) MLi.shape=R_ANFANG+MANN_DIV;
        if ( j == 2 ) MLi.shape=O_ANFANG+MANN_DIV;
        if ( j == 3 ) MLi.shape=U_ANFANG+MANN_DIV;
        MoveListe[index]=1;
      }
      if ( MLi.stop == 220 ) MLi.stop = 51; 
    }

    if ( MLi.feldx != MLi.ax/20 )              // alte X-Pos. im Feld lschen
    {
       MannFeld[MLi.feldy][MLi.feldx] = 0;
       MLi.feldx = MLi.ax/20;
    }
    if ( MLi.feldy != MLi.ay/20 )              // alte Y-Pos. im Feld lschen
    {
       MannFeld[MLi.feldy][MLi.feldx] = 0;
       MLi.feldy = MLi.ay/20;
    }
  }
  if ( (m_x>MLi.x-15)&&(m_x<MLi.x+15)&&(m_y>MLi.y-15)&&(m_y<MLi.y+15)&&(!AktListe[index]) )
     m_show_image=7;
  
//----------------------- Kommt immer dran -----------------------------------
  MLi.del++;
}


















void Feind_compute ( BYTE index )
{
  int ho, hu, hr, hl;
  int i, j, h, dist;
  BYTE links=0, rechts=0;

  if ( FLi.del >= mann_del )    // Ist der Mann berhaupt an der Reihe
  {
    FLi.del = 0; MF[(FLi.ay/20)][(FLi.ax/20)] = index+200;
    if ( FLi.energie <= 0 )
    {
       MF[FLi.feldy][FLi.feldx] = 0;
       Feind_back_restore(index); FeindDelete(index); return;
    }

  if ( FLi.job == OnMyWay )
  {
    if ( ((FLi.dx/20) == FLi.tx)&&((FLi.dy/20) == FLi.ty) )
    {
      FLi.job = SaveMain;
      HauptAnz++;
      return;
    }
  }

//-----------------------------------------------------------------------------
    if ( (FLi.attack == 255)&&(FLi.job != OnMyWay) )
    {
      if ( FLi.ty-FLi.reach < 0 )       hu = FLi.ty;          else hu = FLi.reach;
      if ( FLi.ty+FLi.reach > y_breit ) ho = y_breit-FLi.ty;  else ho = FLi.reach;
      if ( FLi.tx-FLi.reach < 0 )       hr = FLi.tx;          else hr = FLi.reach;
      if ( FLi.tx+FLi.reach > x_lang )  hl = x_lang-FLi.tx;   else hl = FLi.reach;

      FLi.dx = FLi.tx*20; FLi.dy = FLi.ty*20;

      for (i=FLi.ty-hu; i<=FLi.ty+ho; i++)
      {
        for (j=FLi.tx-hr; j<=FLi.tx+hl; j++)
        {
          if ( (MF[i][j] < 200)&&(MF[i][j] > 0) )
          {
            h = MF[i][j]-1;
            FLi.attack = h;
            FLi.dx = ML[h].ax;
            FLi.dy = ML[h].ay;
            break;
          }
        }
      }
    }

    if ( (FLi.ax<(FLi.tx-(FLi.reach-1))*20)||(FLi.ax>(FLi.tx+(FLi.reach-1))*20) ) { FLi.dx = FLi.tx*20; FLi.dy = FLi.ty*20; FLi.attack=255; goto gehen1; }
    if ( (FLi.ay<(FLi.ty-(FLi.reach-1))*20)||(FLi.ay>(FLi.ty+(FLi.reach-1))*20) ) { FLi.dx = FLi.tx*20; FLi.dy = FLi.ty*20; FLi.attack=255; goto gehen1; }

    if ( FLi.attack != 255 ) { FLi.dx = ML[FLi.attack].ax; FLi.dy = ML[FLi.attack].ay; }

//-----------------------------------------------------------------------------
    if ( FLi.attack < 255 )
    {
       if ( FLi.feldx < ML[FLi.attack].feldx ) dist = ML[FLi.attack].feldx-FLi.feldx;
       else dist = FLi.feldx-ML[FLi.attack].feldx;

       if ( FLi.feldy < ML[FLi.attack].feldy ) dist += ML[FLi.attack].feldy-FLi.feldy;
       else dist += FLi.feldy-ML[FLi.attack].feldy;

       if ( dist < 6 )
       {
         if ( ML[FLi.attack].ax > FLi.ax )
         {
           if ( FLi.shape < ANGRIF_R ) FLi.shape = ANGRIF_R;
           if ( FLi.shape > ANGRIF_R+ANGRIF_RL ) FLi.shape = ANGRIF_R;
           FLi.shape++; goto atack;
         }
         if ( ML[FLi.attack].ax < FLi.ax )
         {
           if ( FLi.shape < ANGRIF_L ) FLi.shape = ANGRIF_L;
           if ( FLi.shape > ANGRIF_L+ANGRIF_LL ) FLi.shape = ANGRIF_L;
           FLi.shape++; goto atack;
         }  
         if ( ML[FLi.attack].ay > FLi.ay ) FLi.shape = ANGRIF_U;
         if ( ML[FLi.attack].ay <= FLi.ay ) FLi.shape = ANGRIF_O;
       
atack:
         ML[FLi.attack].energie--;
         if ( (ML[FLi.attack].energie == 0)||(ML[FLi.attack].energie == 255) )
         {
           FLi.dx = FLi.tx*20; FLi.dy = FLi.ty*20;
           FLi.attack = 255;
         }
         MoveListe[index+200] = 1; MoveListe[FLi.attack] = 1;
         return;
       } // if in Reichweite
    }
//----------------------------------------------------------------------------

    //--------------------- Hindernis RECHTS ----------------------------------------
    if ( (FLi.ax < FLi.dx)&&(Feld[FLi.feldy][FLi.feldx+1] > Hindernis) )
    {
      ho = hu = 0;
      FLi.stop = 4;         // 3 bedeutet, da ein 2.Koordinatanpaar vorliegt
      if ( FLi.dcount <= 5 )
      {
        FLi.dcount++;
        FLi.d[FLi.dcount].x = FLi.dx;
        FLi.d[FLi.dcount].y   = FLi.dy;
      }
      else { FLi.dx = FLi.d[0].x; FLi.dy = FLi.d[0].y; FLi.stop = 0; FLi.dcount = 0; goto gehen1; }
      if ( (Feld[FLi.feldy-1][FLi.feldx+1] > Hindernis) )
      {
        for ( i=1; i<FLi.feldy; i++ )
        {
          if ( (Feld[FLi.feldy-i][FLi.feldx+1] > Hindernis) ) ho++;
          else break;
        }
      }
      if ( (Feld[FLi.feldy+1][FLi.feldx+1] > Hindernis) )
      {
        for ( i=1; i<(FELD_Y+10)-FLi.feldy; i++ )
        {
          if ( (Feld[FLi.feldy+i][FLi.feldx+1] > Hindernis) ) hu++;
          else break;
        }
      }
      FLi.dx = FLi.ax;
      if ( FLi.d[FLi.dcount].y >  FLi.ay ) FLi.dy = ((FLi.feldy+hu+1)*20);
      if ( FLi.d[FLi.dcount].y <  FLi.ay ) FLi.dy = ((FLi.feldy-ho-1)*20);
      if ( FLi.d[FLi.dcount].y == FLi.ay )
      {
        if ( hu <  ho ) FLi.dy = ((FLi.feldy+hu+1)*20);
        if ( ho <  hu ) FLi.dy = ((FLi.feldy-ho-1)*20);
        if ( ho == hu ) FLi.dy = ((FLi.feldy-ho-1)*20);
      }
      goto gehen1;
    }
    //--------------------- Hindernis LINKS -----------------------------------------
    if ( (FLi.ax > FLi.dx)&&(Feld[FLi.feldy][FLi.feldx] > Hindernis) )
    {
      ho = hu = 0;
      FLi.stop = 5;         // 3 bedeutet, da ein 2.Koordinatanpaar vorliegt
      if ( FLi.dcount <= 5 )
      {
        FLi.dcount++;
        FLi.d[FLi.dcount].x = FLi.dx;
        FLi.d[FLi.dcount].y   = FLi.dy;
      }
      else { FLi.dx = FLi.d[0].x; FLi.dy = FLi.d[0].y; FLi.stop = 0; FLi.dcount = 0; goto gehen1; }
      if ( (Feld[FLi.feldy-1][FLi.feldx] > Hindernis) )
      {
        for ( i=1; i<FLi.feldy; i++ )
        {
          if ( (Feld[FLi.feldy-i][FLi.feldx] > Hindernis) ) ho++;
          else break;
        }
      }
      if ( (Feld[FLi.feldy+1][FLi.feldx] > Hindernis) )
      {
        for ( i=1; i<(FELD_Y+10)-FLi.feldy; i++ )
        {
          if ( (Feld[FLi.feldy+i][FLi.feldx] > Hindernis) ) hu++;
          else break;
        }
      }
      FLi.dx = FLi.ax;
      if ( FLi.d[FLi.dcount].y >  FLi.ay ) FLi.dy = ((FLi.feldy+hu+1)*20);
      if ( FLi.d[FLi.dcount].y <  FLi.ay ) FLi.dy = ((FLi.feldy-ho-1)*20);
      if ( FLi.d[FLi.dcount].y == FLi.ay )
      {
        if ( hu <  ho ) FLi.dy = ((FLi.feldy+hu+1)*20);
        if ( ho <  hu ) FLi.dy = ((FLi.feldy-ho-1)*20);
        if ( ho == hu ) FLi.dy = ((FLi.feldy-ho-1)*20);
      }
      goto gehen1;
    }
    // --------------------------- Hindernis UNTEN ---------------------------------------
    if ( (FLi.ay < FLi.dy)&&(Feld[FLi.feldy+1][FLi.feldx] > Hindernis) )
    {                                                                             
      hr = hl = 0;
      FLi.stop = 6;         // 3 bedeutet, da ein 2.Koordinatanpaar vorliegt
      if ( FLi.dcount <= 5 )
      {
        FLi.dcount++;
        FLi.d[FLi.dcount].x = FLi.dx;
        FLi.d[FLi.dcount].y   = FLi.dy;
      }
      else { FLi.dx = FLi.d[0].x; FLi.dy = FLi.d[0].y; FLi.stop = 0; FLi.dcount = 0; goto gehen1; }
      if ( (Feld[FLi.feldy+1][FLi.feldx-1] > Hindernis) )
      {
        for ( i=1; i<FLi.feldx; i++ )
        {
          if ( (Feld[FLi.feldy+1][FLi.feldx-i] > Hindernis) ) hl++;
          else break;
        }
      }
      if ( (Feld[FLi.feldy+1][FLi.feldx+1] > Hindernis) )
      {
        for ( i=1; i<(FELD_X+20)-FLi.feldx; i++ )
        {
          if ( (Feld[FLi.feldy+1][FLi.feldx+i] > Hindernis) ) hr++;
          else break;
        }
      }
      FLi.dy = FLi.ay;
      if ( FLi.d[FLi.dcount].x >  FLi.ax ) FLi.dx = ((FLi.feldx+hr+1)*20);
      if ( FLi.d[FLi.dcount].x <  FLi.ax ) FLi.dx = ((FLi.feldx-hl-1)*20);
      if ( FLi.d[FLi.dcount].x == FLi.ax )
      {
        if ( hr <  hl ) FLi.dx = ((FLi.feldx+hr+1)*20);
        if ( hl <  hr ) FLi.dx = ((FLi.feldx-hl-1)*20);
        if ( hl == hr ) FLi.dx = ((FLi.feldx-hl-1)*20);
      }
      goto gehen1;
    }
    // --------------------------- Hindernis OBEN ----------------------------------------
    if ( (FLi.ay > FLi.dy)&&(Feld[FLi.feldy][FLi.feldx] > Hindernis) )
    {
      hr = hl = 0;
      FLi.stop = 7;         // 3 bedeutet, da ein 2.Koordinatanpaar vorliegt
      if ( FLi.dcount <= 5 )
      {
        FLi.dcount++;
        FLi.d[FLi.dcount].x = FLi.dx;
        FLi.d[FLi.dcount].y   = FLi.dy;
      }
      else { FLi.dx = FLi.d[0].x; FLi.dy = FLi.d[0].y; FLi.stop = 0; FLi.dcount = 0; goto gehen1; }
      if ( (Feld[FLi.feldy][FLi.feldx-1] > Hindernis) )
      {
        for ( i=1; i<FLi.feldx; i++ )
        {
          if ( (Feld[FLi.feldy][FLi.feldx-i] > Hindernis) ) hl++;
          else break;
        }
      }
      if ( (Feld[FLi.feldy][FLi.feldx+1] > Hindernis) )
      {
        for ( i=1; i<(FELD_X+20)-FLi.feldx; i++ )
        {
          if ( (Feld[FLi.feldy][FLi.feldx+i] > Hindernis) ) hr++;
          else break;
        }
      }
      FLi.dy = FLi.ay;
      if ( FLi.d[FLi.dcount].x >  FLi.ax ) FLi.dx = ((FLi.feldx+hr+1)*20);
      if ( FLi.d[FLi.dcount].x <  FLi.ax ) FLi.dx = ((FLi.feldx-hl-1)*20);
      if ( FLi.d[FLi.dcount].x == FLi.ax )
      {
        if ( hr <  hl ) FLi.dx = ((FLi.feldx+hr+1)*20);
        if ( hl <  hr ) FLi.dx = ((FLi.feldx-hl-1)*20);
        if ( hl == hr ) FLi.dx = ((FLi.feldx-hl-1)*20);
      }
      goto gehen1;
    }

gehen1:
//------------------------------ Nach RECHTS --------------------------------
    if ( FLi.ax < FLi.dx )
    {
      FLi.ax+=1; FLi.x+=1;
      if ( FLi.shape < R_ANFANG ) FLi.shape = R_ANFANG;
      if ( FLi.shape > R_ANFANG+R_LANG ) FLi.shape = R_ANFANG;
      FLi.shape++; rechts= 1; MoveListe[200+index] = 1;
    }
//------------------------------ Nach LINKS ---------------------------------
    if ( FLi.ax > FLi.dx )
    {
      FLi.ax-=1; FLi.x-=1;
      if ( FLi.shape > L_ANFANG+L_LANG ) FLi.shape = L_ANFANG;
      FLi.shape++; links= 1; MoveListe[200+index] = 1;
    }
//------------------------------ Nach UNTEN ---------------------------------
    if ( FLi.ay < FLi.dy )
    {
      FLi.ay+=1; FLi.y+=1;
      if ( FLi.shape < U_ANFANG ) FLi.shape = U_ANFANG;
      if ( FLi.shape > U_ANFANG+U_LANG ) FLi.shape = U_ANFANG;
      FLi.shape++; MoveListe[200+index] = 1;
    }
//------------------------------ Nach OBEN ----------------------------------
    if ( FLi.ay > FLi.dy )
    {
      FLi.ay-=1; FLi.y-=1;
      if ( FLi.shape < O_ANFANG ) FLi.shape = O_ANFANG;
      if ( FLi.shape > O_ANFANG+O_LANG ) FLi.shape = O_ANFANG;
      FLi.shape++; MoveListe[200+index] = 1;
    }

//----------------------------- Sonstiges ------------------------------------

    if ( (!MoveListe[index+200])&&(FLi.shape>0) )
    {
      if ( FLi.shape<R_ANFANG ) FLi.shape=L_ANFANG;
      if ( FLi.shape>R_ANFANG ) FLi.shape=R_ANFANG;
      MoveListe[index]= 0;
    }


    if ( (FLi.ay==FLi.dy)&&(FLi.ax==FLi.dx) )
    {
      if ( FLi.stop == 4 ) { FLi.dx += 21; FLi.stop = 3; } // Rechts
      if ( FLi.stop == 5 ) { FLi.dx -= 21; FLi.stop = 3; } // Links
      if ( FLi.stop == 6 ) { FLi.dy += 21; FLi.stop = 3; } // Unten
      if ( FLi.stop == 7 ) { FLi.dy -= 21; FLi.stop = 3; } // Oben
    }

    if ( (FLi.ay==FLi.dy)&&(FLi.ax==FLi.dx)&&(FLi.stop==3) )
    {
      FLi.dy = FLi.d[FLi.dcount].y;
      FLi.dx = FLi.d[FLi.dcount--].x;
      FLi.stop = 0;
    }

    if ( MoveListe[index+200] == 0 )
    {
      j = rand() % 4;
      if ( FLi.stop == 0 ) FLi.stop = 51;
      if ( FLi.stop == 51 )
      {
        FLi.stop++;
        if ( j == 0 ) FLi.shape=L_ANFANG;
        if ( j == 1 ) FLi.shape=R_ANFANG;
        if ( j == 2 ) FLi.shape=O_ANFANG;
        if ( j == 3 ) FLi.shape=U_ANFANG;
        MoveListe[index+200]=1;
      }
      if ( FLi.stop > 51 ) FLi.stop++;
      if ( FLi.stop == 170 )
      {
        if ( j == 0 ) FLi.shape=L_ANFANG;
        if ( j == 1 ) FLi.shape=R_ANFANG;
        if ( j == 2 ) FLi.shape=O_ANFANG;
        if ( j == 3 ) FLi.shape=U_ANFANG;
        MoveListe[index+200]=1;
      }
      if ( FLi.stop == 220 ) FLi.stop = 51; 
    }


    if ( FLi.feldx != FLi.ax/20 )              // alte X-Pos. im Feld lschen
    {
       MannFeld[FLi.feldy][FLi.feldx] = 0;
       FLi.feldx = FLi.ax/20;
    }
    if ( FLi.feldy != FLi.ay/20 )              // alte Y-Pos. im Feld lschen
    {
       MannFeld[FLi.feldy][FLi.feldx] = 0;
       FLi.feldy = FLi.ay/20;
    }

  }
  if ( (m_x>FLi.x-15)&&(m_x<FLi.x+15)&&(m_y>FLi.y-15)&&(m_y<FLi.y+15)&&(go) )
     atack= 1;
  
  FLi.del++;
}
