//
// maps.h
//
#define MAP_X           100
#define MAP_Y           100

void LoadMap ( char *Datei )
{
  FILE *D;
  char sign[2];

  chdir("MISSION");
  if ( (D = fopen(Datei, "rb")) == NULL )
  {
    chdir(".."); textmodus();
    printf("\n\nERROR: Kann Datei '%s' nicht laden!\n\n", Datei);
    exit(0);
  }
//------------------------------ Header --------------------------------------
  fread(sign, sizeof(sign), 1, D);
  FeldX = fgetc(D); 
  FeldY = fgetc(D); 
//---------------------------- Karte speichern -------------------------------
  fread(*Karte, sizeof(Karte), 1, D);
//---------------------------- Kennung fr Leute -----------------------------
//-----------------------------------------------------------------------------
  fclose(D);
  chdir("..");
}



void DecodeKarte ( void )
{
  int i, j, h, k, l;
  word puffer, farbe;

  Terrain = (byte *)malloc(4000000);

  for(i=0; i<(FeldY*20)-20; i+=20)   // Schleife fr Y-Richtung ( in Byte )
  {
    for(j=0; j<FeldX; j++)        // Schleife fr X-Richtung ( in 20er Blcken )
    {
      for(k=0; k<20; k++)
      {
        for(l=0; l<20; l++)
        {
          puffer = Karte[i/20][j];
          farbe = (rand()%5)+1; 
          if ( TerrainData[(puffer*400)+(k*20)+l] < 6 ) Terrain[(i*2000)+(j*20)+(k*2000)+l] = farbe;
          else Terrain[(i*2000)+(j*20)+(k*2000)+l] = TerrainData[(puffer*400)+(k*20)+l];
        }
      }
    }
  }
}


void InitKarte ( void )
{
  short i, j;

  for(i=0; i<FeldY; i++)
  {
    for(j=0; j<FeldX; j++)
    {
      switch ( Karte[i][j] )
      {
        case 662:   Animated[AniAnz].x = j*20; Animated[AniAnz].y = i*20;
                    Animated[AniAnz].start = 662; Animated[AniAnz].ende = 675;
                    Animated[AniAnz++].index = 662; break;

        case 676:   Animated[AniAnz].x = j*20; Animated[AniAnz].y = i*20;
                    Animated[AniAnz].start = 676; Animated[AniAnz].ende = 687;
                    Animated[AniAnz++].index = 676; break;
      }
    }
  }
}


void AniKarte ( void )
{
  short i, j;

  for(i=0; i<AniAnz; i++)
  {
    if ( Animated[i].index >= Animated[i].ende ) Animated[i].index = Animated[i].start;
    for(j=0; j<20; j++) memcpy(&Terrain[(Animated[i].y+j)*(MAP_X*20)+Animated[i].x], &TerrainData[(Animated[i].index*400)+(j*20)], 20);
    Animated[i].index++;
  }
}

void Landschaft ( void )
{
  short i;
  if ( ScrollX < 0 ) ScrollX = 0; if ( ScrollX > (FeldX*20)-ResX ) ScrollX = (FeldX*20)-ResX;
  if ( ScrollY < 0 ) ScrollY = 0; if ( ScrollY > (FeldY*20)-ResY-20 ) ScrollY = (FeldY*20)-ResY-20;

  for(i=0; i<Munten; i++) memcpy(&VScreen[i*ResX], &Terrain[((ScrollY+i)*20*MAP_X)+ScrollX], Mrechts); 
}




/*
        if ( Karte[i/20][j] == 0 )
          for(l=0; l<20; l++)
          {
            puffer = (rand()%6)+1; if ( puffer == 6 ) puffer = 23;
            Terrain[(i*2000)+(j*20)+(k*2000)+l] = puffer;
          }
        else
          for(l=0; l<20; l++)
          { 
            puffer = Karte[i/20][j];
            Terrain[(i*2000)+(j*20)+(k*2000)+l] = TerrainData[(puffer*400)+(k*20)+l];
          }

*/
