

//
// rocket.h
//
#include "rauch.h"

#define SPEED   3


void insert_rocket ( int x, int y, int x1, int y1, BYTE type )
{
  RocketAnzahl++;
  if ( RocketAnzahl >= 200 ) { RocketAnzahl--; return; }

  RL[RocketAnzahl].x            = x;
  RL[RocketAnzahl].y            = y;
  RL[RocketAnzahl].ax           = x;
  RL[RocketAnzahl].ay           = y;
  RL[RocketAnzahl].oldx         = x;
  RL[RocketAnzahl].oldy         = y;
  RL[RocketAnzahl].x1           = x1;
  RL[RocketAnzahl].y1           = y1;
  RL[RocketAnzahl].type         = type;
  RL[RocketAnzahl].a_dir        = 0;
  RL[RocketAnzahl].rauch        = 0;

  if ( abs(y-y1) > abs(x-x1) )
  {
    RL[RocketAnzahl].dir = 0;                       // dir = 0 ==> X-Richtung

    if ( y <= y1 ) RL[RocketAnzahl].dir_y = 1;    // Rakete fliegt nach unten
    else RL[RocketAnzahl].dir_y = -1;              // Rakete fliegt nach oben
    if ( x <= x1 ) RL[RocketAnzahl].dir_x = 1;   // Rakete fliegt nach rechts
    else RL[RocketAnzahl].dir_x = -1;             // Rakete fliegt nach links

    RL[RocketAnzahl].div = abs(y-y1)/(abs(x-x1)+1);// Konstante,wann die Nebenrichtung erhht wird
  }
  else
  {
    RL[RocketAnzahl].dir = 1;                       // dir = 0 ==> X-Richtung

    if ( y <= y1 ) RL[RocketAnzahl].dir_y = 1;    // Rakete fliegt nach unten
    else RL[RocketAnzahl].dir_y = -1;              // Rakete fliegt nach oben
    if ( x <= x1 ) RL[RocketAnzahl].dir_x = 1;   // Rakete fliegt nach rechts
    else RL[RocketAnzahl].dir_x = -1;             // Rakete fliegt nach links

    RL[RocketAnzahl].div = abs(x-x1)/(abs(y-y1)+1);// Konstante,wann die Nebenrichtung erhht wird
  }

}


void delete_rocket ( int index )
{
  int i;

  for ( i=index; i<RocketAnzahl; i++ ) RL[i] = RL[i+1];  // index korrigieren
  RocketAnzahl--;
}


void show_rocket ( int index )
{
  int i;
  int a_dir, x, y;

  a_dir = RL[index].a_dir; x = RL[index].ax; y = RL[index].ay; 

  if ( RL[index].dir == 0 )                                  // in Y-Richtung
  {
    for (i=0; i<=SPEED; i++)
    {
      if ( RL[index].a_dir == RL[index].div ) { RL[index].ax+=RL[index].dir_x; RL[index].a_dir = 0; }
      RL[index].a_dir++;
      RL[index].ay += RL[index].dir_y;
      if ( (RL[index].ax<Mrechts)&&(RL[index].ax>Mlinks)&&(RL[index].ay<Munten)&&(RL[index].ay>Moben) ) vsetpix(RL[index].ax, RL[index].ay, 254, res_x);
    }
  }
  else                                                       // in X-Richtung
  {
    for (i=0; i<=SPEED; i++)
    {
      if ( RL[index].a_dir == RL[index].div ) { RL[index].ay+=RL[index].dir_y; RL[index].a_dir = 0; }
      RL[index].a_dir++;
      RL[index].ax += RL[index].dir_x;
      if ( (RL[index].ax<Mrechts)&&(RL[index].ax>Mlinks)&&(RL[index].ay<Munten)&&(RL[index].ay>Moben) ) vsetpix(RL[index].ax, RL[index].ay, 254, res_x);
    }
  }

  if ( (rock_del != mann_del)&&(mann_del> 0) ) { RL[index].a_dir = a_dir; RL[index].ax = x; RL[index].ay = y; }
  if ( (rock_del >= mann_del) )
  {
    if ( RL[index].rauch )
    {
      insert_rauch(RL[index].oldx-7, RL[index].oldy-7);
      RL[index].oldx = RL[index].ax; RL[index].oldy = RL[index].ay;
      RL[index].rauch = 0;
    }
    else RL[index].rauch++;

    if ( (abs(RL[index].y-RL[index].y1)+abs(RL[index].x-RL[index].x1)) <= (abs(RL[index].ay-RL[index].y)+abs(RL[index].ax-RL[index].x)) )
    {
      insert_explosion(RL[index].ax-8, RL[index].ay-5, 2);
      if ( Feld[f_y+(RL[index].ay/20)][f_x+(RL[index].ax/20)] < 2 ) Feld[f_y+(RL[index].ay/20)][f_x+(RL[index].ax/20)] = 2;
      delete_rocket(index);
      return;
    }
  }

}




