//
// rocket.h
//
#define SPEED   4        


void insert_rocket ( int x, int y, int x1, int y1, BYTE type )
{
  RocketAnzahl++;

  RL[RocketAnzahl].x            = x;
  RL[RocketAnzahl].y            = y;
  RL[RocketAnzahl].x1           = x1;
  RL[RocketAnzahl].y1           = y1;
  RL[RocketAnzahl].type         = type;

//// ====================================================================== // 
  if ( abs((x-x1)) < abs((y-y1)) )                      // X oder Y grer
  {
    RL[RocketAnzahl].dir = 0;                           // 0 = in X-Richtung

//  //-- Hier wird festgelegt, in welche X-Richtung erweitert werden mu --//
    if ( (y> y1)&&(x< x1) ) RL[RocketAnzahl].xincr =  1;
    if ( (y> y1)&&(x>=x1) ) RL[RocketAnzahl].xincr = -1;
    if ( (y<=y1)&&(x< x1) ) RL[RocketAnzahl].xincr = -1;
    if ( (y<=y1)&&(x>=x1) ) RL[RocketAnzahl].xincr =  1;
//  //-- --------------------------------------------------------------- --//  

    RL[RocketAnzahl].dy = abs(y - y1);
    RL[RocketAnzahl].dx = abs(x - x1);
    RL[RocketAnzahl].d  = 2 * RL[RocketAnzahl].dx - RL[RocketAnzahl].dy;
    RL[RocketAnzahl].aincr = 2 * (RL[RocketAnzahl].dx - RL[RocketAnzahl].dy);
    RL[RocketAnzahl].bincr = 2 * RL[RocketAnzahl].dx;

//  //-- Anfangsposition --//
    RL[RocketAnzahl].ax = x;
    RL[RocketAnzahl].ay = y;
  }
  else                                             
  {
    RL[RocketAnzahl].dir = 1;                           // 1 = in Y-Richtung

//  //-- Hier wird festgelegt, in welche Y-Richtung erweitert werden mu --//
    if ( (y<=y1)&&(x< x1) ) RL[RocketAnzahl].yincr =  1;         
    if ( (y<=y1)&&(x>=x1) ) RL[RocketAnzahl].yincr = -1;         
    if ( (y> y1)&&(x>=x1) ) RL[RocketAnzahl].yincr = -1;         
    if ( (y> y1)&&(x< x1) ) RL[RocketAnzahl].yincr =  1;         
//  //-- --------------------------------------------------------------- --//  

    RL[RocketAnzahl].dx = abs(x - x1);
    RL[RocketAnzahl].dy = abs(y - y1);
    RL[RocketAnzahl].d  = 2 * RL[RocketAnzahl].dy - RL[RocketAnzahl].dx;
    RL[RocketAnzahl].aincr = 2 * (RL[RocketAnzahl].dy - RL[RocketAnzahl].dx);
    RL[RocketAnzahl].bincr = 2 * RL[RocketAnzahl].dy;

//  //-- Anfangsposition --//
    RL[RocketAnzahl].ax = x;
    RL[RocketAnzahl].ay = y;
  }
//// ====================================================================== // 
}    


void delete_rocket ( BYTE index )
{
  int i;

  for ( i=index; i<RocketAnzahl; i++ ) RL[i] = RL[i+1];  // index korrigieren
  RocketAnzahl--;
}


void show_rocket ( BYTE index )
{
  int i;
  BYTE anz=0;

  if ( RL[index].dir == 0 )                                  // in X-Richtung
  {
    for (i=RL[index].ay+1; i<=RL[index].y1; ++i )
    {
      if ( RL[index].d >= 0 )
      {
        RL[index].ax += RL[index].xincr;
        RL[index].d  += RL[index].aincr;
      }
      else
       RL[index].d += RL[index].bincr;
     if ( (RL[index].ax<Mrechts)&&(RL[index].ax>Mlinks)&&(i<Munten)&&(i>Moben) ) vsetpix(RL[index].ax, i, 254, res_x);
     anz++;
     if ( anz >= SPEED ) break;
    }
    RL[index].ay += i;
  }


  else
  {
    for (i=RL[index].ax+1; i<=RL[index].x1; ++i )
    {
      if ( RL[index].d >= 0 )
      {
        RL[index].y += RL[index].yincr;
        RL[index].d += RL[index].aincr;
      }
      else
       RL[index].d += RL[index].bincr;
      if ( (i<Mrechts)&&(i>Mlinks)&&(RL[index].ay<Munten)&&(RL[index].ay>Moben) ) vsetpix(i, RL[index].y, 253, res_x);
      anz++;
      if ( anz >= SPEED ) break;
    }
    RL[index].ax += i;
  }

  if ( (RL[index].ax == RL[index].x1)&&(RL[index].ay == RL[index].y1) )
  {
    delete_rocket(index); return;
  }

}

