//
// rocket.h
//
#define Y       0
#define X       1



BYTE insert_rocket ( int d_x, int d_y, byte speed, int id )
{
  RocketAnzahl++;
  if ( RocketAnzahl > 199 ) RocketAnzahl--;
  
  RL[RocketAnzahl].x            = 0;
  RL[RocketAnzahl].y            = 0;
  RL[RocketAnzahl].d_x          = d_x;
  RL[RocketAnzahl].d_y          = d_y;

  RL[RocketAnzahl].dir          = 0;
  RL[RocketAnzahl].dir_xy       = 0;
  RL[RocketAnzahl].cur_dir      = 0;
  RL[RocketAnzahl].speed        = speed;
  RL[RocketAnzahl].id           = id;

  return RocketAnzahl;
}

void delete_rocket ( BYTE index )
{
  int i;

  for ( i=index; i<RocketAnzahl; i++ ) RL[i] = RL[i+1];  // index korrigieren
  RocketAnzahl--;
}

void calc_rocket ( BYTE index, int x1, int y1, int x2, int y2 )
{
  if ( abs(x1-x2) < abs(y1-y2) )                  // Y-Wert grer als X-Wert
  {
    RL[index].dir_xy = Y;
    RL[index].intvall = abs(y1-y2)/abs(x1-x2);
  }
  else { RL[index].dir_xy = X; RL[index].intvall = abs(x1-x2)/abs(y1-y2); }

  if ( (x1> x2)&&(y1< y2) && ( RL[index].dir_xy == Y) ) { RL[index].dir = -1; goto calc_ende; }
  if ( (x1> x2)&&(y1>=y2) && ( RL[index].dir_xy == Y) ) { RL[index].dir = 1; goto calc_ende; }
  //------------------------------------------------------------------------//
  if ( (x1<=x2)&&(y1< y2) && ( RL[index].dir_xy == Y) ) { RL[index].dir = 1;  goto calc_ende; }
  if ( (x1<=x2)&&(y1>=y2) && ( RL[index].dir_xy == Y) ) { RL[index].dir = 1;  goto calc_ende; }

  if ( (y1> y2)&&(x1< x2) && ( RL[index].dir_xy == X) ) { RL[index].dir = -1; goto calc_ende; }
  if ( (y1> y2)&&(x1>=x2) && ( RL[index].dir_xy == X) ) { RL[index].dir = 1; goto calc_ende; }
  //------------------------------------------------------------------------//
  if ( (y1<=y2)&&(x1< x2) && ( RL[index].dir_xy == X) ) { RL[index].dir = 1;  goto calc_ende; }
  if ( (y1<=y2)&&(x1>=x2) && ( RL[index].dir_xy == X) ) { RL[index].dir = 1;  goto calc_ende; }

calc_ende:
  RL[index].x = x1; RL[index].y = y1;
}


void compute_rocket ( BYTE index )
{
  int i;

  if ( (RLi.x/20 == RLi.d_x)&&(RLi.y/20 == RLi.d_y) )
  {
    if ( RLi.id > 2000 ) for(i=0; i<=FeindAnzahl; i++) if ( FL[i].rfire == RLi.id ) FL[i].rfire = -1;
    if ( RLi.id < 2000 ) for(i=0; i<=MannAnzahl; i++)  if ( ML[i].rfire == RLi.id ) ML[i].rfire = -1;
    insert_explosion(RLi.x, RLi.y, 2); delete_rocket(index);
    return;
  }

  for(i=0; i<=RL[index].speed; i++)
  {
    if ( RL[index].dir_xy == Y )
    {
      if ( RL[index].cur_dir == RL[index].intvall ) { RL[index].x +=1*RL[index].dir; RL[index].cur_dir = 0; }
      else { RL[index].y +=1*RL[index].dir; RL[index].cur_dir++; }
    }
    else
    {
      if ( RL[index].cur_dir == RL[index].intvall ) { RL[index].y +=1*RL[index].dir; RL[index].cur_dir = 0; }
      else { RL[index].x +=1*RL[index].dir; RL[index].cur_dir++; }
    }
  }
  show_rocket(index);
}


void show_rocket ( BYTE index )
{
  Line(RL[index].x, RL[index].y, RL[index].x+5, RL[index].y, 254);
}



