#include <dos.h>
#include <stdarg.h>
#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <maus.h>
#include <defkon.h>


#define m_save  0
#define m_image 1
#define m_up    3
#define m_down  4
#define m_left  2
#define m_right 5
#define m_franz 6
#define MannMax 100

/*------------------------------- Variablen --------------------------------*/
long XMS_Adr; int XMS_frei, EMB_frei, handle, backh, shapeh;
BYTE XMSErr, MannAnzahl= -1, AktAnzahl= 2;
int m_x= 160, m_y= 100, m_taste, m_visi= 1, x1, y1, m_show_image, i, error, f_y= 0, f_x= 0;
MANN MannListe[200];
BYTE AktListe[200];
/*------------------------------ Konstanten --------------------------------*/
     int PIXEL_ANZAHL = 400;
     int PIXEL_X      = 20;
     int PIXEL_Y      = 20;
     int SPIEL_BREIT  = 12;
     int SPIEL_LANG   = 9;
     int FELD_X	      = 18;
     int FELD_Y       = 30;
     int FELD_ANZAHL  = 18*15;
/*------------------Hier stehen die internen Funktionen---------------------*/
void put_sprite( int x, int y, unsigned int pos );
int  maus_reset( void );
void maus_pos ( void );
void maus_show ( BYTE image );
void m_back_restore ( void );
void m_back_save ( void );
void m_place ( void );
void Landschaft ( int a, int b );
void Feld_bewegen ( void );
void init_Spiel();
void setpix ( int x, int y, BYTE farbe );
BYTE getpix ( int x, int y );
int  MannInsert ( int ax, int ay, BYTE shape );
void Mann_back_save ( BYTE index );
void Mann_back_restore ( BYTE index );
void Mann_set ( BYTE index );
void Mann_compute ( BYTE index );
void Mann_move ( BYTE index );

/*==========================================================================*/
void main( void )
{
   char pal[768]; int i, j;

   init_Spiel();
   delay(1000);

   ClearPalette();
   Landschaft(0, 0);
   LoadPalette("D:\\DISK\\SYNAPS\\DBL\\rasen-01.pcx", pal); SetPalette(pal);
   m_back_save(); m_place(); maus_show(m_image);
   MannInsert(10, 20,  0); MannInsert(40, 20,  0);
   MannInsert(70, 20,  0); MannInsert(100, 20, 0);
   MannInsert(130, 20, 0); MannInsert(160, 20, 0);
   MannInsert(10, 50,  0); MannInsert(40, 50,  0);
   MannInsert(70, 50,  0); MannInsert(100, 50, 0);
   MannInsert(130, 50, 0); MannInsert(160, 50, 0);

   for (i=0; i<12; i++) { Mann_back_save(i); Mann_set(i); }

   while ( m_taste != 3 )
   {
     m_taste = 0;
     maus_pos();
     //---------------------- Mauszeiger richtig setzen ---------------------
     if ( m_x > 300 ) { maus_show( m_right ); Feld_bewegen(); }
     if ( m_x <   5 ) { maus_show( m_left );  Feld_bewegen(); }
     if ( m_y > 180 ) { maus_show( m_down );  Feld_bewegen(); }
     if ( m_y <  11 ) { maus_show( m_up );    Feld_bewegen(); }
     if ((m_y <= 183)&&(m_y >=11)&&(m_x <=300)&&(m_x >=5)) maus_show(1);
     //----------------------------------------------------------------------

     if ( m_taste == 1 )        	    // linke Maustaste wurde gedrckt
     {
	m_taste = 0;			             // gleich wieder lschen
	if ( ((m_x>5)&&(m_x<245))&&((m_y>11)&&(m_y<191)) )     // Spielflche
	{
	  for (i=0; i<MannAnzahl+1; i++)            // alle Mnner durchgehen
	  {                                        // wurde einer angeklickt?
	    if ( ((m_x<MannListe[i].x+21)&&(m_x>MannListe[i].x-1))&&((m_y<MannListe[i].y+21)&&(m_y>MannListe[i].y-1)) )
	    {
	      for (j=0; j<200; j++ ) AktListe[j] = 0;  // Aktiv-Liste lschen
	      AktListe[i] = 1;                 // ja? In Aktiv-Liste einfgen
	    }
	    else
	    {
	      if ( AktListe[i] )                       // ist Mann aktiviert?
	      {
		MannListe[i].dx = (f_x*20)+m_x-10;
		MannListe[i].dy = (f_y*20)+m_y-10;
	      } // if
	    } // else
	  } // for
	} // if
     } // if
     if ( m_taste == 2 )                   // rechte Maustaste wurde gedrckt
     {
       for (i=0; i<200; i++ ) AktListe[i] = 0;         // Aktiv-Liste lschen
       setpix(m_x, m_y, 254);
     }

     for (j=0; j<MannAnzahl+1; j++ ) Mann_compute(j);   // Bewegung errechnen
     WaitRetrace();                              // auf Kathodenstrahl warten
     for (i=0; i<MannAnzahl+1; i++ )
     if ( (MannListe[i].x1 != MannListe[i].x)||(MannListe[i].y1 != MannListe[i].y) )
     {
       if ( ((MannListe[i].x>5)&&(MannListe[i].x<245))&&((MannListe[i].y>11)&&(MannListe[i].y<191)) )
       {
	 Mann_back_restore(i);		    // und jetzt wird der Mann bewegt
	 Mann_back_save(i); Mann_set(i);
	 MannListe[i].x1 = MannListe[i].x; MannListe[i].y1 = MannListe[i].y;
       } // if
     } // for
   } // Programmende (while)

   chdir("..");
   XMSUnlock(handle); XMSFreeMem(handle);
   XMSUnlock(backh);  XMSFreeMem(backh);     // XMS-Speicher wieder freigeben
   XMSUnlock(shapeh); XMSFreeMem(shapeh);
   textmodus();					   // zurck in den Textmodus
   printf("Du hast diese Zeit verloren!\n");// und sinnvolle Meldung ausgeben
}


/****************************************************************************/
/* put_sprite bring ein Sprite von 20x20 auf den Bildschirm. Zuvor mu ihr  */
/* aber die Position des Sprites im XMS bergeben werden, sowie die X- und  */
/* Y-Koordinaten.                                                           */
/*--------------------------------------------------------------------------*/
/* Parameter:                                                               */
/*            x................................... X-Koordinate des Sprites */
/*            y................................... Y-Koordinate des Sprites */
/*            pos................................... Sprite-Position im XMS */
/****************************************************************************/
void put_sprite( int x, int y, unsigned int pos )
{
  int i= y, j= x, h= 0;
  BYTE sprt[400];

    XMSCopy( handle, (long) (void far *) pos, 0, (long) ((void far *) &sprt), 400);

    for ( i=0; i<PIXEL_Y; i++ )
    {
      for ( j=0; j<PIXEL_X; j++ ) setpix(x+j, y+i, sprt[h++]);
    }
}


/****************************************************************************/
/* Diese Funktion initialisiert den Maustreiber, und berprft ob dieser    */
/* vorhanden ist.                                                           */
/* Dem entsprechend fllt dann der Rckgabewert aus.                        */
/*--------------------------------------------------------------------------*/
/* Keine Parameter                                                               */
/****************************************************************************/
int maus_reset( void )
{
  unsigned install;

  asm { xor ax, ax
	int 33h
	mov install, ax
      }

  if ( install == 0xFFFF ) return 0;
  return 1;
}

/****************************************************************************/
/* put_sprite bring ein Sprite von 20x20 auf den Bildschirm. Zuvor mu ihr  */
/* aber die Position des Sprites im XMS bergeben werden, sowie die X- und  */
/* Y-Koordinaten.                                                           */
/*--------------------------------------------------------------------------*/
/* Parameter:                                                               */
/*            x................................... X-Koordinate des Sprites */
/*            y................................... Y-Koordinate des Sprites */
/*            pos................................... Sprite-Position im XMS */
/****************************************************************************/
void maus_pos ( void )
{
   asm { mov	ax, 03
	 int 33h
	 mov    m_taste, bx
	 mov    m_x, cx
	 mov    m_y, dx
       }

  m_x = m_x >> 1;
  if ( m_x > 310 ) m_x = 310;
  if ( m_y > 192 ) m_y = 192;
}

void maus_show ( BYTE image )
{
  if ( (x1 != m_x) || (y1 != m_y) )
  {
    m_show_image = image;
    /* Hintergrund wiederherstellen */
    m_back_restore();
    /* Hintergrund sichern */
    m_back_save();
    /* Maus auf den Bildschirm bringen */
    m_place();
    x1 = m_x; y1 = m_y;                          /* Koordinaten auffrischen */
  } /* if */
}

void m_back_restore ( void )
{
  int i, j, h= 0;

  for ( i=0; i<12; i++ )
  {
    for ( j=0; j<10; j++ )
    {
      if ( getpix(x1+j, y1+i) >= 250 ) setpix(x1+j, y1+i, m_images[m_save][h]);
      h++;
    }
  }
}

void m_back_save ( void )
{
  int i, j, h= 0;

  for ( i=0; i<12; i++ )
  {
    for ( j=0; j<10; j++ ) { m_images[m_save][h] = getpix(m_x+j, m_y+i); h++; }
  }
}

void m_place ( void )
{
  int i, j, h= 0;

  for ( i=0; i<12; i++ )
  {
    for ( j=0; j<10; j++ )
    {
      if ( m_images[m_show_image][h] != 0 ) setpix(m_x+j, m_y+i, m_images[m_show_image][h]);
      h++;
    }
  }
}


/****************************************************************************/
/* Dies Funktion stellt das Grundgrst fr diese Spiel dar. Sie berechnet   */
/* welche Teile der Landschaft (Karte) angezeigt werden soll. 	            */
/* Gesteuert wird per Maus.						    */
/*--------------------------------------------------------------------------*/
/* Parameter:                                                               */
/*            weiter_x..................... wie weit in X-Richtung scrollen */
/*            weiter_y..................... wie weit in Y_Richtung scrollen */
/****************************************************************************/
void Landschaft ( int weiter_x, int weiter_y )
{
  int i, j;


  /* Hier wird nun die Karte auf dem Bildschirm ausgegeben                  */
  for (i=weiter_y; i<weiter_y+SPIEL_LANG; i++)          /* Geht fr Y durch */
  {
    for (j=weiter_x; j<weiter_x+SPIEL_BREIT; j++)     /* und die hier fr X */
    {
      put_sprite((j-weiter_x)*20+5, (i-weiter_y)*20+11, Feld[i] [j]*400);
    }
  }
}


void Feld_bewegen ( void )
{
  int i;

  /* nach UNTEN */
  if ( (m_y > 180) && (f_y < FELD_Y) )
  {
     m_back_restore();// Landschaft(f_x, ++f_y);
     asm { push es
	   push ds
	   cld
	   mov ax, 0a000h
	   mov ds, ax
	   mov es, ax
	   mov si, 9925
	   mov di, 3525
	   xor dx, dx
	 }
     nexty:
     asm { inc dx
	   mov cx, 120
	   rep movsw
	   cmp dx, 160
	   je ende
	   add si, 80
	   add di, 80
	   jmp nexty
	 }
     ende:
     asm { pop ds
	   pop es
	 }
     f_y++;
     for (i=0; i<SPIEL_BREIT; i++)
     {
       put_sprite((i*20)+5, 171, Feld[f_y+8] [f_x+i]*400);
     }
     for (i=0; i<MannAnzahl+1; i++)
     {
       MannListe[i].y-=20; MannListe[i].y1-=20;
       if ( ((MannListe[i].x>5)&&(MannListe[i].x<245))&&((MannListe[i].y>11)&&(MannListe[i].y<191)) )
       { /*Mann_back_save(i);*/ Mann_set(i); }
     }
     m_back_save(); m_place();
     return;
  }
  /*  nach OBEN*/
  if ( (m_y < 11 ) && (f_y > 0) )
  {
     m_back_restore(); //Landschaft(f_x, --f_y);
     asm { push es
	   push ds
	   cld
	   mov ax, 0a000h
	   mov ds, ax
	   mov es, ax
	   mov si, 54405
	   mov di, 60805
	   xor dx, dx
	 }
     nexty1:
     asm { inc dx
	   mov cx, 120
	   rep movsw
	   cmp dx, 160
	   je ende1
	   sub si, 560
	   sub di, 560
	   jmp nexty1
	 }
     ende1:
     asm { pop ds
	   pop es
	   cld
	 }
     f_y--;
     for (i=0; i<SPIEL_BREIT; i++)
     {
       put_sprite((i*20)+5, 11, Feld[f_y] [f_x+i]*400);
     }
     for (i=0; i<MannAnzahl+1; i++)
     {
       MannListe[i].y+=20; MannListe[i].y1+=20;
       if ( ((MannListe[i].x>5)&&(MannListe[i].x<245))&&((MannListe[i].y>11)&&(MannListe[i].y<191)) )
       { /*Mann_back_save(i);*/ Mann_set(i); }
     }
     m_back_save(); m_place();
     return;
  }
  /*nach RECHTS*/
  if ( (m_x > 300) && (f_x < FELD_X) )
  {
     m_back_restore(); //Landschaft(++f_x, f_y);
     asm { push es
	   push ds
	   cld
	   mov ax, 0a000h
	   mov ds, ax
	   mov es, ax
	   mov si, 3545
	   mov di, 3525
	   xor dx, dx
	 }
     nexty2:
     asm { inc dx
	   mov cx, 110
	   rep movsw
	   cmp dx, 180
	   je ende2
	   add si, 100
	   add di, 100
	   jmp nexty2
	 }
     ende2:
     asm { pop ds
	   pop es
	 }
     f_x++;
     for (i=0; i<SPIEL_LANG; i++)
     {
       put_sprite(225, (i*20)+11, Feld[f_y+i] [f_x+11]*400);
     }
     for (i=0; i<MannAnzahl+1; i++)
     {
       MannListe[i].x-=20; MannListe[i].x1-=20;
       if ( ((MannListe[i].x>5)&&(MannListe[i].x<245))&&((MannListe[i].y>11)&&(MannListe[i].y<191)) )
       { /*Mann_back_save(i);*/ Mann_set(i); }
     }
     m_back_save(); m_place();
     return;
  }
  /* nach LINKS*/
  if ( (m_x <  5 ) && (f_x > 0) )
  {
     m_back_restore(); //Landschaft(--f_x, f_y);
     asm { push es
	   push ds
	   std
	   mov ax, 0a000h
	   mov ds, ax
	   mov es, ax
	   mov si, 3743  // SI = Ziel
	   mov di, 3763  // DI = Quelle
	   xor dx, dx
	 }
     nexty3:
     asm { inc dx
	   mov cx, 110
	   rep movsw
	   cmp dx, 180
	   je ende3
	   add si, 540
	   add di, 540
	   jmp nexty3
	 }
     ende3:
     asm { pop ds
	   pop es
	   cld
	 }
     f_x--;
     for (i=0; i<SPIEL_LANG; i++)
     {
       put_sprite(5, (i*20)+11, Feld[f_y+i] [f_x]*400);
     }
     for (i=0; i<MannAnzahl+1; i++)
     {
       MannListe[i].x+=20; MannListe[i].x1+=20;
       if ( ((MannListe[i].x>5)&&(MannListe[i].x<245))&&((MannListe[i].y>11)&&(MannListe[i].y<191)) )
       { /*Mann_back_save(i);*/ Mann_set(i); }
     }
     m_back_save(); m_place();
     return;
  }
}


void init_Spiel()
{
  int i, Zeichen;
  FILE *Datei;
  BYTE data[30000];

  printf("(c)Synaps 1995, 1996. Alle Rechte vorbehalten. \n");
  printf("wild Synaps ist eine Digital Events(tm) Gesellschaft. 1994, 1996\n");
  if ( maus_reset() )         // berprfen ob ein Maustreiber installiert ist
  {
   printf("\nERROR: Es wurde kein Maustreiber gefunden!\n\n");
   exit(0);
  }
  if ( !XMSInit() )                                          // XMS uberprufen
  {
    printf("\nERROR: Es wurden kein Speichermanager fr XMS gefunden.");
    printf("\n       Bitte berprfen Sie, ob HIMEM.SYS o.. geladen ist!\n");
    exit(0);
  }
  XMSQueryFree(&XMS_frei, &EMB_frei);
  if (XMS_frei < 2000) { printf("\nERROR: Dieses Spiel bentigt 2MB XMS-Speicher!\n"); exit(0); }
  handle = XMSGetMem(1000);        // 1MB XMS fr Landschaft & Co. allocieren
  backh  = XMSGetMem(500);            // 500kb fr die Hintergrnde der Leute
  shapeh = XMSGetMem(500);         // und nochmal 500kb fur die Leute an sich
  delay(1400);

  if ( chdir("DATA") )
  {
    printf("\nERROR: Kann Verzeichnis DATA nicht finden!\n\n");
    exit(0);
  }                                          // ins DATA-Verzeichnis wechseln
  Datei = fopen("landscp1.dat", "rb");                    // Landschaft laden
  i= 0;
  while ((Zeichen = fgetc(Datei)) != EOF) data[i++] = (BYTE)Zeichen;
  fclose(Datei);
  XMSCopy( 0, (long) ((void far *) data), handle, NULL, sizeof(data) );

  Datei = fopen("mann.dat", "rb");                             // Leute laden
  i= 0;
  while ((Zeichen = fgetc(Datei)) != EOF) data[i++] = (BYTE)Zeichen;
  fclose(Datei);
  XMSCopy( 0, (long) ((void far *) data), shapeh, NULL, sizeof(data) );

  asm { mov al, 13h; int 10h }                        // Mode 13h einschalten
  delay(200);
  maus_off(); maus_put(160, 100); x1= 160; y1= 100;            // Maus setzen
  MannAnzahl = -1;
}


void setpix ( int x, int y, BYTE farbe )
{
  asm { mov ax, y
	mov bx, 320
	mul bx
	add ax, x
	mov di, ax
	mov ax, 0a000h
	mov es, ax
	mov al, byte ptr farbe
	stosb
      }
}

BYTE getpix ( int x, int y )
{
  BYTE punkt;

  asm { mov ax, y
	mov bx, 320
	mul bx
	add ax, x
	mov bx, ax
	mov ax, 0a000h
	mov es, ax
	mov cl, es:[bx]
	mov punkt, cl
      }

  return punkt;
}

/*==========================================================================*/
/*==========================================================================*/
int MannInsert ( int ax, int ay, BYTE shape )
{
  //if ( (MannAnzahl+1) >= MannMax ) return 0;

  MannAnzahl++;
  MannListe[MannAnzahl].del   = 0;
  MannListe[MannAnzahl].x     = ax-(f_x*20);
  MannListe[MannAnzahl].y     = ay-(f_y*20);
  MannListe[MannAnzahl].x1    = ax-(f_x*20);
  MannListe[MannAnzahl].y1    = ay-(f_y*20);
  MannListe[MannAnzahl].ax    = ax;
  MannListe[MannAnzahl].ay    = ay;
  MannListe[MannAnzahl].dx    = ax;
  MannListe[MannAnzahl].dy    = ay;
  MannListe[MannAnzahl].shape = shape;
  MannListe[MannAnzahl].back  = MannAnzahl*400;
  AktListe[MannAnzahl]        = 0;

  return 1;
}

void Mann_back_save ( BYTE index )
{
  BYTE mback[400];
  int i, j, h=0;

  for ( i=0; i<20; i++ )
  {
    for ( j=0; j<20; j++ ) mback[h++] = getpix( MannListe[index].x+j, MannListe[index].y+i);
  }

  XMSCopy( 0, (long) ((void far *) &mback), backh, (long) (void far *) index*400, sizeof(mback) );
}

void Mann_back_restore ( BYTE index )
{
  BYTE mback[400];
  int i, j, h=0;

  XMSCopy( backh, (long) (void far *) index*400, 0, (long) ((void far *) &mback), sizeof(mback) );

  for ( i=0; i<20; i++ )
  {
    for ( j=0; j<20; j++ ) setpix(MannListe[index].x1+j, MannListe[index].y1+i, mback[h++]);
  }
}

void Mann_set ( BYTE index )
{
  BYTE mback[400], mshape[400];
  int i, j, h=0;

					   // das Sprite aus dem XMS kopieren
  XMSCopy( shapeh, (long) (void far *) MannListe[index].shape*400, 0, (long) ((void far *) &mshape), sizeof(mshape) );

  for ( i=0; i<20; i++ )
  {
    for ( j=0; j<20; j++ )
    {
      mback[h] = getpix( MannListe[index].x+j, MannListe[index].y+i);
      if ( (mshape[h]>5)&&(mback[h]<5) ) setpix( MannListe[index].x+j, MannListe[index].y+i, mshape[h]); h++;
    }
  }
}

void Mann_compute ( BYTE index )
{
  if ( MannListe[index].del >= 12 )
  {
    MannListe[index].del = 0;
    if ( MannListe[index].ax < MannListe[index].dx )
       { MannListe[index].ax+=2; MannListe[index].x+=2; }
    if ( MannListe[index].ax > MannListe[index].dx )
       { MannListe[index].ax-=2; MannListe[index].x-=2; }
    if ( MannListe[index].ay < MannListe[index].dy )
       { MannListe[index].ay+=2; MannListe[index].y+=2; }
    if ( MannListe[index].ay > MannListe[index].dy )
       { MannListe[index].ay-=2; MannListe[index].y-=2; }
  }
  MannListe[index].del++; MannListe[index].shape++;
  if ( MannListe[index].shape >= 3 ) MannListe[index].shape = 0;
}

void Mann_move ( BYTE index )
{
    Mann_back_restore(index);
    Mann_back_save(index); Mann_set(index);
}

/*==========================================================================*/
/* Das ENDE dieses schnen Programms                                        */
/*==========================================================================*/
