#include <dos.h>
#include <stdarg.h>
#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <maus.h>
#include <defkon.h>


#define m_save  0
#define m_image 1
#define m_up    3
#define m_down  4
#define m_left  2
#define m_right 5
#define m_franz 6
#define MannMax 100
#define STRG 36
#define MannListe ML

/*------------------------------- Variablen --------------------------------*/
long XMS_Adr; int XMS_frei, EMB_frei, handle, backh, shapeh;
BYTE XMSErr, MannAnzahl=-1, AktAnzahl= 2, maus=1, links, rechts, oben, unten;
int m_x= 160, m_y= 100, m_taste, m_visi= 1, x1, y1, m_show_image=1, i, error, f_y= 0, f_x= 0;
MANN MannListe[200];
BYTE AktListe[200];
/*------------------------------ Konstanten --------------------------------*/
     int PIXEL_ANZAHL = 400;
     int PIXEL_X      = 20;
     int PIXEL_Y      = 20;
     int SPIEL_BREIT  = 12;
     int SPIEL_LANG   = 9;
     int FELD_X	      = 18;
     int FELD_Y       = 30;
     int FELD_ANZAHL  = 18*15;
/*------------------Hier stehen die internen Funktionen---------------------*/
void put_sprite( int x, int y, unsigned int pos );
int  maus_reset( void );
void maus_pos ( void );
void maus_show ( void );
void m_back_restore ( void );
void m_back_save ( void );
void m_place ( void );
void Landschaft ( int a, int b );
void Feld_bewegen ( void );
void init_Spiel();
void setpix ( int x, int y, BYTE farbe );
BYTE getpix ( int x, int y );
int  MannInsert ( int ax, int ay, BYTE shape );
void Mann_back_save ( BYTE index );
void Mann_back_restore ( BYTE index );
void Mann_set ( BYTE index );
void Mann_akt_set ( BYTE index );
void Mann_set_clip_down ( BYTE index );
void Mann_akt_set_clip_down ( BYTE index );
void Mann_restore_clip_down ( BYTE index );
void Mann_set_clip_up ( BYTE index );
void Mann_akt_set_clip_up ( BYTE index );
void Mann_restore_clip_up ( BYTE index );
void Mann_compute ( BYTE index );
void Maus_links ( void );
void Maus_rechts ( void );
void quit ( void );
/*==========================================================================*/
void main( void )
{
   char pal[768]; int i, j, k, waitme=0;

   init_Spiel();
   delay(100);

   ClearPalette(); load_PCX("rahmen.pcx");
   Landschaft(0, 0); write(250, 97, "neuer mann"); write(270, 185, "beenden");
   m_back_save(); m_place(); maus_show();
   MannInsert(100, 50, 0); Mann_set(0);

   while ( m_taste != 7 )                 // diese Abfrage ist vllig sinnlos
   {
     m_taste = 0; maus_pos();
     //---------------------- Mauszeiger richtig setzen ---------------------
     if ( (m_x>300)&&(m_y<180) ) {  maus_show(); Feld_bewegen(); }
     if ( m_x <   5 )            { maus_show();  Feld_bewegen(); }
     if ( (m_y>180)&&(m_x<245) ) { maus_show();  Feld_bewegen(); }
     if ( m_y <  11 )            { maus_show();    Feld_bewegen(); }
     if ((m_y <= 199)&&(m_y >=11)&&(m_x <=310)&&(m_x >=5)) maus_show();
     //----------------------------------------------------------------------
     if ( m_taste == 1 ) Maus_links(); 	     //linke Maustaste wurde gedrckt
     if ( m_taste == 2 ) Maus_rechts();    // rechte Maustaste wurde gedrckt
     //---------------------------------------------------------------------

     for (j=0; j<MannAnzahl+1; j++ ) Mann_compute(j);   // Bewegung errechnen
     waitme = 0; WaitRetrace();                  // auf Kathodenstrahl warten
     for (i=0; i<MannAnzahl+1; i++ )
     if ( (MannListe[i].x1 != MannListe[i].x)||(MannListe[i].y1 != MannListe[i].y) )
     {
       if ( ((ML[i].x>5)&&(ML[i].x<245))&&((ML[i].y>11)&&(ML[i].y<191)) )
       {
	 m_back_restore();
	 if ( ML[i].y>171 )
	 {
	   Mann_restore_clip_down(i);
	   if ( AktListe[i] == 1 )  Mann_akt_set_clip_down(i);
	   else Mann_set_clip_down(i);
	 }
	 /*if ( ML[i].y<11 )
	 {
	   Mann_restore_clip_up(i);
	   if ( AktListe[i] == 1 )  Mann_akt_set_clip_up(i);
	   else Mann_set_clip_up(i);
	 } */
	 else
	 {
	   Mann_back_restore(i); 	    // und jetzt wird der Mann bewegt
	   if ( AktListe[i] == 1 ) Mann_akt_set (i);
	   else Mann_set(i);
	   waitme++;
	   if ( waitme == 5 ) { waitme= 0; WaitRetrace(); }//erneut synchronisieren
	 } // kein Clipping
	 MannListe[i].x1 = MannListe[i].x; MannListe[i].y1 = MannListe[i].y;
	 m_back_save(); m_place();           // Maus sichern und neu zeigen
       } // if; Mann sichtbar
     } // for; jedes Mnnchen durchgehen
   } // Programmende (while)

   quit();
}


/****************************************************************************/
/* put_sprite bring ein Sprite von 20x20 auf den Bildschirm. Zuvor mu ihr  */
/* aber die Position des Sprites im XMS bergeben werden, sowie die X- und  */
/* Y-Koordinaten.                                                           */
/*--------------------------------------------------------------------------*/
/* Parameter:                                                               */
/*            x................................... X-Koordinate des Sprites */
/*            y................................... Y-Koordinate des Sprites */
/*            pos................................... Sprite-Position im XMS */
/****************************************************************************/
void put_sprite( int x, int y, unsigned int pos )
{
  int i= y, j= x, h= 0;
  BYTE sprt[400];

    XMSCopy( handle, (long) (void far *) pos, 0, (long) ((void far *) &sprt), 400);

    for ( i=0; i<PIXEL_Y; i++ )
    {
      for ( j=0; j<PIXEL_X; j++ ) setpix(x+j, y+i, sprt[h++]);
    }
}


/****************************************************************************/
/* Diese Funktion initialisiert den Maustreiber, und berprft ob dieser    */
/* vorhanden ist.                                                           */
/* Dem entsprechend fllt dann der Rckgabewert aus.                        */
/*--------------------------------------------------------------------------*/
/* Keine Parameter                                                               */
/****************************************************************************/
int maus_reset( void )
{
  unsigned install;

  asm { xor ax, ax
	int 33h
	mov install, ax
      }

  if ( install == 0xFFFF ) return 0;
  return 1;
}

/****************************************************************************/
/* put_sprite bring ein Sprite von 20x20 auf den Bildschirm. Zuvor mu ihr  */
/* aber die Position des Sprites im XMS bergeben werden, sowie die X- und  */
/* Y-Koordinaten.                                                           */
/*--------------------------------------------------------------------------*/
/* Parameter:                                                               */
/*            x................................... X-Koordinate des Sprites */
/*            y................................... Y-Koordinate des Sprites */
/*            pos................................... Sprite-Position im XMS */
/****************************************************************************/
void maus_pos ( void )
{
   asm { mov	ax, 03
	 int 33h
	 mov    m_taste, bx
	 mov    m_x, cx
	 mov    m_y, dx
       }

  m_x = m_x >> 1;
  if ( m_x > 310 ) m_x = 310;
  if ( m_y > 192 ) m_y = 192;
}

void maus_show ( void )
{
  if ( (x1 != m_x) || (y1 != m_y) )
  {
    /* Hintergrund wiederherstellen */
    m_back_restore();
    /* Hintergrund sichern */
    m_back_save();
    /* Maus auf den Bildschirm bringen */
    m_place();
    x1 = m_x; y1 = m_y;                          /* Koordinaten auffrischen */
  } /* if */
}

void m_back_restore ( void )
{
  int i, j, h= 0;

  for ( i=0; i<16; i++ )
  {
    for ( j=0; j<15; j++ )
    {
      if ( getpix(x1+j, y1+i) >= 250 ) setpix(x1+j, y1+i, m_images[m_save][h]);
      h++;
    }
  }
}

void m_back_save ( void )
{
  int i, j, h= 0;

  for ( i=0; i<16; i++ )
  {
    for ( j=0; j<15; j++ ) { m_images[m_save][h] = getpix(m_x+j, m_y+i); h++; }
  }
}

void m_place ( void )
{
  int i, j, h= 0;

  for ( i=0; i<16; i++ )
  {
    for ( j=0; j<15; j++ )
    {
      if ( m_images[m_show_image][h] != 0 ) setpix(m_x+j, m_y+i, m_images[m_show_image][h]);
      h++;
    }
  }
}


/****************************************************************************/
/* Dies Funktion stellt das Grundgrst fr diese Spiel dar. Sie berechnet   */
/* welche Teile der Landschaft (Karte) angezeigt werden soll. 	            */
/* Gesteuert wird per Maus.						    */
/*--------------------------------------------------------------------------*/
/* Parameter:                                                               */
/*            weiter_x..................... wie weit in X-Richtung scrollen */
/*            weiter_y..................... wie weit in Y_Richtung scrollen */
/****************************************************************************/
void Landschaft ( int weiter_x, int weiter_y )
{
  int i, j;


  /* Hier wird nun die Karte auf dem Bildschirm ausgegeben                  */
  for (i=weiter_y; i<weiter_y+SPIEL_LANG; i++)          /* Geht fr Y durch */
  {
    for (j=weiter_x; j<weiter_x+SPIEL_BREIT; j++)     /* und die hier fr X */
    {
      put_sprite((j-weiter_x)*20+5, (i-weiter_y)*20+11, Feld[i] [j]*400);
    }
  }
}


void Feld_bewegen ( void )
{
  int i;

  /* nach UNTEN */
  if ( (m_y > 180) && (f_y < FELD_Y) )
  {
     m_back_restore();// Landschaft(f_x, ++f_y);
     asm { push es
	   push ds
	   cld
	   mov ax, 0a000h
	   mov ds, ax
	   mov es, ax
	   mov si, 9925
	   mov di, 3525
	   xor dx, dx
	 }
     nexty:
     asm { inc dx
	   mov cx, 120
	   rep movsw
	   cmp dx, 160
	   je ende
	   add si, 80
	   add di, 80
	   jmp nexty
	 }
     ende:
     asm { pop ds
	   pop es
	 }
     f_y++;
     for (i=0; i<SPIEL_BREIT; i++)
     {
       put_sprite((i*20)+5, 171, Feld[f_y+8] [f_x+i]*400);
     }
     for (i=0; i<MannAnzahl+1; i++)
     {
       MannListe[i].y-=20; MannListe[i].y1-=20;
       if ( ((MannListe[i].x>5)&&(MannListe[i].x<245))&&((MannListe[i].y>170)&&(MannListe[i].y<191)) )
       {
	 Mann_restore_clip_down(i);
	 if ( AktListe[i] == 1 ) Mann_akt_set_clip_down(i);
	 else Mann_set_clip_down(i);
       }
     }
     m_show_image=m_down; m_back_save(); m_place(); m_show_image=1;
     return;
  }
  /*  nach OBEN*/
  if ( (m_y < 11 ) && (f_y > 0) )
  {
     m_back_restore(); //Landschaft(f_x, --f_y);
     asm { push es
	   push ds
	   cld
	   mov ax, 0a000h
	   mov ds, ax
	   mov es, ax
	   mov si, 54405
	   mov di, 60805
	   xor dx, dx
	 }
     nexty1:
     asm { inc dx
	   mov cx, 120
	   rep movsw
	   cmp dx, 160
	   je ende1
	   sub si, 560
	   sub di, 560
	   jmp nexty1
	 }
     ende1:
     asm { pop ds
	   pop es
	   cld
	 }
     f_y--;
     for (i=0; i<SPIEL_BREIT; i++)
     {
       put_sprite((i*20)+5, 11, Feld[f_y] [f_x+i]*400);
     }
     for (i=0; i<MannAnzahl+1; i++)
     {
       MannListe[i].y+=20; MannListe[i].y1+=20;
       if ( ((MannListe[i].x>5)&&(MannListe[i].x<245))&&((MannListe[i].y>11)&&(MannListe[i].y<31)) )
       {
	 Mann_restore_clip_down(i);
	 if ( AktListe[i] == 1 ) Mann_akt_set_clip_down(i);
	 else Mann_set_clip_down(i);
       }
     }
     m_show_image=m_up; m_back_save(); m_place(); m_show_image=1;
     return;
  }
  /*nach RECHTS*/
  if ( (m_x > 300) && (f_x < FELD_X) )
  {
     m_back_restore(); //Landschaft(++f_x, f_y);
     asm { push es
	   push ds
	   cld
	   mov ax, 0a000h
	   mov ds, ax
	   mov es, ax
	   mov si, 3545
	   mov di, 3525
	   xor dx, dx
	 }
     nexty2:
     asm { inc dx
	   mov cx, 110
	   rep movsw
	   cmp dx, 180
	   je ende2
	   add si, 100
	   add di, 100
	   jmp nexty2
	 }
     ende2:
     asm { pop ds
	   pop es
	 }
     f_x++;
     for (i=0; i<SPIEL_LANG; i++)
     {
       put_sprite(225, (i*20)+11, Feld[f_y+i] [f_x+11]*400);
     }
     for (i=0; i<MannAnzahl+1; i++)
     {
       MannListe[i].x-=20; MannListe[i].x1-=20;
       if ( ((MannListe[i].x>224)&&(MannListe[i].x<245))&&((MannListe[i].y>11)&&(MannListe[i].y<191)) )
       {
	 Mann_back_restore(i);
	 if ( AktListe[i] == 1 ) Mann_akt_set(i);
	 else Mann_set(i);
       }
     }
     m_show_image=m_right; m_back_save(); m_place(); m_show_image=1;
     return;
  }
  /* nach LINKS*/
  if ( (m_x <  5 ) && (f_x > 0) )
  {
     m_back_restore(); //Landschaft(--f_x, f_y);
     asm { push es
	   push ds
	   std
	   mov ax, 0a000h
	   mov ds, ax
	   mov es, ax
	   mov si, 3743  // SI = Ziel
	   mov di, 3763  // DI = Quelle
	   xor dx, dx
	 }
     nexty3:
     asm { inc dx
	   mov cx, 110
	   rep movsw
	   cmp dx, 180
	   je ende3
	   add si, 540
	   add di, 540
	   jmp nexty3
	 }
     ende3:
     asm { pop ds
	   pop es
	   cld
	 }
     f_x--;
     for (i=0; i<SPIEL_LANG; i++)
     {
       put_sprite(5, (i*20)+11, Feld[f_y+i] [f_x]*400);
     }
     for (i=0; i<MannAnzahl+1; i++)
     {
       MannListe[i].x+=20; MannListe[i].x1+=20;
       if ( ((MannListe[i].x>5)&&(MannListe[i].x<26))&&((MannListe[i].y>11)&&(MannListe[i].y<191)) )
       {
	 Mann_back_restore(i);
	 if ( AktListe[i] == 1 ) Mann_akt_set(i);
	 else Mann_set(i);
       }
     }
     m_show_image=m_left; m_back_save(); m_place(); m_show_image=1;
     return;
  }
}


void init_Spiel()
{
  int i, Zeichen;
  FILE *Datei;
  BYTE data[30000];

  printf("(c)Synaps 1995, 1996. Alle Rechte vorbehalten. \n");
  printf("wild Synaps ist eine Digital Events(tm) Gesellschaft. 1994, 1996\n");
  if ( maus_reset() )         // berprfen ob ein Maustreiber installiert ist
  {
   printf("\nERROR: Es wurde kein Maustreiber gefunden!\n\n");
   exit(0);
  }
  if ( !XMSInit() )                                          // XMS uberprufen
  {
    printf("\nERROR: Es wurden kein Speichermanager fr XMS gefunden.");
    printf("\n       Bitte berprfen Sie, ob HIMEM.SYS o.. geladen ist!\n");
    exit(0);
  }
  XMSQueryFree(&XMS_frei, &EMB_frei);
  if (XMS_frei < 2000) { printf("\nERROR: Dieses Spiel bentigt 2MB XMS-Speicher!\n"); exit(0); }
  handle = XMSGetMem(1000);        // 1MB XMS fr Landschaft & Co. allocieren
  backh  = XMSGetMem(500);            // 500kb fr die Hintergrnde der Leute
  shapeh = XMSGetMem(500);         // und nochmal 500kb fur die Leute an sich
  delay(1400);

  if ( chdir("DATA") )
  {
    printf("\nERROR: Kann Verzeichnis DATA nicht finden!\n\n");
    exit(0);
  }                                          // ins DATA-Verzeichnis wechseln
  Datei = fopen("landscp1.dat", "rb");                    // Landschaft laden
  i= 0;
  while ((Zeichen = fgetc(Datei)) != EOF) data[i++] = (BYTE)Zeichen;
  fclose(Datei);
  XMSCopy( 0, (long) ((void far *) data), handle, NULL, sizeof(data) );

  Datei = fopen("mann.dat", "rb");                             // Leute laden
  i= 0;
  while ((Zeichen = fgetc(Datei)) != EOF) data[i++] = (BYTE)Zeichen;
  fclose(Datei);
  XMSCopy( 0, (long) ((void far *) data), shapeh, NULL, sizeof(data) );

  asm { mov al, 13h; int 10h }                        // Mode 13h einschalten
  delay(200);
  maus_off(); maus_put(160, 100); x1= 160; y1= 100;            // Maus setzen
  MannAnzahl = -1;
}


void setpix ( int x, int y, BYTE farbe )
{
  asm { mov ax, y
	mov bx, 320
	mul bx
	add ax, x
	mov di, ax
	mov ax, 0a000h
	mov es, ax
	mov al, byte ptr farbe
	stosb
      }
}

BYTE getpix ( int x, int y )
{
  BYTE punkt;

  asm { mov ax, y
	mov bx, 320
	mul bx
	add ax, x
	mov bx, ax
	mov ax, 0a000h
	mov es, ax
	mov cl, es:[bx]
	mov punkt, cl
      }

  return punkt;
}

/*==========================================================================*/
/*==========================================================================*/
int MannInsert ( int ax, int ay, BYTE shape )
{
  //if ( (MannAnzahl+1) >= MannMax ) return 0;

  MannAnzahl++;
  MannListe[MannAnzahl].del     = 0;
  MannListe[MannAnzahl].x       = ax-(f_x*20);
  MannListe[MannAnzahl].y       = ay-(f_y*20);
  MannListe[MannAnzahl].x1      = ax-(f_x*20);
  MannListe[MannAnzahl].y1      = ay-(f_y*20);
  MannListe[MannAnzahl].ax      = ax;
  MannListe[MannAnzahl].ay      = ay;
  MannListe[MannAnzahl].dx      = ax;
  MannListe[MannAnzahl].dy      = ay;
  MannListe[MannAnzahl].shape   = shape;
  MannListe[MannAnzahl].energie = 10;
  MannListe[MannAnzahl].target  = 0;
  MannListe[MannAnzahl].back    = MannAnzahl*400;
  AktListe[MannAnzahl]          = 0;


  return 1;
}

void Mann_back_save ( BYTE index )
{
  BYTE mback[400];
  int i, j, h=0;

  for ( i=0; i<20; i++ )
  {
    for ( j=0; j<20; j++ ) mback[h++] = getpix( MannListe[index].x+j, MannListe[index].y+i);
  }

  XMSCopy( 0, (long) ((void far *) &mback), backh, (long) (void far *) index*400, sizeof(mback) );
}

void Mann_back_restore ( BYTE index )
{
  BYTE mback[400];
  int i, j, h=0;

  XMSCopy( backh, (long) (void far *) index*400, 0, (long) ((void far *) &mback), sizeof(mback) );

  for ( i=0; i<20; i++ )
  {
    for ( j=0; j<20; j++ ) setpix(MannListe[index].x1+j, MannListe[index].y1+i, mback[h++]);
  }

}

void Mann_set ( BYTE index )
{
  BYTE mback[400], mshape[400];
  int i, j, h=0;
					   // das Sprite aus dem XMS kopieren
  XMSCopy( shapeh, (long) (void far *) MannListe[index].shape*400, 0, (long) ((void far *) &mshape), sizeof(mshape) );

  for ( i=0; i<20; i++ )
  {
    for ( j=0; j<20; j++ )
    {
      mback[h] = getpix( MannListe[index].x+j, MannListe[index].y+i);
      if ( ((mshape[h]>5)&&(mback[h]<35)) ) setpix( MannListe[index].x+j, MannListe[index].y+i, mshape[h]); h++;
    }
  }

  XMSCopy( 0, (long) ((void far *) &mback), backh, (long) (void far *) index*400, sizeof(mback) );
}

void Mann_akt_set ( BYTE index )
{
  BYTE mback[400], mshape[400];
  int i, j, h=0;
					   // das Sprite aus dem XMS kopieren
  XMSCopy( shapeh, (long) (void far *) MannListe[index].shape*400, 0, (long) ((void far *) &mshape), sizeof(mshape) );

  for ( i=0; i<20; i++ )
  {
    for ( j=0; j<20; j++ )
    {
      mback[h] = getpix( MannListe[index].x+j, MannListe[index].y+i);
      if ( (mback[h]<35) &&(((j==0)||(j==19))||((i==0)||(i==19))) ) { setpix( ML[index].x+j, ML[index].y+i, 254); h++; goto next; }
      if ( ((mshape[h]>5)&&(mback[h]<35)) ) setpix( MannListe[index].x+j, MannListe[index].y+i, mshape[h]); h++;
next:
    }
  }

  XMSCopy( 0, (long) ((void far *) &mback), backh, (long) (void far *) index*400, sizeof(mback) );
}


void Mann_set_clip_down ( BYTE index )
{
  BYTE mback[400], mshape[400];
  int i, j, y=191-ML[index].y, h=0;
  if ( y > 20 ) y = 20;
					   // das Sprite aus dem XMS kopieren
  XMSCopy( shapeh, (long) (void far *) MannListe[index].shape*400, 0, (long) ((void far *) &mshape), sizeof(mshape) );

  for ( i=0; i<y; i++ )
  {
    for ( j=0; j<20; j++ )
    {
      mback[h] = getpix( MannListe[index].x+j, MannListe[index].y+i);
      if ( ((mshape[h]>5)&&(mback[h]<35)) ) setpix( MannListe[index].x+j, MannListe[index].y+i, mshape[h]); h++;
    }
  }
  XMSCopy( 0, (long) ((void far *) &mback), backh, (long) (void far *) index*400, sizeof(mback) );
}
void Mann_akt_set_clip_down ( BYTE index )
{
  BYTE mback[400], mshape[400];
  int i, j, y=191-ML[index].y, h=0;
  if ( y > 20 ) y = 20;
					   // das Sprite aus dem XMS kopieren
  XMSCopy( shapeh, (long) (void far *) MannListe[index].shape*400, 0, (long) ((void far *) &mshape), sizeof(mshape) );

  for ( i=0; i<y; i++ )
  {
    for ( j=0; j<20; j++ )
    {
      mback[h] = getpix( MannListe[index].x+j, MannListe[index].y+i);
      if ( (mback[h]<35) &&(((j==0)||(j==19))||((i==0)||(i==19))) ) { setpix( ML[index].x+j, ML[index].y+i, 254); h++; goto next; }
      if ( ((mshape[h]>5)&&(mback[h]<35)) ) setpix( MannListe[index].x+j, MannListe[index].y+i, mshape[h]); h++;
next:
    }
  }

  XMSCopy( 0, (long) ((void far *) &mback), backh, (long) (void far *) index*400, sizeof(mback) );
}
void Mann_restore_clip_down ( BYTE index )
{
  BYTE mback[400];
  int i, j, y=192-ML[index].y, h=0;
  if ( y > 20 ) y = 20;

  XMSCopy( backh, (long) (void far *) index*400, 0, (long) ((void far *) &mback), sizeof(mback) );

  for ( i=0; i<y; i++ )
  {
    for ( j=0; j<20; j++ ) setpix(MannListe[index].x1+j, MannListe[index].y1+i, mback[h++]);
  }

}

void Mann_set_clip_up ( BYTE index )
{
  BYTE mback[400], mshape[400];
  int i, j, y=20-(ML[index].y+9), h=0;
					   // das Sprite aus dem XMS kopieren
  XMSCopy( shapeh, (long) (void far *) MannListe[index].shape*400, 0, (long) ((void far *) &mshape), sizeof(mshape) );

  for ( i=0; i<20; i++ )
  {
    for ( j=y; j<20; j++ )
    {
      mback[h] = getpix( MannListe[index].x+j, MannListe[index].y+i);
      if ( ((mshape[h]>5)&&(mback[h]<35)) ) setpix( MannListe[index].x+j, MannListe[index].y+i, mshape[h]); h++;
    }
  }
  XMSCopy( 0, (long) ((void far *) &mback), backh, (long) (void far *) index*400, sizeof(mback) );
}
void Mann_akt_set_clip_up ( BYTE index )
{
  BYTE mback[400], mshape[400];
  int i, j, y=20-(ML[index].y+9), h=0;
					   // das Sprite aus dem XMS kopieren
  XMSCopy( shapeh, (long) (void far *) MannListe[index].shape*400, 0, (long) ((void far *) &mshape), sizeof(mshape) );

  for ( i=0; i<y; i++ )
  {
    for ( j=0; j<20; j++ )
    {
      mback[h] = getpix( MannListe[index].x+j, MannListe[index].y+i);
      if ( (mback[h]<35) &&(((j==0)||(j==19))||((i==0)||(i==19))) ) { setpix( ML[index].x+j, ML[index].y+i, 254); h++; goto next; }
      if ( ((mshape[h]>5)&&(mback[h]<35)) ) setpix( MannListe[index].x+j, MannListe[index].y+i, mshape[h]); h++;
next:
    }
  }

  XMSCopy( 0, (long) ((void far *) &mback), backh, (long) (void far *) index*400, sizeof(mback) );
}
void Mann_restore_clip_up ( BYTE index )
{
  BYTE mback[400];
  int i, j, y=20-(ML[index].y+9), h=0;

  XMSCopy( backh, (long) (void far *) index*400, 0, (long) ((void far *) &mback), sizeof(mback) );

  for ( i=0; i<y; i++ )
  {
    for ( j=0; j<20; j++ ) setpix(MannListe[index].x1+j, MannListe[index].y1+i, mback[h++]);
  }

}



void Mann_compute ( BYTE index )
{
  int i;

  if ( MannListe[index].del >= 15-MannListe[index].energie )    // Ist der Mann berhaupt an der Reihe
  {
    MannListe[index].del = 0;
//------------------------------ Nach RECHTS --------------------------------
    if ( MannListe[index].ax < MannListe[index].dx )
    {
      MannListe[index].ax+=1; MannListe[index].x+=1;
      if ( MannListe[index].shape < 4 ) MannListe[index].shape = 4;
      if ( MannListe[index].shape > 6 ) MannListe[index].shape = 4;
      MannListe[index].shape++;
    }
//------------------------------ Nach LINKS ---------------------------------
    if ( MannListe[index].ax > MannListe[index].dx )
    {
      MannListe[index].ax-=1; MannListe[index].x-=1;
      if ( MannListe[index].shape > 2 ) MannListe[index].shape = 0;
      MannListe[index].shape++;
    }
//------------------------------ Nach UNTEN ---------------------------------
    if ( MannListe[index].ay < MannListe[index].dy )
    {
      MannListe[index].ay+=1; MannListe[index].y+=1;
      if ( MannListe[index].shape <  8 ) MannListe[index].shape = 8;
      if ( MannListe[index].shape > 12 ) MannListe[index].shape = 8;
      MannListe[index].shape++;
    }
//------------------------------ Nach OBEN ----------------------------------
    if ( MannListe[index].ay > MannListe[index].dy )
    {
      MannListe[index].ay-=1; MannListe[index].y-=1;
    }

  }
  MannListe[index].del++;
}

void Mann_move ( BYTE index )
{
    Mann_back_restore(index);
    Mann_back_save(index); Mann_set(index);
}


void Maus_links ( void )
{
  int i, j, k;
  BYTE keyb_flag;

	asm { mov ah, 02; int 16h; mov keyb_flag, al; }
	m_taste = 0;			              //gleich wieder lschen
	if ( ((m_x>5)&&(m_x<245))&&((m_y>11)&&(m_y<191)) )      //Spielflche
	{
	  for (i=0; i<MannAnzahl+1; i++)             //alle Mnner durchgehen
	  {                                         //wurde einer angeklickt?
	    if ( ((m_x<MannListe[i].x+17)&&(m_x>MannListe[i].x+2))&&((m_y<MannListe[i].y+17)&&(m_y>MannListe[i].y+2)) )
	    {
	      if ( keyb_flag != STRG )          //nur lschen wenn nicht STRG
	      {
		for (k=0; k<200; k++ )               //Alle Mnner durchgehen
		{
		  if ( AktListe[k] == 1 ) { Mann_back_restore(k); Mann_set(k); AktListe[k] = 0; }
		}                           //Aktiv-Liste, und Rahmen lschen
	      } // if; wurde STRG gedrckt
	      AktListe[i] = 1;          //angeklickt? In Aktiv-Liste einfgen
	      m_back_restore();
	      Mann_back_restore(i); Mann_akt_set(i);
	      m_show_image=6; m_back_save(); m_place();

	      return; //Abfrage auf rechte M.t. nicht ntig
	    }
	  } // for; suchen ob ein Mann angeklickt worden ist
	  for (i=0; i<MannAnzahl+1; i++)             //alle Mnner durchgehen
	  {
	    if ( AktListe[i] )                       // ist Mann aktiviert?
	    {
	      MannListe[i].dx = (f_x*20)+m_x-2;
	      MannListe[i].dy = (f_y*20)+m_y;
	    } // if
	  } // for; wurde einem Mann ein Ziel bergeben
	} // if
       if ( ((m_x>250)&&(m_x<310))&&((m_y>96)&&(m_y<102)) )
       {
	 MannInsert(30, 30, 0);
	 if ( ((ML[MannAnzahl].x>5)&&(ML[MannAnzahl].x<245))&&((ML[MannAnzahl].y>11)&&(ML[MannAnzahl].y<191)) ) Mann_set(MannAnzahl);
       }
       if ( ((m_x>270)&&(m_x<310))&&((m_y>185)&&(m_y<190)) ) quit();

}

void Maus_rechts ( void )
{
  int j;

  m_back_restore();
  for (j=0; j<200; j++ )
  {
    if ( AktListe[j] == 1 ) { Mann_back_restore(j); Mann_set(j); AktListe[j] = 0; }
  }                                        // Aktiv-Liste, und Rahmen lschen
  m_show_image=1; m_back_save(); m_place();
  setpix(m_x, m_y, 254);
}



void quit ( void )
{
   chdir("..");
   XMSUnlock(handle); XMSFreeMem(handle);
   XMSUnlock(backh);  XMSFreeMem(backh);     // XMS-Speicher wieder freigeben
   XMSUnlock(shapeh); XMSFreeMem(shapeh);
   textmodus();					   // zurck in den Textmodus
   printf("Du hast diese Zeit verloren!\n");// und sinnvolle Meldung ausgeben
   exit(0);					                // und tsch
}

/*==========================================================================*/
/* Das ENDE dieses schnen Programms                                        */
/*==========================================================================*/
