//**************************************************************************//
// Das hier wird die DEFKON17 Konvertierung auf WATCOM C                    //
// -----------------------------------------------------                    //
// von Stephan Meiner                                                      //
// ab 25. Mrz 1996                                                         //
//**************************************************************************//
#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <graph.h>
#include <dos.h>
#include <i86.h>
#include <string.h>
#include <gfklib.h>
#include <pcxlib.h>
#include <maus.h>
#include <font.h>
#include <defkon.h>

#define MLi      ML[index]
#define FLi      FL[index]

void main ( int argc, char *argv[] )
{
  char p[768], i;

  Init_Program();
//  put_pcx("defkon.dbl"); LoadPalette("defkon.dbl", p); ClearPalette(); Set_Overscan_Color(255);
//  cpy2screen(); fade_in(p); (void) getch(); fade_out();

  if ( (argc < 2) ) { Init_Spiel(); Spiel(); quit(); }
  else Menu();
}


void Spiel ( void )
{
  int i, j;
  char c;

  while ( m_taste != 7 )                                  // sinnlose Abfrage
  {
    m_show_image= 1;                         // Mauszeiger auf Default setzen
    if ( go == 1  ) m_show_image= 6;  // Bewegungszeiger, wenn Mann aktiv ist
    if ( atack==1 ) { m_show_image= 8; atack= 0; }           // Angrifszeiger
    maus_pos(); maus_show();              // Mauspos. berechnen, und anzeigen
    m_back_restore();

    if ( m_taste == 1 )
    {
      if ( maus_links() ) { quit(); }                             // beenden 
      if ( !maus_links() ) goto compute;   // im Men wurde 'Weiter' gewhlt
    }
    if ( m_taste == 2 ) maus_rechts();

    if ( kbhit() )
    {
      c = getch();
      if ( c == 0 )
      {
        c = getch();
        if ( c == 63 )
        {
           if ( radar_akt ) { radar_akt=0; Landschaft(f_x, f_y); }
           else { radar_akt=1; draw_box(Radar_x, Radar_y, Radar_x1-1, Radar_y1+1, 247); }
        }
        if ( c == 64 ) { if ( view_akt ) view_akt=0; else { view_akt=1; view_x=(f_x+(m_x/20)); view_y=(f_y+(m_y/20)); } }
      }
      else
      {
        if ( c == 27 ) { m_back_restore(); if ( spiel_menu() ) return; screen_refresh= 1; }
        if ( c == 45 ) { mann_del+=4; }                                // -
        if ( c == 43 ) { if ( mann_del > 4 ) mann_del-=4; }            // +
        if ( c == 47 ) { scroll_del+=1; }                              // /
        if ( c == 42 ) { if ( scroll_del > 0 ) scroll_del-=1; }        // *
        if ( c ==  8 ) { scroll_del = ss_del; mann_del = sm_del; }     // bs
        if ( c ==115 ) { save_game("Mein erstes Defkon17 Savegame\0"); delay(1000); } // s
        if ( c ==108 ) { load_game(); screen_refresh=1; Landschaft(f_x, f_y); goto compute; }// l
        if ( c ==109 ) { if ( MannAnzahl > -1 ) { MF[ML[0].feldy][ML[0].feldx]=0; mann_back_restore(0); MannDelete(0); } }
        if ( c ==102 ) { if ( FeindAnzahl > -1 ) { MF[FL[0].feldy][FL[0].feldx]=0;feind_back_restore(0); FeindDelete(0); } }
        if ( c == 13 ) { MannInsert((f_x*20)+m_x, (f_y*20)+m_y, 26); mann_set(MannAnzahl); }
        if ( c == 32 ) { FeindInsert((f_x*20)+m_x, (f_y*20)+m_y, 0); feind_set(FeindAnzahl); }
        if ( c ==114 )
        {
           if ( ((m_x+50)<320)&&((m_y+51)<200) ) { Radar_x = m_x; Radar_y = m_y; Radar_x1 = Radar_x+50; Radar_y1 = Radar_y+50; Landschaft(f_x, f_y); }
        }
        if ( c ==118 )
        {
           if ( ((m_x+80)<320)&&((m_y+61)<200) ) { vx = m_x; vy = m_y; Landschaft(f_x, f_y); }
        }

      } // c == 0;
    }
    memset(MoveListe, 0, 400); 
    //------------------------------------------------------------------------------------
    if ( (m_y>190)&&(f_y<FELD_Y) )  { if (sdel>=scroll_del) scroll_down(); else sdel++;  }
    if ( (m_y< 10)&&(f_y>0) )       { if (sdel>=scroll_del) scroll_up(); else sdel++;    }
    if ( (m_x>310)&&(f_x<FELD_X) )  { if (sdel>=scroll_del) scroll_right(); else sdel++; }
    if ( (m_x< 10)&&(f_x>0) )       { if (sdel>=scroll_del) scroll_left(); else sdel++;  }
    //------------------------------------------------------------------------------------
    if ( aktzaehler > -1 )
    {
       for ( i=0; i<aktzaehler+1; i++ )
       {
          button_up(2+(52*i), 1, 50, "");
          fill_box(2+(52*i), 3, 2+((ML[akt[i]].energie+1)*47)/11, 9, 245);
       }
    }

compute:
    if ( MannAnzahl > -1 )                      // ist berhaupt ein Mann da
    {
      for ( i=0; i<MannAnzahl+1; i++ )
      {
        Mann_compute(i);
        if ( MoveListe[i] == 1 )
        {
          Mann_back_restore(i);
          if ( AktListe[i] ) mann_akt_set(i);
          else mann_set(i);
          ML[i].x1 = ML[i].x; ML[i].y1 = ML[i].y;
          ML[i].ax1= ML[i].ax; ML[i].ay1= ML[i].ay;
        }
      }
    }

    if ( FeindAnzahl > -1 )
    {
      for ( i=0; i<FeindAnzahl+1; i++ )
      {
        Feind_compute(i);
        if ( MoveListe[200+i] == 1 )
        {
          feind_back_restore(i);
          feind_set(i);
          FL[i].x1 = FL[i].x; FL[i].y1 = FL[i].y;
          FL[i].ax1= FL[i].ax; FL[i].ay1= FL[i].ay;
        }
      }
    }
    if ( radar_akt ) radar();
    if ( view_akt ) view_place();
    m_back_save(); m_place();

    if ( screen_refresh ) { wait_retrace(); cpy2screen(); }
  }

}


void Menu ( void )
{
  char c, pal[786];

build:
  Screen_Off();
  m_back_restore();
  load_PCX("dg-03a.dbl"); Set_Overscan_Color(0);
  write(109, 103, "neues spiel beginnen", 254);
  write(129, 127, "spiel laden", 251);
  write(136, 152, "credits", 251);
  write(124, 178, "spiel beenden", 254);

  write(245, 178, "alpha", 223);

  LoadPalette("dg-03a.dbl", pal);
  ClearPalette(); cpy2screen(); Screen_On(); set_fade_in(pal, 0, 180); delay(100); set_fade_in(pal, 181, 255);
  m_back_save(); m_place();


  while ( m_taste != 7 )                                  // sinnlose Abfrage
  {
    m_show_image= 1; maus_pos(); maus_show();

    if ( m_taste == 1 ) if (menu_maus_links()) goto build;
    if ( kbhit() )
    {
      c = getch();
      if ( c == 27 ) { set_fade_out(181, 255); set_fade_out(0, 180); quit(); }
    }
    if ( screen_refresh ) { wait_retrace(); cpy2screen(); }
  }

}

int menu_maus_links ( void )
{
  if ( (m_x>83)&&(m_x<237)&&(m_y>99)&&(m_y<109) )    // neues Spiel beginnen
  {
     m_back_restore();
     write(109, 103, "neues spiel beginnen", 93);
     button_down(83, 100, 154, "neues spiel beginnen"); wait_retrace(); cpy2screen();
     while ( m_taste == 1 ) { maus_pos(); maus_show(); } delay(70);
     button_up(83, 100, 154, "neues spiel beginnen");
     m_back_save(); m_place();
     wait_retrace(); cpy2screen(); clr_screen();
     Init_Spiel(); Spiel();
     return 1;
  }
  if ( (m_x>107)&&(m_x<211)&&(m_y>175)&&(m_y<185) )
  {
     m_back_restore();
     write(124, 178, "spiel beenden", 93);
     button_down(107, 175, 105, "spiel beenden"); wait_retrace(); cpy2screen();
     while ( m_taste == 1 ) { maus_pos(); maus_show(); } delay(70);
     button_up(107, 175, 105, "spiel beenden"); 
     m_back_save(); m_place(); 
     wait_retrace(); cpy2screen();
     set_fade_out(181, 255); set_fade_out(0, 180);
     quit();
     return 0;
  }
  return 0;
}


int spiel_menu ( void )
{
  int i;

  m_back_restore();
  button_down(10, 180, 53, "menu"); wait_retrace(); cpy2screen();
  while ( m_taste == 1 ) { maus_pos(); } delay(70);
  button_up(10, 180, 53, "menu"); 
  m_back_save(); m_place();
  show_smenu(); i = go_smenu();
  LoadPalette("mr-005.dbl", pal); wait_vretrace(); SetPalette(pal); Set_Overscan_Color(0);
  if ( i == 2 ) Init_Spiel();
  if ( i == 1 ) return 1;                                     // 1 = ende
  if ( i == 0 ) return 0;
  return 0;
}


void button_down ( int x, int y, int lang, char *msg )
{
  int i, j;

  screen_refresh= 1;

  for ( i=y+1; i<y+10; i++ )
  {
    for ( j=x; j<x+lang-2; j++ ) vsetpix(j, i, 245);
  }

  i = (strlen(msg))*5; j = (lang-i)/2;
  write(x+j, y+3, msg, 254);
}

void button_up ( int x, int y, int lang, char *msg )
{
  int i, j;

  screen_refresh= 1;

  for ( i=(x-1); i<(x+lang-1); i++ ) vsetpix(i, y, 247);
  for ( i=(x-1); i<(x+lang-1); i++ ) vsetpix(i, y+10, 247);
  for ( i=y+1; i<y+11; i++ ) vsetpix(x-1, i, 247);
  for ( i=y; i<y+10; i++ ) vsetpix(x+lang-2, i, 247);
  for ( i=y+1; i<y+10; i++ )
  {
    for ( j=x; j<x+lang-2; j++ ) vsetpix(j, i, 246);
  }

  i = (strlen(msg))*5; j = (lang-i)/2;
  write(x+j, y+3, msg, 254);
}


void draw_box ( int x, int y, int x1, int y1, byte color )
{
  int i;

  for ( i=x; i<=x1; i++ ) { vsetpix(i, y, color); vsetpix(i, y1, color); }
  for ( i=y; i<=y1; i++ ) { vsetpix(x, i, color); vsetpix(x1, i, color); }
}

void fill_box ( int x, int y, int x1, int y1, byte color )
{
  int i, j;

  for ( i=y; i<=y1; i++ )
  {
    for ( j=x; j<=x1; j++ ) vsetpix(j, i, color);
  }
}

void button_punch ( int x, int y, int lang, char *msg )
{
  m_back_restore();
  button_down(x, y, lang, msg);
  m_back_save(); wait_retrace(); cpy2screen();
  while ( m_taste == 1 ) { maus_pos(); maus_show(); } delay(70);
  m_back_restore();
  button_up(x, y, lang, msg); m_back_save(); maus_show();
  wait_retrace(); cpy2screen(); delay(70);
  m_taste= 0;
}


/****************************************************************************/
/* "Erschafft" einen neuen Mann.                                            */
/* ------------------------------------------------------------------------ */
/* Parameter: globale Koordinaten und das momentane Aussehen.               */
/****************************************************************************/
int MannInsert ( int ax, int ay, BYTE shape )
{

  MannAnzahl++;
  MannListe[MannAnzahl].del     = 0;
  MannListe[MannAnzahl].x       = ax-(f_x*20);
  MannListe[MannAnzahl].y       = ay-(f_y*20);
  MannListe[MannAnzahl].x1      = ax-(f_x*20);
  MannListe[MannAnzahl].y1      = ay-(f_y*20);
  MannListe[MannAnzahl].ax      = ax;
  MannListe[MannAnzahl].ay      = ay;
  MannListe[MannAnzahl].dx      = ax;
  MannListe[MannAnzahl].dy      = ay;
  MannListe[MannAnzahl].dx1     = ax;
  MannListe[MannAnzahl].dy1     = ay;
  MannListe[MannAnzahl].shape   = shape;
  MannListe[MannAnzahl].energie = 15;
  MannListe[MannAnzahl].stop    = 0;
  MannListe[MannAnzahl].feldx   = ax/20;
  MannListe[MannAnzahl].feldy   = ay/20;
  AktListe[MannAnzahl]          = 0;

  return 1;
}

void MannDelete( BYTE index )
{
  int i;

  for ( i=index; i<MannAnzahl; i++ ) ML[i] = ML[i+1];     // index korrigieren
  memmove(&MannBack[index*400], &MannBack[(index+1)*400], (MannAnzahl-index)*400);
  MannAnzahl--;
}
  

/****************************************************************************/
/* "Erschafft" einen neuen Feind.                                           */
/* ------------------------------------------------------------------------ */
/* Parameter: globale Koordinaten und das momentane Aussehen.               */
/****************************************************************************/
int FeindInsert ( int ax, int ay, BYTE shape )
{

  FeindAnzahl++;
  FL[FeindAnzahl].del     = 0;
  FL[FeindAnzahl].x       = ax-(f_x*20);
  FL[FeindAnzahl].y       = ay-(f_y*20);
  FL[FeindAnzahl].x1      = ax-(f_x*20);
  FL[FeindAnzahl].y1      = ay-(f_y*20);
  FL[FeindAnzahl].ax      = ax;
  FL[FeindAnzahl].ay      = ay;
  FL[FeindAnzahl].dx      = ax;
  FL[FeindAnzahl].dy      = ay;
  FL[FeindAnzahl].dx1     = ax;
  FL[FeindAnzahl].dy1     = ay;
  FL[FeindAnzahl].shape   = shape;
  FL[FeindAnzahl].feldx   = ax/20;
  FL[FeindAnzahl].feldy   = ay/20;
  FL[FeindAnzahl].energie = 50;
  FL[FeindAnzahl].stop    = 0;

  return 1;
}

void FeindDelete( BYTE index )
{
  int i;

  for ( i=index; i<FeindAnzahl; i++ ) FL[i] = FL[i+1];
  memmove(&FeindBack[index*400], &FeindBack[(index+1)*400], (FeindAnzahl-index)*400);
  FeindAnzahl--;
}

void Mann_back_restore ( BYTE index )
{
  int i, j, h=index*400;

  for ( i=0; i<20; i++ )
  {
    for ( j=0; j<20; j++ )
    {
      if ( ((ML[index].x1+j)<Mrechts)&&((ML[index].x1+j)>Mlinks)&&((ML[index].y1+i)>Moben)&&((ML[index].y1+i)<Munten) )
      {
        /*if ( (MannBack[h]>110)&&(MannBack[h]<96) )*/ vsetpix(ML[index].x1+j, ML[index].y1+i, MannBack[h]);
      }
      h++;
    }
  }

}

void Mann_set ( BYTE index )
{
  int i, j, h=index*400, k=ML[index].shape*400;

  for ( i=0; i<20; i++ )
  {
    for ( j=0; j<20; j++ )
    {
      if ( ((ML[index].x+j)<Mrechts)&&((ML[index].x+j)>Mlinks)&&((ML[index].y+i)>Moben)&&((ML[index].y+i)<Munten) )
      {
        MannBack[h] = vgetpix( ML[index].x+j, ML[index].y+i);
        if ( ((MannData[k]>5)&&(MannBack[h]<96)) ) vsetpix( ML[index].x+j, ML[index].y+i, MannData[k]); 
      }
    h++; k++;
    }
  }
}

void Feind_back_restore ( BYTE index )
{
  int i, j, h=index*400;

  for ( i=0; i<20; i++ )
  {
    for ( j=0; j<20; j++ )
    {
      if ( ((FL[index].x1+j)<Mrechts)&&((FL[index].x1+j)>Mlinks)&&((FL[index].y1+i)>Moben)&&((FL[index].y1+i)<Munten) )
        vsetpix(FL[index].x1+j, FL[index].y1+i, FeindBack[h]);
      h++;
    }
  }

}

void Feind_set ( BYTE index )
{
  int i, j, h=index*400, k=FL[index].shape*400;

  for ( i=0; i<20; i++ )
  {
    for ( j=0; j<20; j++ )
    {
      if ( ((FL[index].x1+j)<Mrechts)&&((FL[index].x1+j)>Mlinks)&&((FL[index].y1+i)>Moben)&&((FL[index].y1+i)<Munten) )
      {
        FeindBack[h] = vgetpix( FL[index].x+j, FL[index].y+i);
        if ( ((MannData[k]>5)&&(FeindBack[h]<96)) ) vsetpix( FL[index].x+j, FL[index].y+i, MannData[k]); 
      }
    h++; k++;
    }
  }
}

void Mann_akt_set ( BYTE index )
{
  int i, j, h=index*400, k=ML[index].shape*400;

  for ( i=0; i<20; i++ )
  {
    for ( j=0; j<20; j++ )
    {
      if ( ((ML[index].x+j)<Mrechts)&&((ML[index].x+j)>Mlinks)&&((ML[index].y+i)>Moben)&&((ML[index].y+i)<Munten) )
      {
        MannBack[h] = vgetpix( ML[index].x+j, ML[index].y+i);
        if ( ((MannData[k]>5)&&(MannBack[h]<96)) ) vsetpix( ML[index].x+j, ML[index].y+i, MannData[k]); 
      }
    h++; k++;
    }
  }
  //---------------------------- Y-Werte ------------------------------
  for ( i= 2; i< 6; i++ ) if ( ((ML[index].x+i)<Mrechts)&&((ML[index].x+i)>Mlinks)&&((ML[index].y+ 1)>Moben)&&((ML[index].y+ 1)<Munten) ) vsetpix(ML[index].x+i, ML[index].y+1,  254);
  for ( i=14; i<18; i++ ) if ( ((ML[index].x+i)<Mrechts)&&((ML[index].x+i)>Mlinks)&&((ML[index].y+ 1)>Moben)&&((ML[index].y+ 1)<Munten) ) vsetpix(ML[index].x+i, ML[index].y+1,  254);
  for ( i= 2; i< 6; i++ ) if ( ((ML[index].x+i)<Mrechts)&&((ML[index].x+i)>Mlinks)&&((ML[index].y+15)>Moben)&&((ML[index].y+15)<Munten) ) vsetpix(ML[index].x+i, ML[index].y+15, 254);
  for ( i=14; i<18; i++ ) if ( ((ML[index].x+i)<Mrechts)&&((ML[index].x+i)>Mlinks)&&((ML[index].y+15)>Moben)&&((ML[index].y+15)<Munten) ) vsetpix(ML[index].x+i, ML[index].y+15, 254);
  //---------------------------- X-Werte ------------------------------
  for ( i= 2; i< 6; i++ ) if ( ((ML[index].x+ 2)<Mrechts)&&((ML[index].x+ 2)>Mlinks)&&((ML[index].y+i)>Moben)&&((ML[index].y+i)<Munten) ) vsetpix(ML[index].x+2,  ML[index].y+i,  254);
  for ( i=12; i<16; i++ ) if ( ((ML[index].x+ 2)<Mrechts)&&((ML[index].x+ 2)>Mlinks)&&((ML[index].y+i)>Moben)&&((ML[index].y+i)<Munten) ) vsetpix(ML[index].x+2,  ML[index].y+i,  254);
  for ( i= 2; i< 6; i++ ) if ( ((ML[index].x+17)<Mrechts)&&((ML[index].x+17)>Mlinks)&&((ML[index].y+i)>Moben)&&((ML[index].y+i)<Munten) ) vsetpix(ML[index].x+17, ML[index].y+i,  254);
  for ( i=12; i<16; i++ ) if ( ((ML[index].x+17)<Mrechts)&&((ML[index].x+17)>Mlinks)&&((ML[index].y+i)>Moben)&&((ML[index].y+i)<Munten) ) vsetpix(ML[index].x+17, ML[index].y+i,  254);
}

void Mann_compute ( BYTE index )
{
  int i, j;
  BYTE links=0, rechts=0;

  if ( MannListe[index].del >= mann_del )// Ist der Mann berhaupt an der Reihe
  {
    MLi.del = 0;
    MF[(MLi.feldy)][(MLi.feldx)] = index+1; 
    if ( MLi.energie <= 0 )
    {
       MF[MLi.feldy][MLi.feldx] = 0;
       Mann_back_restore(index); MannDelete(index); return;
    }
//------------------------------ Nach RECHTS ---------------------------------------------------------------------
    if ( MLi.ax < MLi.dx )
    {
      MLi.ax+=1; MLi.x+=1;
      if ( MLi.shape < R_ANFANG+MANN_DIV ) MLi.shape = R_ANFANG+MANN_DIV;
      if ( MLi.shape > R_ANFANG+MANN_DIV+R_LANG ) MLi.shape = R_ANFANG+MANN_DIV;
      MLi.shape++; rechts= 1; MoveListe[index] = 1;
    }
//------------------------------ Nach LINKS ---------------------------------
    if ( MLi.ax > MLi.dx )
    {
      MLi.ax-=1; MLi.x-=1;
      if ( MLi.shape > L_ANFANG+MANN_DIV+L_LANG ) MLi.shape = L_ANFANG+MANN_DIV;
      MLi.shape++; links= 1; MoveListe[index] = 1;
    }
//------------------------------ Nach UNTEN ---------------------------------
    if ( MLi.ay < MLi.dy )
    {
      MLi.ay+=1; MLi.y+=1;
      if ( MLi.shape < U_ANFANG+MANN_DIV ) MLi.shape = U_ANFANG+MANN_DIV;
      if ( MLi.shape > U_ANFANG+MANN_DIV+U_LANG ) MLi.shape = U_ANFANG+MANN_DIV;
      MLi.shape++; MoveListe[index] = 1;
    }
//------------------------------ Nach OBEN ----------------------------------
    if ( MLi.ay > MLi.dy )
    {
      MLi.ay-=1; MLi.y-=1;
      if ( MLi.shape < O_ANFANG+MANN_DIV ) MLi.shape = O_ANFANG+MANN_DIV;
      if ( MLi.shape > O_ANFANG+MANN_DIV+O_LANG ) MLi.shape = O_ANFANG+MANN_DIV;
      MLi.shape++; MoveListe[index] = 1;
    }
//---------------------------- Sonstiges ------------------------------------
    if ( (!MoveListe[index])&&(ML[index].shape>0) )
    {
      if ( MLi.shape<R_ANFANG+MANN_DIV ) MLi.shape=L_ANFANG+MANN_DIV;
      if ( MLi.shape>R_ANFANG+MANN_DIV ) MLi.shape=R_ANFANG+MANN_DIV;
      MoveListe[index]= 0;
    }
    if ( MLi.feldx != MLi.ax/20 )              // alte X-Pos. im Feld lschen
    {
       MannFeld[ML[index].feldy][MLi.feldx] = 0;
       MLi.feldx = MLi.ax/20;
    }
    if ( MLi.feldy != MLi.ay/20 )              // alte Y-Pos. im Feld lschen
    {
       MannFeld[MLi.feldy][MLi.feldx] = 0;
       MLi.feldy = MLi.ay/20;
    }

  }
  if ( (m_x>MLi.x-15)&&(m_x<MLi.x+15)&&(m_y>MLi.y-15)&&(m_y<MLi.y+15)&&(!AktListe[index]) )
     m_show_image=7;
  
//----------------------- Kommt immer dran -----------------------------------
  MLi.del++;
  for ( i=1; i<6; i++)
  {
    if ( (j=MF[MLi.feldy][MLi.feldx-i]) > 199 )
    {
       j = j-200;  Mann_Atack_left(index, MLi.ax-FL[j].ax-15);
       if ( MLi.del == 1 ) FL[j].energie--;
       return;
    }
  } // for
  for ( i=1; i<6; i++)
  {
    if ( (j=MF[MLi.feldy][MLi.feldx+i]) > 199 )
    {
       j = j-200;  Mann_Atack_right(index, FL[j].ax-MLi.ax-5);
       if ( MLi.del == 1 ) FL[j].energie--;
       return;
    }
  } // for

}



void Feind_compute ( BYTE index )
{
  int i;
  BYTE links=0, rechts=0;

  if ( FL[index].del >= mann_del )    // Ist der Mann berhaupt an der Reihe
  {
    FL[index].del = 0;
    MF[(FL[index].ay/20)][(FL[index].ax/20)] = index+200;
    if ( FLi.energie <= 0 )
    {
       MF[FLi.feldy][FLi.feldx] = 0;
       Feind_back_restore(index); FeindDelete(index); return;
    }
//---------------------------------------------------------------------------

    if ( FL[index].stop ) return;
//------------------------------ Nach RECHTS --------------------------------
    if ( FL[index].ax < ML[index].ax )
    {
      FL[index].ax+=1; FL[index].x+=1;
      if ( FL[index].shape < R_ANFANG ) FL[index].shape = R_ANFANG;
      if ( FL[index].shape > R_ANFANG+R_LANG ) FL[index].shape = R_ANFANG;
      FL[index].shape++; rechts= 1; MoveListe[200+index] = 1;
    }
//------------------------------ Nach LINKS ---------------------------------
    if ( FL[index].ax > ML[index].ax )
    {
      FL[index].ax-=1; FL[index].x-=1;
      if ( FL[index].shape > L_ANFANG+L_LANG ) FL[index].shape = L_ANFANG;
      FL[index].shape++; links= 1; MoveListe[200+index] = 1;
    }
//------------------------------ Nach UNTEN ---------------------------------
    if ( FL[index].ay < ML[index].ay )
    {
      FL[index].ay+=1; FL[index].y+=1;
      if ( FL[index].shape < U_ANFANG ) FL[index].shape = U_ANFANG;
      if ( FL[index].shape > U_ANFANG+U_LANG ) FL[index].shape = U_ANFANG;
      FL[index].shape++; MoveListe[200+index] = 1;
    }
//------------------------------ Nach OBEN ----------------------------------
    if ( FL[index].ay > ML[index].ay )
    {
      FL[index].ay-=1; FL[index].y-=1;
      if ( FL[index].shape < O_ANFANG ) FL[index].shape = O_ANFANG;
      if ( FL[index].shape > O_ANFANG+O_LANG ) FL[index].shape = O_ANFANG;
      FL[index].shape++; MoveListe[200+index] = 1;
    }

//----------------------------- Sonstiges ------------------------------------
    if ( (!MoveListe[200+index])&&(FL[index].shape>0) )
    {
      if ( FL[index].shape<R_ANFANG ) FL[index].shape=L_ANFANG;
      if ( FL[index].shape>R_ANFANG ) FL[index].shape=R_ANFANG;
      MoveListe[200+index]= 1;
    }

    if ( (FL[index].x>=ML[index].x)&&(FL[index].x<=ML[index].x+20)&&(FL[index].y>=ML[index].y)&&(FL[index].y<=ML[index].y+20) ) ML[index].energie--;
    if ( FL[index].feldx != FL[index].ax/20 )
    {
       MF[FL[index].feldy][FL[index].feldx] = 0;
       FL[index].feldx = FL[index].ax/20;
    }
    if ( FL[index].feldy != FL[index].ay/20 )
    {
       MF[FL[index].feldy][FL[index].feldx] = 0;
       FL[index].feldy = FL[index].ay/20;
    }
  }

  if ( (m_x>FL[index].x-15)&&(m_x<FL[index].x+15)&&(m_y>FL[index].y-15)&&(m_y<FL[index].y+15)&&(go) )
     atack= 1;
  
  FL[index].del++;
}


void clr_screen ( void )
{
  memset(Screen, 0, 64000);
}


void show_smenu( void )
{
  set_pal_out(0, 244, 80);

  button_up(140, 65, 120, "spiel speichern");
  button_up(140, 88, 120, "spiel laden"); 
  button_up(140,111, 120, "einstellungen"); 
  button_up(110,144, 60, "ende"); 
  button_up(220,144, 60, "weiter"); 
  wait_retrace(); cpy2screen();
}

int go_smenu ( void )
{
  char c;

  while ( m_taste != 7 )                                  // sinnlose Abfrage
  {
    m_show_image= 1; maus_pos(); maus_show();

    if ( m_taste == 1 )
    {
      if ( (m_x>220)&&(m_x<280)&&(m_y>144)&&(m_y<155) )             // weiter
      {
        button_punch(220,144, 60, "weiter"); Landschaft(f_x, f_y); return 0;
      }
      if ( (m_x>110)&&(m_x<170)&&(m_y>144)&&(m_y<155) )               // ende
      {
        button_punch(110,144, 60, "ende"); return 1;
      }
      if ( (m_x>140)&&(m_x<260)&&(m_y>65)&&(m_y<76) )            // speichern
      {
        button_punch(140, 65, 120, "spiel speichern");  
        save_game("savegame\0"); Landschaft(f_x, f_y); return 0;
      }
      if ( (m_x>140)&&(m_x<260)&&(m_y>88)&&(m_y<99) )                // laden
      {
        load_game(); button_punch(140, 88, 120, "spiel laden"); Landschaft(f_x, f_y); 
        return 2;
      }

    }
    if ( kbhit() )
    {
      c = getch();
      if ( c == 27 )
      {
        button_down(220,144, 60, "weiter"); wait_retrace(); cpy2screen(); delay(70);
        button_up(220,144, 60, "weiter"); wait_retrace(); cpy2screen(); delay(70);
        Landschaft(f_x, f_y); return 0;
      }
    } 
    if ( screen_refresh ) { wait_retrace(); cpy2screen(); }
  }
  return 0;
}

void radar ( void )
{
  int i, j;

  fill_box(Radar_x+1, Radar_y+1, Radar_x1-2, Radar_y1, 246);

  draw_box(((f_x*50)/x_lang)+Radar_x+1, ((f_y*50)/y_breit)+Radar_y+1, (((f_x+16)*50)/x_lang)+Radar_x+1, (((f_y+10)*50)/y_breit)+Radar_y+1, 254);

  for (i=0; i<=y_breit; i++)
  {
    for (j=0; j<=x_lang; j++)
    {
      if ( MannFeld[i][j] > 0 )
      {
        if ( MannFeld[i][j] <= 200 ) vsetpix(((j*50)/x_lang)+Radar_x+1, ((i*50)/y_breit)+Radar_y+1, 252);
        else vsetpix(((j*50)/x_lang)+Radar_x+1, ((i*50)/y_breit)+Radar_y+1, 97);
      }
    }
  }
  screen_refresh = 1;
}

void view_place ( void )
{
  int i, j;

  draw_box(vx-1, vy-1, vx+80, vy+60, 247);

  for (i=view_y; i<view_y+VIEW_BREIT; i++)
  {
    for (j=view_x; j<view_x+VIEW_LANG; j++) put_sprite(vx+((j-view_x)*20), vy+((i-view_y)*20), Feld[i][j]*400);
  }

  if ( MannAnzahl > -1 )
  {
    for ( i=0; i<MannAnzahl+1; i++ )
    {
      VMann_set(i);
    }
  }
  if ( FeindAnzahl > -1 )
  {
    for ( i=0; i<FeindAnzahl+1; i++ )
    {
      VFeind_set(i);
    }
  } 
}
  
void VMann_back_restore ( BYTE index )
{
  int i, j, h=index*400;

  for ( i=0; i<20; i++ )
  {
    for ( j=0; j<20; j++ )
    {
      if ( ((ML[index].ax1+j)<((view_x*20)+80))&&((ML[index].ax1+j)>=(view_x*20))&&((ML[index].ay1+i)>=(view_y*20))&&((ML[index].ay1+i)<((view_y*20)+60)) )
      {
        vsetpix(((ML[index].ax1+j)-(view_x*20))+vx, ((ML[index].ay1+i)-(view_y*20))+vy, MannBack[h]);
      }
      h++;
    }
  }

}

void VMann_set ( BYTE index )
{
  int i, j, h=index*400, k=ML[index].shape*400;

  for ( i=0; i<20; i++ )
  {
    for ( j=0; j<20; j++ )
    {
      if ( ((ML[index].ax+j)<((view_x*20)+80))&&((ML[index].ax+j)>=(view_x*20))&&((ML[index].ay+i)>=(view_y*20))&&((ML[index].ay+i)<((view_y*20)+60)) )
      {
        MannBack[h] = vgetpix( ((ML[index].ax+j)-(view_x*20))+vx, ((ML[index].ay+i)-(view_y*20))+vy);
        if ( ((MannData[k]>5)&&(MannBack[h]<38)) ) vsetpix(((ML[index].ax+j)-(view_x*20))+vx, ((ML[index].ay+i)-(view_y*20))+vy, MannData[k]); 
      }
    h++; k++;
    }
  }
}

void VFeind_back_restore ( BYTE index )
{
  int i, j, h=index*400;

  for ( i=0; i<20; i++ )
  {
    for ( j=0; j<20; j++ )
    {
      if ( ((FL[index].ax1+j)<((view_x*20)+80))&&((FL[index].ax1+j)>=(view_x*20))&&((FL[index].ay1+i)>=(view_y*20))&&((FL[index].ay1+i)<((view_y*20)+60)) )
        vsetpix(((FL[index].ax1+j)-(view_x*20))+vx, ((FL[index].ay1+i)-(view_y*20))+vy, FeindBack[h]);
      h++;
    }
  }

}

void VFeind_set ( BYTE index )
{
  int i, j, h=index*400, k=FL[index].shape*400;

  for ( i=0; i<20; i++ )
  {
    for ( j=0; j<20; j++ )
    {
      if ( ((FL[index].ax+j)<((view_x*20)+80))&&((FL[index].ax+j)>=(view_x*20))&&((FL[index].ay+i)>=(view_y*20))&&((FL[index].ay+i)<((view_y*20)+60)) )
      {
        FeindBack[h] = vgetpix( ((FL[index].ax+j)-(view_x*20))+vx, ((FL[index].ay+i)-(view_y*20))+vy);
        if ( ((MannData[k]>5)&&(FeindBack[h]<96)) ) vsetpix(((FL[index].ax+j)-(view_x*20))+vx, ((FL[index].ay+i)-(view_y*20))+vy, MannData[k]); 
      }
    h++; k++;
    }
  }
}

void Mann_Atack_left ( int index, int l )
{
  int lang=2, i;

  MLi.shape = L_ANFANG+MANN_DIV;                  // in Kampfposition begeben

  setpix(MLi.x+2, MLi.y+6,  244);
  setpix(MLi.x+1, MLi.y+7,  244); setpix(MLi.x  , MLi.y+7,  244);
  setpix(MLi.x-1, MLi.y+8,  244);
  setpix(MLi.x+2, MLi.y+10, 244); setpix(MLi.x+1,   MLi.y+10, 244);
  setpix(MLi.x  , MLi.y+9,  244); 

  i = rand() % 2;

  if ( i == 0 )
  {
    while ( lang < l )
    {
      setpix(MLi.x-lang++, MLi.y+8, 244); setpix(MLi.x-lang++, MLi.y+8, 244);
      setpix(MLi.x-lang++, MLi.y+9, 244); setpix(MLi.x-lang++, MLi.y+9, 244); setpix(MLi.x-lang++, MLi.y+9, 244);
      setpix(MLi.x-lang++, MLi.y+8, 244); setpix(MLi.x-lang++, MLi.y+8, 244);
      setpix(MLi.x-lang++, MLi.y+7, 244); setpix(MLi.x-lang++, MLi.y+7, 244); setpix(MLi.x-lang++, MLi.y+7, 244);
      setpix(MLi.x-lang++, MLi.y+8, 244);
    }
  }
  if ( i == 1 )
  {
    while ( lang < l )
    {
      setpix(MLi.x-lang++, MLi.y+9, 248); setpix(MLi.x-lang++, MLi.y+9, 248); setpix(MLi.x-lang++, MLi.y+9, 248);
      setpix(MLi.x-lang++, MLi.y+8, 248);
      setpix(MLi.x-lang++, MLi.y+9, 248);
      setpix(MLi.x-lang++, MLi.y+10, 248); setpix(MLi.x-lang++, MLi.y+10, 248); setpix(MLi.x-lang++, MLi.y+10, 248);
      setpix(MLi.x-lang++, MLi.y+9, 248); setpix(MLi.x-lang++, MLi.y+9, 248); setpix(MLi.x-lang++, MLi.y+9, 248);
      setpix(MLi.x-lang++, MLi.y+8, 248); setpix(MLi.x-lang++, MLi.y+8, 248);
    }
  }

  screen_refresh= 1;
}

void Mann_Atack_right ( int index, int l )
{
  int lang=21, i, j, k;

  MLi.shape = R_ANFANG+MANN_DIV;                  // in Kampfposition begeben

  setpix(MLi.x+17, MLi.y+6,  244);
  setpix(MLi.x+18, MLi.y+7,  244); setpix(MLi.x+19, MLi.y+7,  244);
  setpix(MLi.x+20, MLi.y+8,  244);
  setpix(MLi.x+17, MLi.y+10, 244); setpix(MLi.x+18, MLi.y+10, 244);
  setpix(MLi.x+19, MLi.y+9,  244); 

  i = rand() % 2;

  if ( i == 0 )
  {
    while ( lang < l )
    {
      setpix(MLi.x+lang++, MLi.y+8, 244); setpix(MLi.x+lang++, MLi.y+8, 244);
      setpix(MLi.x+lang++, MLi.y+9, 244); setpix(MLi.x+lang++, MLi.y+9, 244); setpix(MLi.x+lang++, MLi.y+9, 244);
      setpix(MLi.x+lang++, MLi.y+8, 244); setpix(MLi.x+lang++, MLi.y+8, 244);
      setpix(MLi.x+lang++, MLi.y+7, 244); setpix(MLi.x+lang++, MLi.y+7, 244); setpix(MLi.x+lang++, MLi.y+7, 244);
      setpix(MLi.x+lang++, MLi.y+8, 244);
    }
  }
  if ( i == 1 )
  {
    while ( lang < l )
    {
      setpix(MLi.x+lang++, MLi.y+9, 248); setpix(MLi.x+lang++, MLi.y+9, 248); setpix(MLi.x+lang++, MLi.y+9, 248);
      setpix(MLi.x+lang++, MLi.y+8, 248);
      setpix(MLi.x+lang++, MLi.y+9, 248);
      setpix(MLi.x+lang++, MLi.y+10, 248); setpix(MLi.x+lang++, MLi.y+10, 248); setpix(MLi.x+lang++, MLi.y+10, 248);
      setpix(MLi.x+lang++, MLi.y+9, 248); setpix(MLi.x+lang++, MLi.y+9, 248); setpix(MLi.x+lang++, MLi.y+9, 248);
      setpix(MLi.x+lang++, MLi.y+8, 248); setpix(MLi.x+lang++, MLi.y+8, 248);
    }
  }

  screen_refresh= 1;
}


