//
// vardefs.h
//
#define Mlinks          -1
#define Mrechts         640
#define Moben           -1
#define Munten          400
#define EINHEITEN       10


byte *TerrainData;                                    // Daten fr Landschaft
short Karte[100][100];                                 // Landschaftsstruktur
POS YKarte[100][100], XKarte[100][100];     // Enthlt Infos ber Hindernisse
byte *Terrain;                            // Zeiger auf entkompremierte Karte
short FeldX, FeldY;                              // Gre der geladenen Karte                      
short ScrollX, ScrollY;   // Koordinaten, wie weit die Karte verschoben wurde

// Bentigte Var. fr das Scrollen mit der rechten Maustaste
short RightScrollX=0, RightScrollY=0, RightScroll=0, RightScrolled=0;
short ScrollSpeed = 4;
byte ScrollDir=0, NachScroll=0, Scrolled=0;

// Var. fr den aufziehbaren Rahmen
byte Rahmen=0;
short RahmenX, RahmenY;

// Alles fr die ani. Landschaft
#define ANICOUNT        100
ANITER Animated[ANICOUNT];                      // Daten fr anim. Landschaft
short AniAnz=0;

// Var. fr die Leute
#define LMAX            100
byte *LeuteData;
MANN Leute[LMAX];                                     // Liste fr alle Leute
short MAnz=0, FAnz=0;
short NextFree=0;

// Geschwindigkeitsregelung
short GameSpeed=8, GameDel=0;


// MausVariablen
short m_image_start=0; m_image_end=0;
byte  MouseImage=0; // wird gesetzt, wenn der Mauszeiger eine andere Form erhlt
byte  MouseMoved=0;               // wird gesetzt, wenn die Maus bewegt wurde
byte  MouseDelete=0;                   // wenn mouse_code gelscht werden soll

// Datenbank fr die Fhigkeiten der einzelnen Einheiten
ABILITY Data[EINHEITEN];

// Hindernis def.
#define Hindernis       96

// Fr die Mnner, um richtig zu laufen
short O_ANFANG, U_ANFANG, R_ANFANG, L_ANFANG, MANN_DIV, O_LANG,
      U_LANG, R_LANG, L_LANG,
      LO_ANFANG, LU_ANFANG, RO_ANFANG, RU_ANFANG, LO_LANG, LU_LANG, RO_LANG, RU_LANG,
      ANGRIF_L, ANGRIF_R, ANGRIF_O, ANGRIF_U,
      ANGRIF_LL, ANGRIF_RL, ANGRIF_OL, ANGRIF_UL,
      ANGRIF_LO, ANGRIF_LU, ANGRIF_RO, ANGRIF_RU,
      ANGRIF_LOL, ANGRIF_LUL, ANGRIF_ROL, ANGRIF_RUL,
      FL_ANFANG, FR_ANFANG, FO_ANFANG, FU_ANFANG,    
      S1_ANFANG, S1_LANG, S2_ANFANG, S2_LANG;

// Var. fr den Anfang neuer Sprites
int HELI_START;
int KAMPF_START;

// Diese Variablen sind fr den Editor-Abschnitt in diesem Programm
#define EDITLENGTH      10
byte edit=0;
short EditSelect = 0;
short PartSelect=0, SelectX=10, SelectY=10;


// Explosionen
#define EMAX            200
byte *ExploseData;
EXPLO Explose[EMAX];
short EAnz=0;
short ExploseNextFree=0;


// Laser
#define LASERMAX        100
LASER Laser[LASERMAX];
short LaserAnz=0;
short LaserNextFree=0;

